#include "avatar.h"

static MLV_Image *palette_peau = NULL;
static MLV_Image *palette_poils = NULL;
static MLV_Image *palette_yeux = NULL;
static MLV_Image *palette_haut = NULL;
static MLV_Image *palette_bas = NULL;
static MLV_Image *palette_pied = NULL;
static int file_tools_selection = FILE_TOOLS_NONE;
static int last_file_tools_selection = FILE_TOOLS_NONE;
static int was_init = 0;

void Avatar_Afficher_File_Tools(int x, int mx, int my, int width, int height)
{
	int value = 127;
	int bheight = height/20;
	int w;
	value = (file_tools_selection == FILE_TOOLS_QUIT)?(196):(127);
	MLV_draw_filled_rectangle(x, 0, width/5, bheight, MLV_rgba(value, value, value, 255));
	MLV_get_size_of_text("Quitter", &w, NULL);
	MLV_draw_text(x+width/10-w/2, 5, "Quitter", MLV_rgba(50, 50, 50, 255));
	value = (file_tools_selection == FILE_TOOLS_SAVE)?(196):(127);
	MLV_draw_filled_rectangle(x+width/5, 0, (width*2)/5, bheight, MLV_rgba(value, value, value, 255));
	MLV_get_size_of_text("Sauvegarder", &w, NULL);
	MLV_draw_text(x+(width*2)/5-w/2, 5, "Sauvegarder", MLV_rgba(50, 50, 50, 255));
	value = (file_tools_selection == FILE_TOOLS_LOAD)?(196):(127);
	MLV_draw_filled_rectangle(x+(width*3)/5, 0, (width*2)/5, bheight, MLV_rgba(value, value, value, 255));
	MLV_get_size_of_text("Charger", &w, NULL);
	MLV_draw_text(x+(width*4)/5-w/2, 5, "Charger", MLV_rgba(50, 50, 50, 255));
}

int Avatar_Action_File_Tools(int x, int mx, int my, int width, int height)
{
	if(my >= height/20 || mx >= x+width)
		file_tools_selection = FILE_TOOLS_NONE;
	else if(mx >= x && mx < x+width/5)
		file_tools_selection = FILE_TOOLS_QUIT;
	else if(mx >= x+width/5 && mx < x+(width*3)/5)
		file_tools_selection = FILE_TOOLS_SAVE;
	else if(mx >= x+(width*3)/5 && mx < x+width)
		file_tools_selection = FILE_TOOLS_LOAD;
	else
		file_tools_selection = FILE_TOOLS_NONE;
	if(file_tools_selection != last_file_tools_selection)
	{
		last_file_tools_selection = file_tools_selection;
		return 1;
	}
	return 0;
}

void Avatar_Afficher_Tools(int x, int width, int height)
{
	MLV_draw_filled_rectangle(x, 0, width+1, height, MLV_rgba(127, 127, 127, 255));
	if(palette_peau == NULL)
		palette_peau = MLV_Image_CreatePalette((width*4)/5, height/(AVATAR_NB_COLOR+1), 	
									MLV_rgba(242, 154, 121, 255),
									MLV_rgba(244, 158, 88, 255),
									MLV_rgba(37, 28, 20, 255),
									MLV_rgba(242, 215, 121, 255),
									MLV_rgba(255, 255, 255, 255));
	if(palette_poils == NULL)
		palette_poils = MLV_Image_CreatePalette((width*4)/5, height/(AVATAR_NB_COLOR+1), 	
									MLV_rgba(255, 206, 42, 255),
									MLV_rgba(255, 135, 42, 255),
									MLV_rgba(0, 0, 0, 255),
									MLV_rgba(113, 50, 0, 255),
									MLV_rgba(173, 173, 173, 255));
	if(palette_yeux == NULL)
		palette_yeux = MLV_Image_CreatePalette((width*4)/5, height/(AVATAR_NB_COLOR+1), 	
									MLV_rgba(23, 182, 228, 255),
									MLV_rgba(34, 213, 42, 255),
									MLV_rgba(132, 42, 0, 255),
									MLV_rgba(50, 16, 0, 255),
									MLV_rgba(251, 206, 19, 255));
	if(palette_haut == NULL)
		palette_haut = MLV_Image_CreatePalette((width*4)/5, height/(AVATAR_NB_COLOR+1), 	
									MLV_rgba(31, 175, 52, 255),
									MLV_rgba(175, 31, 31, 255),
									MLV_rgba(0, 0, 0, 255),
									MLV_rgba(40, 108, 221, 255),
									MLV_rgba(255, 255, 255, 255));
	if(palette_bas == NULL)
		palette_bas = MLV_copy_image(palette_haut);
	if(palette_pied == NULL)
		palette_pied = MLV_Image_CreatePalette((width*4)/5, height/(AVATAR_NB_COLOR+1), 	
									MLV_rgba(221, 44, 44, 255),
									MLV_rgba(148, 76, 31, 255),
									MLV_rgba(0, 0, 0, 255),
									MLV_rgba(40, 108, 221, 255),
									MLV_rgba(255, 255, 255, 255));
	MLV_Image *palette[] = {palette_peau, palette_poils, palette_yeux, palette_haut, palette_bas, palette_pied};
	char *noms[] = {"Couleur peau", "Couleur poils", "Couleur yeux", "Couleur haut", "Couleur bas", "Couleur pieds"};
	int i;
	for(i = 0; i < AVATAR_NB_COLOR; i ++)
	{
		MLV_draw_text(x+2, 2+(height*i)/AVATAR_NB_COLOR, noms[i], MLV_rgba(50, 50, 50, 255));
		MLV_draw_image(palette[i], x+width/10, 15+(height*i)/AVATAR_NB_COLOR);
	}
}

int Avatar_Action_Tools(Avatar *ava, int x, int width, int height, int mx, int my)
{
	if(mx >= x+width/10 && mx < x-1+(width*9)/10)
	{
		int id = (my-15)/(height/AVATAR_NB_COLOR);
		if(my >= 15+((height/AVATAR_NB_COLOR)*id) && my < 15+((height/AVATAR_NB_COLOR)*id)+(height/(AVATAR_NB_COLOR+1)))
		{
			Color couleur;
			MLV_get_pixel(mx, my, &(couleur.r), &(couleur.g), &(couleur.b), &(couleur.a));
			couleur.a = 255;
			switch(id)
			{
				case AVATAR_COULEUR_PEAU:
				ava->couleur_peau = Color_To_MLV_Color(couleur);
				Corps_SetColor(CORPS_MAIN_D(ava->corps), ava->couleur_peau);
				Corps_SetColor(CORPS_MAIN_G(ava->corps), ava->couleur_peau);
				Corps_SetColor(CORPS_COU(ava->corps), ava->couleur_peau);
				return 1;
				case AVATAR_COULEUR_POILS:
				ava->couleur_poils = Color_To_MLV_Color(couleur);
				return 1;
				case AVATAR_COULEUR_YEUX:
				ava->couleur_yeux = Color_To_MLV_Color(couleur);
				return 1;
				case AVATAR_COULEUR_HAUT:
				Corps_SetColor(CORPS_BUSTE(ava->corps), Color_To_MLV_Color(couleur));
				return 1;
				case AVATAR_COULEUR_BAS:
				Corps_SetColor(CORPS_BASSIN(ava->corps), Color_To_MLV_Color(couleur));
				return 1;
				case AVATAR_COULEUR_PIED:
				Corps_SetColor(CORPS_PIED_D(ava->corps), Color_To_MLV_Color(couleur));
				Corps_SetColor(CORPS_PIED_G(ava->corps), Color_To_MLV_Color(couleur));
				return 1;
			}
		}
	}
	return 0;
}

void Avatar_Gest(Avatar *ava)
{
	int width = 800;
	int height = 600;
	MLV_change_window_size(width, height);
	MLV_disable_full_screen();
	Avatar_Init(ava, width/6, height/8, width/3, height/2);
	if(!was_init)
	{
		was_init = 1;
	}
	else
		Avatar_Load(ava, "media/tmp.avatar");
	int x, y;
	MLV_Mouse_button bouton;
	MLV_Button_state state;
	int need_refresh = 1;
	int cont = 1;
	MLV_Event event = MLV_NONE;
	while(cont && (event = MLV_get_event(NULL, NULL, NULL, NULL, NULL, &x, &y, &bouton, &state)) != MLV_KEY)
	{
		if(need_refresh)
		{
			MLV_clear_window(MLV_COLOR_BLACK);
			Avatar_Afficher(ava);
			Avatar_Afficher_Tools((width*2)/3, width/3, height);
			Avatar_Afficher_File_Tools(0, x, y, (width*2)/3, height);
			MLV_actualise_window();
			need_refresh = 0;
		}
		if(event == MLV_MOUSE_BUTTON && bouton == MLV_BUTTON_LEFT && state == MLV_RELEASED)
		{
			if(!Avatar_MakeSelection(ava, x, y))
			{
				switch(file_tools_selection)
				{
					case FILE_TOOLS_QUIT:
					cont = 0;
					break;
					case FILE_TOOLS_SAVE:
					{
						char *file_to = MyFile_ChargFile();
						Avatar_Save(ava, file_to);
						if(file_to != NULL)free(file_to);
					}
					need_refresh = 1;
					break;
					case FILE_TOOLS_LOAD:
					{
						char *file_to2 = MyFile_ChargFile();
						Avatar_Load(ava, file_to2);
					}
					need_refresh = 1;
					break;
					default:
					need_refresh |= Avatar_Action_Tools(ava, (width*2)/3, width/3, height, x, y);
					break;
				}
			}
		}
		else if(bouton == MLV_BUTTON_RIGHT && state == MLV_PRESSED)
			ava->choix_selection = ASI_None;
		else if(bouton == MLV_BUTTON_WHEELUP && state == MLV_PRESSED)
			need_refresh |= Avatar_Scale(ava, 5);
		else if(bouton == MLV_BUTTON_WHEELDOWN && state == MLV_PRESSED)
			need_refresh |= Avatar_Scale(ava, -5);
		if(!(need_refresh |= Avatar_Move(ava, x, y)))
			need_refresh |= Avatar_Action_File_Tools(0, x, y, (width*2)/3, height);
		
	}
	if(palette_peau != NULL)
		MLV_free_image(palette_peau);
	palette_peau = NULL;
	if(palette_poils != NULL)
		MLV_free_image(palette_poils);
	palette_poils = NULL;
	if(palette_yeux != NULL)
		MLV_free_image(palette_yeux);
	palette_yeux = NULL;
	if(palette_haut != NULL)
		MLV_free_image(palette_haut);
	palette_haut = NULL;
	if(palette_bas != NULL)
		MLV_free_image(palette_bas);
	palette_bas = NULL;
	if(palette_pied != NULL)
		MLV_free_image(palette_pied);
	palette_pied = NULL;
	Avatar_Save(ava, "media/tmp.avatar");
}

MLV_Image *MLV_Image_CreatePalette(int width, int height, MLV_Color topleft, MLV_Color topright, MLV_Color botright, MLV_Color botleft, MLV_Color center)
{
	MLV_Image *image = MLV_create_image(width, height);
	int i, j;
	int c_dist, m_dist = (int)sqrt(pow(((double)width)/2, 2)+pow(((double)height)/2, 2));
	for(i = 0; i < width; i ++)
	{
		for(j = 0; j < height; j ++)
		{
			c_dist = (int)sqrt(pow(((double)width)/2 - i, 2)+pow(((double)height)/2 - j, 2));
			MLV_set_pixel_on_image(i, j, MLV_Color_Mix(2, MLV_Color_Mix(2, MLV_Color_Mix(2, topleft, width-i, topright, i), height-j, MLV_Color_Mix(2, botleft, width-i, botright, i), j), c_dist, center, (m_dist-c_dist)/4), image);
		}
	}
	return image;
}
