#include "avatar_affichage.h"

void Cercle_Afficher(Cercle c, int add_x, int add_y, MLV_Color couleur)
{
	MLV_draw_filled_circle(c.centre.x+add_x, c.centre.y+add_y, c.rayon, couleur);
}

void Cercle_AfficherScaled(Cercle c, int add_x, int add_y, double scale, MLV_Color couleur)
{
	MLV_draw_filled_circle(c.centre.x+add_x, c.centre.y+add_y, (int)(c.rayon*scale), couleur);
}

void Visage_Afficher(Visage *vis, int add_x, int add_y, MLV_Color couleur)
{
	int *poly_x = (int*)malloc(2*VISAGE_NB_CERCLES*sizeof(int));
	int *poly_y = (int*)malloc(2*VISAGE_NB_CERCLES*sizeof(int));
	int i = 0;
	Point p1, p2;
	Visage *cur = vis;
	do
	{
		Cercle_Afficher(cur->cercle, add_x, add_y, couleur);
		Cercle_GetTangentes(cur->cercle, cur->next->cercle, NULL, &p1, NULL, &p2);
		poly_x[i] = p1.x+add_x;
		poly_y[i] = p1.y+add_y;
		poly_x[i+1] = p2.x+add_x;
		poly_y[i+1] = p2.y+add_y;
		i += 2;
		cur = cur->next;
	}while(cur != vis);
	MLV_draw_filled_polygon(poly_x, poly_y, 2*VISAGE_NB_CERCLES, couleur);
	free(poly_x);
	free(poly_y);
}

void Yeux_Afficher(Yeux *yeux, int add_x, int add_y, MLV_Color couleur)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	Point pa1, pa2, pb1, pb2;
	Yeux *cur = yeux;
	while(cur != NULL)
	{
		Cercle_Afficher(cur->cercle, add_x, add_y, MLV_COLOR_WHITE);
		if(cur->next != NULL)
		{
			if(Cercle_GetTangentes(cur->cercle, cur->next->cercle, &pa1, &pa2, &pb1, &pb2))
			{
				poly_x[0] = pa1.x+add_x;
				poly_x[1] = pb1.x+add_x;
				poly_x[2] = pb2.x+add_x;
				poly_x[3] = pa2.x+add_x;
				poly_y[0] = pa1.y+add_y;
				poly_y[1] = pb1.y+add_y;
				poly_y[2] = pb2.y+add_y;
				poly_y[3] = pa2.y+add_y;
				MLV_draw_filled_polygon(poly_x, poly_y, 4, MLV_COLOR_WHITE);
			}
		}
		cur = cur->next;
	}
	Cercle_Afficher(YEUX_MIDDLE(yeux)->cercle, add_x, add_y, MLV_COLOR_BLACK);
	Cercle_AfficherScaled(YEUX_MIDDLE(yeux)->cercle, add_x, add_y, 0.9, couleur);
	Cercle_AfficherScaled(YEUX_MIDDLE(yeux)->cercle, add_x, add_y, 0.5, MLV_COLOR_BLACK);
	MLV_draw_filled_circle(	YEUX_MIDDLE(yeux)->cercle.centre.x-(int)(YEUX_MIDDLE(yeux)->cercle.rayon*0.25)+add_x,
				YEUX_MIDDLE(yeux)->cercle.centre.y-(int)(YEUX_MIDDLE(yeux)->cercle.rayon*0.25)+add_y,
				(int)(YEUX_MIDDLE(yeux)->cercle.rayon*0.25),
				MLV_COLOR_WHITE);
	free(poly_x);
	free(poly_y);
}

void Yeux_Sourcils_Afficher(Yeux *sour, int add_x, int add_y, MLV_Color couleur)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	Point pa1, pa2, pb1, pb2;
	Yeux *cur = sour;
	while(cur != NULL)
	{
		if(cur != sour && cur->next != NULL)
			Cercle_Afficher(cur->cercle, add_x, add_y, couleur);
		if(cur->next != NULL)
		{
			if(Cercle_GetTangentes(cur->cercle, cur->next->cercle, &pa1, &pa2, &pb1, &pb2))
			{
				poly_x[0] = pa1.x+add_x;
				poly_x[1] = pb1.x+add_x;
				poly_x[2] = pb2.x+add_x;
				poly_x[3] = pa2.x+add_x;
				poly_y[0] = pa1.y+add_y;
				poly_y[1] = pb1.y+add_y;
				poly_y[2] = pb2.y+add_y;
				poly_y[3] = pa2.y+add_y;
				MLV_draw_filled_polygon(poly_x, poly_y, 4, couleur);
			}
		}
		cur = cur->next;
	}
	free(poly_x);
	free(poly_y);
}

void Yeux_Oreilles_Afficher(Yeux *sour, int add_x, int add_y, MLV_Color couleur)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	Point pa1, pa2, pb1, pb2;
	Yeux *cur = sour;
	while(cur != NULL)
	{
		Cercle_Afficher(cur->cercle, add_x, add_y, couleur);
		if(cur->next != NULL)
		{
			if(Cercle_GetTangentes(cur->cercle, cur->next->cercle, &pa1, &pa2, &pb1, &pb2))
			{
				poly_x[0] = pa1.x+add_x;
				poly_x[1] = pb1.x+add_x;
				poly_x[2] = pb2.x+add_x;
				poly_x[3] = pa2.x+add_x;
				poly_y[0] = pa1.y+add_y;
				poly_y[1] = pb1.y+add_y;
				poly_y[2] = pb2.y+add_y;
				poly_y[3] = pa2.y+add_y;
				MLV_draw_filled_polygon(poly_x, poly_y, 4, couleur);
			}
		}
		cur = cur->next;
	}
	free(poly_x);
	free(poly_y);
}

MLV_Color MLV_Color_teinte(MLV_Color couleur, int teinte)
{
	Uint8 r, g, b, a;
	MLV_convert_color_to_rgba(couleur, &r, &g, &b, &a);
	return MLV_rgba((r*teinte)/255, (g*teinte)/255, (b*teinte)/255, a);
}

void Yeux_Nez_Afficher(Yeux *nez, int add_x, int add_y, MLV_Color couleur)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	Point pa1, pa2, pb1, pb2;
	Yeux *cur = nez;
	while(cur != NULL)
	{
		Cercle_Afficher(cur->cercle, add_x, add_y, couleur);
		if(cur->next != NULL)
		{
			if(Cercle_GetTangentes(cur->cercle, cur->next->cercle, &pa1, &pa2, &pb1, &pb2))
			{
				poly_x[0] = pa1.x+add_x;
				poly_x[1] = pb1.x+add_x;
				poly_x[2] = pb2.x+add_x;
				poly_x[3] = pa2.x+add_x;
				poly_y[0] = pa1.y+add_y;
				poly_y[1] = pb1.y+add_y;
				poly_y[2] = pb2.y+add_y;
				poly_y[3] = pa2.y+add_y;
				MLV_draw_filled_polygon(poly_x, poly_y, 4, couleur);
			}
		}
		cur = cur->next;
	}
	MLV_draw_line(NEZ_GAUCHE(nez)->cercle.centre.x-(NEZ_GAUCHE(nez)->cercle.rayon/2)+add_x, NEZ_GAUCHE(nez)->cercle.centre.y-(NEZ_GAUCHE(nez)->cercle.rayon/4)+add_y, NEZ_GAUCHE(nez)->cercle.centre.x+(NEZ_GAUCHE(nez)->cercle.rayon/2)+add_x, NEZ_GAUCHE(nez)->cercle.centre.y+(NEZ_GAUCHE(nez)->cercle.rayon/4)+add_y, MLV_Color_teinte(couleur, 196));
	MLV_draw_line(NEZ_DROITE(nez)->cercle.centre.x+(NEZ_DROITE(nez)->cercle.rayon/2)+add_x, NEZ_DROITE(nez)->cercle.centre.y-(NEZ_DROITE(nez)->cercle.rayon/4)+add_y, NEZ_DROITE(nez)->cercle.centre.x-(NEZ_DROITE(nez)->cercle.rayon/2)+add_x, NEZ_DROITE(nez)->cercle.centre.y+(NEZ_DROITE(nez)->cercle.rayon/4)+add_y, MLV_Color_teinte(couleur, 196));
	free(poly_x);
	free(poly_y);
}

void Cheveux_Afficher(Cheveux *chev, int add_x, int add_y, MLV_Color couleur)
{
	Cheveux *cur = chev;
	int nb = 0;
	while(cur != NULL)
	{
		cur = cur->next;
		nb ++;
	}
	int *poly_x = (int*)malloc(nb*sizeof(int));
	int *poly_y = (int*)malloc(nb*sizeof(int));
	int i = 0;
	cur = chev;
	while(cur != NULL)
	{
		poly_x[i] = cur->centre.x+add_x;
		poly_y[i] = cur->centre.y+add_y;
		cur = cur->next;
		i ++;
	}
	MLV_draw_filled_polygon(poly_x, poly_y, nb, couleur);
	free(poly_x);
	free(poly_y);
}

void Cheveux_AfficherJoin(Cheveux *chev1, Cheveux *chev2, int join_rad, int add_x, int add_y, MLV_Color couleur)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	Cheveux *cur1 = chev1;
	Cheveux *cur2 = chev2;
	while(cur1 != NULL && cur2 != NULL && cur1->next != NULL && cur2->next != NULL)
	{
		if(abs(cur1->centre.x-cur2->centre.x) <= join_rad*2 && abs(cur1->next->centre.x-cur2->next->centre.x) <= join_rad*2)
		{
			poly_x[0] = cur1->centre.x+add_x;
			poly_y[0] = cur1->centre.y+add_y;
			poly_x[1] = cur1->next->centre.x+add_x;
			poly_y[1] = cur1->next->centre.y+add_y;
			poly_x[2] = cur2->next->centre.x+add_x;
			poly_y[2] = cur2->next->centre.y+add_y;
			poly_x[3] = cur2->centre.x+add_x;
			poly_y[3] = cur2->centre.y+add_y;
			MLV_draw_filled_polygon(poly_x, poly_y, 4, couleur);
		}
		cur1 = cur1->next;
		cur2 = cur2->next;
	}
	free(poly_x);
	free(poly_y);
}

void Corps_Afficher(Corps *corps, int add_x, int add_y)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	int i;
	Point pa1, pa2, pb1, pb2;
	Cercle par;
	for(i = 0; i < corps->nb_child; i ++)
	{
		Corps_Afficher(corps->child[i], corps->cercle.centre.x+add_x, corps->cercle.centre.y+add_y);
	}
	MLV_draw_filled_circle(corps->cercle.centre.x+add_x, corps->cercle.centre.y+add_y, corps->cercle.rayon, corps->couleur);
	if(corps->parent != NULL)
	{
		par = corps->parent->cercle;
		par.centre.x = 0;
		par.centre.y = 0;
		if(Cercle_GetTangentes(corps->cercle, par, &pa1, &pa2, &pb1, &pb2))
		{
			poly_x[0] = pa1.x+add_x;
			poly_x[1] = pb1.x+add_x;
			poly_x[2] = pb2.x+add_x;
			poly_x[3] = pa2.x+add_x;
			poly_y[0] = pa1.y+add_y;
			poly_y[1] = pb1.y+add_y;
			poly_y[2] = pb2.y+add_y;
			poly_y[3] = pa2.y+add_y;
			MLV_draw_filled_polygon(poly_x, poly_y, 4, corps->parent->couleur);
		}
	}
	
	free(poly_x);
	free(poly_y);
}

void Corps_AfficherRotate(Corps *corps, int add_x, int add_y, int add_rotate)
{
	int *poly_x = (int*)malloc(4*sizeof(int));
	int *poly_y = (int*)malloc(4*sizeof(int));
	int i;
	Point pa1, pa2, pb1, pb2;
	Cercle par;
	Cercle rotated = Cercle_ByAngle(corps->cercle, add_rotate+corps->rotate);
	for(i = 0; i < corps->nb_child; i ++)
	{
		Corps_AfficherRotate(corps->child[i], rotated.centre.x+add_x, rotated.centre.y+add_y, add_rotate+corps->rotate);
	}
	MLV_draw_filled_circle(rotated.centre.x+add_x, rotated.centre.y+add_y, rotated.rayon, corps->couleur);
	if(corps->parent != NULL)
	{
		par = corps->parent->cercle;
		par.centre.x = 0;
		par.centre.y = 0;
		if(Cercle_GetTangentes(rotated, par, &pa1, &pa2, &pb1, &pb2))
		{
			poly_x[0] = pa1.x+add_x;
			poly_x[1] = pb1.x+add_x;
			poly_x[2] = pb2.x+add_x;
			poly_x[3] = pa2.x+add_x;
			poly_y[0] = pa1.y+add_y;
			poly_y[1] = pb1.y+add_y;
			poly_y[2] = pb2.y+add_y;
			poly_y[3] = pa2.y+add_y;
			MLV_draw_filled_polygon(poly_x, poly_y, 4, corps->parent->couleur);
		}
	}
	
	free(poly_x);
	free(poly_y);
}

void Avatar_Afficher(Avatar *ava)
{
	if(ava->corps != NULL)
		Corps_Afficher(ava->corps, ava->corps->cercle.centre.x, ava->corps->cercle.centre.y);
	Visage_Afficher(ava->visage, ava->x, ava->y, ava->couleur_peau);
	Yeux_Oreilles_Afficher(ava->oreille_droite, ava->x, ava->y, ava->couleur_peau);
	Yeux_Oreilles_Afficher(ava->oreille_gauche, ava->x, ava->y, ava->couleur_peau);
	Yeux_Afficher(ava->oeil_droit, ava->x, ava->y, ava->couleur_yeux);
	Yeux_Afficher(ava->oeil_gauche, ava->x, ava->y, ava->couleur_yeux);
	Yeux_Sourcils_Afficher(ava->sourcil_droit, ava->x, ava->y, ava->couleur_poils);
	Yeux_Sourcils_Afficher(ava->sourcil_gauche, ava->x, ava->y, ava->couleur_poils);
	Yeux_Nez_Afficher(ava->nez, ava->x, ava->y, MLV_Color_teinte(ava->couleur_peau, 196));
	MLV_draw_line(ava->bouche.centre.x-ava->bouche.rayon+ava->x, ava->bouche.centre.y+ava->y, ava->bouche.centre.x+ava->bouche.rayon+ava->x, ava->bouche.centre.y+ava->y, MLV_Color_teinte(ava->couleur_peau, 127));
	Cheveux_Afficher(ava->cheveux_droite, ava->x, ava->y, ava->couleur_poils);
	Cheveux_Afficher(ava->cheveux_gauche, ava->x, ava->y, ava->couleur_poils);
	Cheveux_AfficherJoin(ava->cheveux_droite, ava->cheveux_gauche, ava->visage_size/100, ava->x, ava->y, ava->couleur_poils);
}

void Avatar_AfficherPerso(Avatar *ava)
{
	if(ava != NULL)
	{
		if(ava->corps != NULL)
			Corps_AfficherRotate(ava->corps, 0, 0, 0);
		if(ava->modified && ava->tete != NULL)
		{
			MLV_free_image(ava->tete);
			ava->tete = NULL;
			ava->modified = 0;
		}
		if(ava->tete == NULL)
			ava->tete = Avatar_Tete(ava);
		MLV_draw_image(ava->tete, ava->x-MLV_get_image_width(ava->tete)/2, ava->y-MLV_get_image_height(ava->tete)/2);
	}
}

MLV_Image *Avatar_Tete(Avatar *ava)
{
	MLV_Image *image = MLV_create_image(ava->visage_size*2, ava->visage_size*2);
	MLV_save_screen();
	MLV_Color fond;
	fond = MLV_rgba(255, 0, 255, 255);
	if(fond == ava->couleur_peau || fond == ava->couleur_poils || fond == ava->couleur_yeux)
		fond = MLV_rgba(0, 255, 0, 255);
	if(fond == ava->couleur_peau || fond == ava->couleur_poils || fond == ava->couleur_yeux)
		fond = MLV_rgba(255, 0, 0, 255);
	if(fond == ava->couleur_peau || fond == ava->couleur_poils || fond == ava->couleur_yeux)
		fond = MLV_rgba(0, 0, 255, 255);
	MLV_clear_window(fond);
	int lx = ava->x, ly = ava->y;
	ava->x = (ava->y = ava->visage_size/2);
	Corps *corps = ava->corps;
	ava->corps = NULL;
	Avatar_Afficher(ava);
	ava->corps = corps;
	ava->x = lx;
	ava->y = ly;
	int i, j;
	Uint8 fr, fg, fb, fa;
	MLV_convert_color_to_rgba(fond, &fr, &fg, &fb, &fa);
	int r, g, b, a;
	for(i = 0; i < ava->visage_size*2; i ++)
	{
		for(j = 0; j < ava->visage_size*2; j ++)
		{
			MLV_get_pixel(i, j, &r, &g, &b, &a);
			if(r != fr || g != fg || b != fb)
				MLV_set_pixel_on_image(i, j, MLV_rgba(r, g, b, 255), image);
			else
				MLV_set_pixel_on_image(i, j, MLV_rgba(0, 0, 0, 0), image);
		}
	}
	MLV_load_screen();
	return image;
}

void Avatar_Afficher_Tete_BySize(Avatar *ava, int x, int y, int size)
{
	if(ava->modified && ava->tete != NULL)
	{
		MLV_free_image(ava->tete);
		ava->tete = NULL;
		ava->modified = 0;
	}
	if(ava->tete == NULL)
		ava->tete = Avatar_Tete(ava);
	MLV_Image *tmp = MLV_copy_image(ava->tete);
	MLV_resize_image(tmp, size*2, size*2);
	MLV_draw_image(tmp, -size+x, -size+y);
	MLV_free_image(tmp);
}
