#include "avatar_calcul.h"

int Cercle_GetTangentes(Cercle ca, Cercle cb, Point *pa1, Point *pa2, Point *pb1, Point *pb2)
{
	if(ca.rayon < 0)
		ca.rayon *= -1;
	if(cb.rayon < 0)
		cb.rayon *= -1;
	if(ca.rayon < cb.rayon)//Permettra d'avoir les points correctement positionnés (du bon côté)
		return Cercle_GetTangentes(cb, ca, pb2, pb1, pa2, pa1);
	if(pow((double)(ca.centre.x-cb.centre.x), 2)+pow((double)(ca.centre.y-cb.centre.y), 2) <= pow((double)(ca.rayon-cb.rayon), 2))//ca contient cb
		return 0;
	double angle1 = 0;
	double angle2 = 0;
	if(ca.rayon != cb.rayon)
	{
		double a = ((double)(ca.centre.x-cb.centre.x))/((double)(ca.rayon-cb.rayon));
		double b = ((double)(ca.centre.y-cb.centre.y))/((double)(ca.rayon-cb.rayon));
		if(a != -1)
		{
			angle1 = 2*atan((b+sqrt(pow(a, 2)+pow(b, 2)-1))/(a+1))+M_PI;
			angle2 = 2*atan((b-sqrt(pow(a, 2)+pow(b, 2)-1))/(a+1))+M_PI;
		}
		else
		{
			if(b > 0)//angle1 vaut déjà 0
				angle2 = 2*atan(1/b)+M_PI;
			else if(b < 0)//angle2 vaut déjà 0
				angle1 = 2*atan(1/b)+M_PI;
			//Sinon les deux angles vaudront 0 ce qui est déjà le cas
		}
	}
	else
	{
		double a = (double)(ca.rayon*(ca.centre.y-cb.centre.y));
		double b = (double)(-ca.rayon*(ca.centre.x-cb.centre.x));
		if(a != 0)
		{
			angle1 = 2*atan((b-sqrt(pow(a, 2)+pow(b, 2)))/a)+(M_PI/2);
			angle2 = 2*atan((b+sqrt(pow(a, 2)+pow(b, 2)))/a)+(M_PI/2);
		}
		else
		{
			if(b > 0)
			{
				angle1 = M_PI/2;
				angle2 = -M_PI/2;
			}
			else if(b < 0)
			{
				angle1 = -M_PI/2;
				angle2 = M_PI/2;
			}
			//Si a=0 et b=0, c'est que ca contient cb donc cas inutile à traiter
		}
	}
	if(pa1 != NULL)
	{
		(*pa1).x = (int)((ca.rayon*cos(angle1))+ca.centre.x);
		(*pa1).y = (int)((ca.rayon*sin(angle1))+ca.centre.y);
	}
	if(pa2 != NULL)
	{
		(*pa2).x = (int)((ca.rayon*cos(angle2))+ca.centre.x);
		(*pa2).y = (int)((ca.rayon*sin(angle2))+ca.centre.y);
	}
	if(pb1 != NULL)
	{
		(*pb1).x = (int)((cb.rayon*cos(angle1))+cb.centre.x);
		(*pb1).y = (int)((cb.rayon*sin(angle1))+cb.centre.y);
	}
	if(pb2 != NULL)
	{
		(*pb2).x = (int)((cb.rayon*cos(angle2))+cb.centre.x);
		(*pb2).y = (int)((cb.rayon*sin(angle2))+cb.centre.y);
	}
	return 1;
}

int Cercle_GetX_ByAngle(Cercle c, double angle, double radius_scale)
{
	return (int)((radius_scale*c.rayon*cos(angle))+c.centre.x);
}

int Cercle_GetY_ByAngle(Cercle c, double angle, double radius_scale)
{
	return (int)((radius_scale*c.rayon*sin(angle))+c.centre.y);
}

double radian_convert(int degre)
{
	return (((double)(degre*M_PI))/180);
}

Cercle Cercle_ByAngle(Cercle c, int degre)
{
	degre *= -1;
	Cercle new_c = {{(c.centre.x*cos(radian_convert(degre))) - (c.centre.y*sin(radian_convert(degre))), (c.centre.y*cos(radian_convert(degre))) + (c.centre.x*sin(radian_convert(degre)))}, c.rayon};
	return new_c;
}
