#include "avatar_edit.h"

static Cheveux *last_chev = NULL;
static Cheveux *last_oposite = NULL;

int Visage_MoveTo(Visage *vis, Visage *main_vis, int x, int y, int size)
{
	if(vis == NULL || vis == VISAGE_CRANE(main_vis))
		return 0;
	if(vis == VISAGE_MACHOIRE_GAUCHE(main_vis))
		return Visage_Move(VISAGE_MACHOIRE_DROITE(main_vis), main_vis, -(x-vis->cercle.centre.x), y-vis->cercle.centre.y, size);
	if(vis == VISAGE_MENTON_GAUCHE(main_vis))
		return Visage_Move(VISAGE_MENTON_DROITE(main_vis), main_vis, -(x-vis->cercle.centre.x), y-vis->cercle.centre.y, size);
	return Visage_Move(vis, main_vis, x-vis->cercle.centre.x, y-vis->cercle.centre.y, size);
}

int Visage_Scale(Visage *vis, Visage *main_vis, int add_scale, int size)
{
	if(vis == NULL || vis == VISAGE_CRANE(main_vis))
		return 0;
	if(vis->cercle.rayon + add_scale <= 0)
		return 0;
	if(vis == VISAGE_MENTON_GAUCHE(main_vis))
		return Visage_Scale(VISAGE_MENTON_DROITE(main_vis), main_vis, add_scale, size);
	if(vis == VISAGE_MACHOIRE_GAUCHE(main_vis))
		return Visage_Scale(VISAGE_MACHOIRE_DROITE(main_vis), main_vis, add_scale, size);
	if(add_scale == 0)
		return 0;
	if(vis == VISAGE_MACHOIRE_DROITE(main_vis))
	{
		if(vis->cercle.centre.x+vis->cercle.rayon+add_scale > size)
			add_scale = size-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.x+vis->cercle.rayon+add_scale < VISAGE_MENTON_DROITE(main_vis)->cercle.centre.x+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon)
			add_scale = VISAGE_MENTON_DROITE(main_vis)->cercle.centre.x+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.x+vis->cercle.rayon+add_scale < VISAGE_CRANE(main_vis)->cercle.centre.x+(VISAGE_CRANE(main_vis)->cercle.rayon/2))
			add_scale = VISAGE_CRANE(main_vis)->cercle.centre.x+(VISAGE_CRANE(main_vis)->cercle.rayon/2)-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.y+vis->cercle.rayon+add_scale > VISAGE_MENTON_DROITE(main_vis)->cercle.centre.y+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon)
			add_scale = VISAGE_MENTON_DROITE(main_vis)->cercle.centre.y+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.y+vis->cercle.rayon);
	}
	else if(vis == VISAGE_MENTON_DROITE(main_vis))
	{
		if(vis->cercle.centre.x+vis->cercle.rayon+add_scale > VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.x+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon)
			add_scale = VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.x+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.y+vis->cercle.rayon+add_scale > size)
			add_scale = size-(vis->cercle.centre.y+vis->cercle.rayon);
		if(vis->cercle.centre.y+vis->cercle.rayon+add_scale < VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.y+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon)
			add_scale = VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.y+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.y+vis->cercle.rayon);
	}
	vis->cercle.rayon += add_scale;
	if(vis == VISAGE_MENTON_DROITE(main_vis))
		VISAGE_MENTON_GAUCHE(main_vis)->cercle.rayon += add_scale;
	if(vis == VISAGE_MACHOIRE_DROITE(main_vis))
		VISAGE_MACHOIRE_GAUCHE(main_vis)->cercle.rayon += add_scale;
	return 1;
}

int Visage_Move(Visage *vis, Visage *main_vis, int add_x, int add_y, int size)
{
	if(vis == NULL || vis == VISAGE_CRANE(main_vis))
		return 0;
	if(vis == VISAGE_MACHOIRE_DROITE(main_vis))
	{
		if(vis->cercle.centre.x+vis->cercle.rayon+add_x > size)
			add_x = size-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.x+vis->cercle.rayon+add_x < VISAGE_MENTON_DROITE(main_vis)->cercle.centre.x+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon)
			add_x = VISAGE_MENTON_DROITE(main_vis)->cercle.centre.x+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.x+vis->cercle.rayon+add_x < VISAGE_CRANE(main_vis)->cercle.centre.x+(VISAGE_CRANE(main_vis)->cercle.rayon/2))
			add_x = VISAGE_CRANE(main_vis)->cercle.centre.x+(VISAGE_CRANE(main_vis)->cercle.rayon/2)-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.y+add_y < VISAGE_CRANE(main_vis)->cercle.centre.y+(VISAGE_CRANE(main_vis)->cercle.rayon/2))
			add_y = VISAGE_CRANE(main_vis)->cercle.centre.y+(VISAGE_CRANE(main_vis)->cercle.rayon/2)-vis->cercle.centre.y;
		if(carre(vis->cercle.centre.x+add_x-VISAGE_CRANE(main_vis)->cercle.centre.x)+carre(vis->cercle.centre.y+add_y-VISAGE_CRANE(main_vis)->cercle.centre.y) < carre(VISAGE_CRANE(main_vis)->cercle.rayon))
		{
			add_x = 0;
			add_y = 0;
		}
		if(vis->cercle.centre.y+vis->cercle.rayon+add_y > VISAGE_MENTON_DROITE(main_vis)->cercle.centre.y+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon)
			add_y = VISAGE_MENTON_DROITE(main_vis)->cercle.centre.y+VISAGE_MENTON_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.y+vis->cercle.rayon);
		if(add_x == 0 && add_y == 0)
			return 0;
		vis->cercle.centre.x = vis->cercle.centre.x+add_x;
		vis->cercle.centre.y = vis->cercle.centre.y+add_y;
		VISAGE_MACHOIRE_GAUCHE(main_vis)->cercle.centre.x = VISAGE_MACHOIRE_GAUCHE(main_vis)->cercle.centre.x-add_x;
		VISAGE_MACHOIRE_GAUCHE(main_vis)->cercle.centre.y = VISAGE_MACHOIRE_GAUCHE(main_vis)->cercle.centre.y+add_y;
		return 1;
	}
	else if(vis == VISAGE_MENTON_DROITE(main_vis))
	{
		if(vis->cercle.centre.x+add_x < (size/2))
			add_x = (size/2)-vis->cercle.centre.x;
		if(vis->cercle.centre.x+vis->cercle.rayon+add_x > VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.x+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon)
			add_x = VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.x+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.x+vis->cercle.rayon);
		if(vis->cercle.centre.y+vis->cercle.rayon+add_y > size)
			add_y = size-(vis->cercle.centre.y+vis->cercle.rayon);
		if(vis->cercle.centre.y+vis->cercle.rayon+add_y < VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.y+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon)
			add_y = VISAGE_MACHOIRE_DROITE(main_vis)->cercle.centre.y+VISAGE_MACHOIRE_DROITE(main_vis)->cercle.rayon-(vis->cercle.centre.y+vis->cercle.rayon);
		if(add_x == 0 && add_y == 0)
			return 0;
		vis->cercle.centre.x = vis->cercle.centre.x+add_x;
		vis->cercle.centre.y = vis->cercle.centre.y+add_y;
		VISAGE_MENTON_GAUCHE(main_vis)->cercle.centre.x = VISAGE_MENTON_GAUCHE(main_vis)->cercle.centre.x-add_x;
		VISAGE_MENTON_GAUCHE(main_vis)->cercle.centre.y = VISAGE_MENTON_GAUCHE(main_vis)->cercle.centre.y+add_y;
		return 1;
	}
	return 0;
}

int Avatar_Yeux_MoveTo(Avatar *ava, int x, int y)
{
	return Avatar_Yeux_Move(ava, x-ava->selection.yeux->cercle.centre.x, y-ava->selection.yeux->cercle.centre.y);
}

int Avatar_Yeux_Move(Avatar *ava, int add_x, int add_y)
{
	Yeux *oeil_sel = ava->selection.yeux;
	Yeux *oposite = NULL;
	
	if(oeil_sel == YEUX_INTERNE(ava->oeil_gauche))
	{
		oeil_sel = YEUX_INTERNE(ava->oeil_droit);
		add_x *= -1;
	}
	else if(oeil_sel == YEUX_MIDDLE(ava->oeil_gauche))
	{
		oeil_sel = YEUX_MIDDLE(ava->oeil_droit);
		add_x *= -1;
	}
	else if(oeil_sel == YEUX_EXTERNE(ava->oeil_gauche))
	{
		oeil_sel = YEUX_EXTERNE(ava->oeil_droit);
		add_x *= -1;
	}
	
	if(oeil_sel == YEUX_INTERNE(ava->oeil_droit))
		oposite = YEUX_INTERNE(ava->oeil_gauche);
	if(oeil_sel == YEUX_MIDDLE(ava->oeil_droit))
		oposite = YEUX_MIDDLE(ava->oeil_gauche);
	if(oeil_sel == YEUX_EXTERNE(ava->oeil_droit))
		oposite = YEUX_EXTERNE(ava->oeil_gauche);
	
	if(oeil_sel == YEUX_INTERNE(ava->oeil_droit))
	{
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x < (ava->visage_size*11)/20)
			add_x = (ava->visage_size*11)/20-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon);
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x > YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.x-YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_x = YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.x-YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon)-1;
		if(oeil_sel->cercle.centre.y+add_y < YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y-YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_y = YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y-YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.y);
		if(oeil_sel->cercle.centre.y+add_y > YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y+YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_y = YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y+YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.y);
	}
	else if(oeil_sel == YEUX_EXTERNE(ava->oeil_droit))
	{
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_x > (ava->visage_size*16)/20)
			add_x = (ava->visage_size*16)/20-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon);
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_x < YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.x+YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_x = YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.x+YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon)+1;
		if(oeil_sel->cercle.centre.y+add_y < YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y-YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_y = YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y-YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.y);
		if(oeil_sel->cercle.centre.y+add_y > YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y+YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_y = YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y+YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.y);
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x < ava->visage_size/2)
			add_x = (ava->visage_size/2)-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon);
	}
	else if(oeil_sel == YEUX_MIDDLE(ava->oeil_droit))
	{
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x < YEUX_INTERNE(ava->oeil_droit)->cercle.centre.x-YEUX_INTERNE(ava->oeil_droit)->cercle.rayon)
			add_x = YEUX_INTERNE(ava->oeil_droit)->cercle.centre.x-YEUX_INTERNE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon)+1;
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_x > YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.x+YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon)
			add_x = YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.x+YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon)-1;
		if(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon+add_y > min(YEUX_INTERNE(ava->oeil_droit)->cercle.centre.y, YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.y))
			add_y = min(YEUX_INTERNE(ava->oeil_droit)->cercle.centre.y, YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.y)-(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon);
		if(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon+add_y < max(YEUX_INTERNE(ava->oeil_droit)->cercle.centre.y, YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.y))
			add_y = max(YEUX_INTERNE(ava->oeil_droit)->cercle.centre.y, YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.y)-(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon);
		
	}
	if(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon+add_y > VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon);
	if(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon+add_y < VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon);
	
	if(add_x == 0 && add_y == 0)
		return 0;
	oeil_sel->cercle.centre.x = oeil_sel->cercle.centre.x+add_x;
	oeil_sel->cercle.centre.y = oeil_sel->cercle.centre.y+add_y;
	oposite->cercle.centre.x = oposite->cercle.centre.x-add_x;
	oposite->cercle.centre.y = oposite->cercle.centre.y+add_y;
	return 1;
}

int Avatar_Yeux_Scale(Avatar *ava, int add_scale)
{
	Yeux *oeil_sel = ava->selection.yeux;
	Yeux *oposite = NULL;
	
	if(oeil_sel == YEUX_INTERNE(ava->oeil_gauche))
		oeil_sel = YEUX_INTERNE(ava->oeil_droit);
	else if(oeil_sel == YEUX_MIDDLE(ava->oeil_gauche))
		oeil_sel = YEUX_MIDDLE(ava->oeil_droit);
	else if(oeil_sel == YEUX_EXTERNE(ava->oeil_gauche))
		oeil_sel = YEUX_EXTERNE(ava->oeil_droit);
	
	if(oeil_sel == YEUX_INTERNE(ava->oeil_droit))
		oposite = YEUX_INTERNE(ava->oeil_gauche);
	else if(oeil_sel == YEUX_MIDDLE(ava->oeil_droit))
		oposite = YEUX_MIDDLE(ava->oeil_gauche);
	else if(oeil_sel == YEUX_EXTERNE(ava->oeil_droit))
		oposite = YEUX_EXTERNE(ava->oeil_gauche);
	
	if(oeil_sel == YEUX_INTERNE(ava->oeil_droit))
	{
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon-add_scale < (ava->visage_size*11)/20)
			add_scale = -((ava->visage_size*11)/20-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon));
		if(oeil_sel->cercle.rayon+add_scale >= YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon)
			add_scale = YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon-oeil_sel->cercle.rayon-1;
	}
	else if(oeil_sel == YEUX_EXTERNE(ava->oeil_droit))
	{
		if(oeil_sel->cercle.rayon+add_scale >= YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon*2)
			add_scale = (YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon*2)-oeil_sel->cercle.rayon-1;
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon-add_scale < ava->visage_size/2)
			add_scale = -((ava->visage_size/2)-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon));
	}
	else if(oeil_sel == YEUX_MIDDLE(ava->oeil_droit))
	{
		if(oeil_sel->cercle.rayon+add_scale < YEUX_INTERNE(ava->oeil_droit)->cercle.rayon)
			add_scale = YEUX_INTERNE(ava->oeil_droit)->cercle.rayon-oeil_sel->cercle.rayon+1;
		if(oeil_sel->cercle.rayon+add_scale < YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon/2)
			add_scale = (YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon/2)-oeil_sel->cercle.rayon+1;
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_scale > YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.x+YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon)
			add_scale = YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.x+YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon)-1;
	}
	if(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon+add_scale > VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
		add_scale = VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon);
	if(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon-add_scale < VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
		add_scale = -(VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon));
	if(oeil_sel->cercle.rayon+add_scale < 0)
		add_scale = -oeil_sel->cercle.rayon;
		
	if(add_scale == 0)
		return 0;
	oeil_sel->cercle.rayon = oeil_sel->cercle.rayon+add_scale;
	oposite->cercle.rayon = oposite->cercle.rayon+add_scale;
	return 1;
}

int Avatar_Sourcil_MoveTo(Avatar *ava, int x, int y)
{
	return Avatar_Sourcil_Move(ava, x-ava->selection.yeux->cercle.centre.x, y-ava->selection.yeux->cercle.centre.y);
}

int Avatar_Sourcil_Move(Avatar *ava, int add_x, int add_y)
{
	Yeux *oeil_sel = ava->selection.yeux;
	Yeux *oposite = NULL;
	
	if(oeil_sel == SOURCILS_INTERNE(ava->sourcil_gauche))
	{
		oeil_sel = SOURCILS_INTERNE(ava->sourcil_droit);
		add_x *= -1;
	}
	else if(oeil_sel == SOURCILS_MIDINTERNE(ava->sourcil_gauche))
	{
		oeil_sel = SOURCILS_MIDINTERNE(ava->sourcil_droit);
		add_x *= -1;
	}
	else if(oeil_sel == SOURCILS_MIDEXTERNE(ava->sourcil_gauche))
	{
		oeil_sel = SOURCILS_MIDEXTERNE(ava->sourcil_droit);
		add_x *= -1;
	}
	else if(oeil_sel == SOURCILS_EXTERNE(ava->sourcil_gauche))
	{
		oeil_sel = SOURCILS_EXTERNE(ava->sourcil_droit);
		add_x *= -1;
	}
	
	if(oeil_sel == SOURCILS_INTERNE(ava->sourcil_droit))
		oposite = SOURCILS_INTERNE(ava->sourcil_gauche);
	else if(oeil_sel == SOURCILS_MIDINTERNE(ava->sourcil_droit))
		oposite = SOURCILS_MIDINTERNE(ava->sourcil_gauche);
	else if(oeil_sel == SOURCILS_MIDEXTERNE(ava->sourcil_droit))
		oposite = SOURCILS_MIDEXTERNE(ava->sourcil_gauche);
	else if(oeil_sel == SOURCILS_EXTERNE(ava->sourcil_droit))
		oposite = SOURCILS_EXTERNE(ava->sourcil_gauche);
		
	if(oeil_sel == SOURCILS_INTERNE(ava->sourcil_droit))
	{
		if(oeil_sel->cercle.centre.x+add_x < (ava->visage_size*21)/40)
			add_x = (ava->visage_size*21)/40-(oeil_sel->cercle.centre.x);
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_x > SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.centre.x-SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.rayon)
			add_x = SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.centre.x-SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon)-1;
	}
	else if(oeil_sel == SOURCILS_MIDINTERNE(ava->sourcil_droit))
	{
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_x > SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.centre.x-SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.rayon)
			add_x = SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.centre.x-SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon)-1;
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x < SOURCILS_INTERNE(ava->sourcil_droit)->cercle.centre.x+SOURCILS_INTERNE(ava->sourcil_droit)->cercle.rayon)
			add_x = SOURCILS_INTERNE(ava->sourcil_droit)->cercle.centre.x+SOURCILS_INTERNE(ava->sourcil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon)+1;
	}
	else if(oeil_sel == SOURCILS_MIDEXTERNE(ava->sourcil_droit))
	{
		if(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon+add_x > SOURCILS_EXTERNE(ava->sourcil_droit)->cercle.centre.x-SOURCILS_EXTERNE(ava->sourcil_droit)->cercle.rayon)
			add_x = SOURCILS_EXTERNE(ava->sourcil_droit)->cercle.centre.x-SOURCILS_EXTERNE(ava->sourcil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x+oeil_sel->cercle.rayon)-1;
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x < SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.centre.x+SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.rayon)
			add_x = SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.centre.x+SOURCILS_MIDINTERNE(ava->sourcil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon)+1;
	}
	else if(oeil_sel == SOURCILS_EXTERNE(ava->sourcil_droit))
	{
		if(oeil_sel->cercle.centre.x+add_x > (ava->visage_size*16)/20)
			add_x = (ava->visage_size*16)/20-(oeil_sel->cercle.centre.x);
		if(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon+add_x < SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.centre.x+SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.rayon)
			add_x = SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.centre.x+SOURCILS_MIDEXTERNE(ava->sourcil_droit)->cercle.rayon-(oeil_sel->cercle.centre.x-oeil_sel->cercle.rayon)+1;
	}
	if(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon+add_y > VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8)-(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon);
	if(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon+add_y < VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8)-(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon);
	
	if(add_x == 0 && add_y == 0)
		return 0;
	oeil_sel->cercle.centre.x = oeil_sel->cercle.centre.x+add_x;
	oeil_sel->cercle.centre.y = oeil_sel->cercle.centre.y+add_y;
	oposite->cercle.centre.x = oposite->cercle.centre.x-add_x;
	oposite->cercle.centre.y = oposite->cercle.centre.y+add_y;
	return 1;
}

int Avatar_Sourcil_Scale(Avatar *ava, int add_scale)
{
	Yeux *oeil_sel = ava->selection.yeux;
	Yeux *oposite = NULL;
	
	if(oeil_sel == SOURCILS_INTERNE(ava->sourcil_gauche))
		oeil_sel = SOURCILS_INTERNE(ava->sourcil_droit);
	else if(oeil_sel == SOURCILS_MIDINTERNE(ava->sourcil_gauche))
		oeil_sel = SOURCILS_MIDINTERNE(ava->sourcil_droit);
	else if(oeil_sel == SOURCILS_MIDEXTERNE(ava->sourcil_gauche))
		oeil_sel = SOURCILS_MIDEXTERNE(ava->sourcil_droit);
	else if(oeil_sel == SOURCILS_EXTERNE(ava->sourcil_gauche))
		oeil_sel = SOURCILS_EXTERNE(ava->sourcil_droit);
	
	if(oeil_sel == SOURCILS_INTERNE(ava->sourcil_droit))
		oposite = SOURCILS_INTERNE(ava->sourcil_gauche);
	else if(oeil_sel == SOURCILS_MIDINTERNE(ava->sourcil_droit))
		oposite = SOURCILS_MIDINTERNE(ava->sourcil_gauche);
	else if(oeil_sel == SOURCILS_MIDEXTERNE(ava->sourcil_droit))
		oposite = SOURCILS_MIDEXTERNE(ava->sourcil_gauche);
	else if(oeil_sel == SOURCILS_EXTERNE(ava->sourcil_droit))
		oposite = SOURCILS_EXTERNE(ava->sourcil_gauche);
	
	if(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon+add_scale > VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8))
		add_scale = VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8)-(oeil_sel->cercle.centre.y+oeil_sel->cercle.rayon);
	if(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon-add_scale < VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8))
		add_scale = -(VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(VISAGE_CRANE(ava->visage)->cercle.rayon/8)-(oeil_sel->cercle.centre.y-oeil_sel->cercle.rayon));
	if(oeil_sel->cercle.rayon+add_scale < 0)
		add_scale = -oeil_sel->cercle.rayon;
	
	if(add_scale == 0)
		return 0;
	oeil_sel->cercle.rayon = oeil_sel->cercle.rayon+add_scale;
	oposite->cercle.rayon = oposite->cercle.rayon+add_scale;
	return 1;
}

int Avatar_Nez_Move(Avatar *ava, int add_x, int add_y)
{
	Yeux *nez = ava->selection.yeux;
	Yeux *oposite = NULL;
	if(nez == NEZ_GAUCHE(ava->nez))
		nez = NEZ_DROITE(ava->nez);
	else if(nez == NEZ_DROITE(ava->nez))
		oposite = NEZ_GAUCHE(ava->nez);
	else if(nez == NEZ_MIDDLE(ava->nez))
		add_x = 0;
		
	if(nez == NEZ_DROITE(ava->nez))
	{
		if(nez->cercle.centre.x-nez->cercle.rayon+add_x < NEZ_MIDDLE(ava->nez)->cercle.centre.x+NEZ_MIDDLE(ava->nez)->cercle.rayon)
			add_x = NEZ_MIDDLE(ava->nez)->cercle.centre.x+NEZ_MIDDLE(ava->nez)->cercle.rayon-(nez->cercle.centre.x-nez->cercle.rayon);
		if(nez->cercle.centre.x+nez->cercle.rayon+add_x > (ava->visage_size/2)+(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
			add_x = (ava->visage_size/2)+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(nez->cercle.centre.x+nez->cercle.rayon);
	}
	if(nez->cercle.centre.y+add_y > VISAGE_CRANE(ava->visage)->cercle.centre.y+VISAGE_CRANE(ava->visage)->cercle.rayon)
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+VISAGE_CRANE(ava->visage)->cercle.rayon-nez->cercle.centre.y;
	if(nez->cercle.centre.y+add_y < VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-nez->cercle.centre.y;
	
	if(add_x == 0 && add_y == 0)
		return 0;
	nez->cercle.centre.x = nez->cercle.centre.x+add_x;
	nez->cercle.centre.y = nez->cercle.centre.y+add_y;
	if(oposite != NULL)
	{
		oposite->cercle.centre.x = oposite->cercle.centre.x-add_x;
		oposite->cercle.centre.y = oposite->cercle.centre.y+add_y;
	}
	return 1;
}

int Avatar_Nez_MoveTo(Avatar *ava, int x, int y)
{
	return Avatar_Nez_Move(ava, x-ava->selection.yeux->cercle.centre.x, y-ava->selection.yeux->cercle.centre.y);
}

int Avatar_Nez_Scale(Avatar *ava, int add_scale)
{
	Yeux *nez = ava->selection.yeux;
	Yeux *oposite = NULL;
	if(nez == NEZ_GAUCHE(ava->nez))
		nez = NEZ_DROITE(ava->nez);
	if(nez == NEZ_DROITE(ava->nez))
		oposite = NEZ_GAUCHE(ava->nez);
		
	if(nez->cercle.rayon+add_scale < 0)
		add_scale = -nez->cercle.rayon;
	if(nez == NEZ_DROITE(ava->nez))
	{
		if(nez->cercle.centre.x-nez->cercle.rayon-add_scale < NEZ_MIDDLE(ava->nez)->cercle.centre.x)
			add_scale = -(NEZ_MIDDLE(ava->nez)->cercle.centre.x-(nez->cercle.centre.x-nez->cercle.rayon));
		if(nez->cercle.centre.x+nez->cercle.rayon+add_scale > (ava->visage_size/2)+(VISAGE_CRANE(ava->visage)->cercle.rayon/4))
			add_scale = (ava->visage_size/2)+(VISAGE_CRANE(ava->visage)->cercle.rayon/4)-(nez->cercle.centre.x+nez->cercle.rayon);
	}
	else if(nez == NEZ_MIDDLE(ava->nez))
	{
		if(nez->cercle.centre.x+nez->cercle.rayon+add_scale > NEZ_DROITE(ava->nez)->cercle.centre.x)
			add_scale = NEZ_DROITE(ava->nez)->cercle.centre.x-(nez->cercle.centre.x+nez->cercle.rayon);
	}
	
	if(add_scale == 0)
		return 0;
	nez->cercle.rayon = nez->cercle.rayon+add_scale;
	if(oposite != NULL)
		oposite->cercle.rayon = oposite->cercle.rayon+add_scale;
	return 1;
}

int Avatar_Bouche_Move(Avatar *ava, int add_y)
{
	if(ava->bouche.centre.y+add_y < VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/2))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+(VISAGE_CRANE(ava->visage)->cercle.rayon/2)-ava->bouche.centre.y;
	if(ava->bouche.centre.y+add_y > VISAGE_CRANE(ava->visage)->cercle.centre.y+((VISAGE_CRANE(ava->visage)->cercle.rayon*3)/2))
		add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+((VISAGE_CRANE(ava->visage)->cercle.rayon*3)/2)-ava->bouche.centre.y;
	if(add_y == 0)
		return 0;
	ava->bouche.centre.y = ava->bouche.centre.y+add_y;
	return 1;
}

int Avatar_Bouche_MoveTo(Avatar *ava, int x, int y)
{
	return Avatar_Bouche_Move(ava, y-ava->bouche.centre.y);
}

int Avatar_Bouche_Scale(Avatar *ava, int add_scale)
{
	if(ava->bouche.rayon+add_scale < 0)
		add_scale = -ava->bouche.rayon;
	if(ava->bouche.rayon+add_scale > VISAGE_CRANE(ava->visage)->cercle.rayon)
		add_scale = VISAGE_CRANE(ava->visage)->cercle.rayon-ava->bouche.rayon;
	if(add_scale == 0)
		return 0;
	ava->bouche.rayon = ava->bouche.rayon+add_scale;
	return 1;
}

int Avatar_Oreille_Move(Avatar *ava, int add_x, int add_y)
{
	Yeux *ore = ava->selection.yeux;
	Yeux *oposite = NULL;
	if(ore == OREILLE_HAUT(ava->oreille_gauche))
	{
		ore = OREILLE_HAUT(ava->oreille_droite);
		add_x *= -1;
	}
	else if(ore == OREILLE_MID(ava->oreille_gauche))
	{
		ore = OREILLE_MID(ava->oreille_droite);
		add_x *= -1;
	}
	else if(ore == OREILLE_BAS(ava->oreille_gauche))
	{
		ore = OREILLE_BAS(ava->oreille_droite);
		add_x *= -1;
	}
	
	if(ore == OREILLE_HAUT(ava->oreille_droite))
		oposite = OREILLE_HAUT(ava->oreille_gauche);
	else if(ore == OREILLE_MID(ava->oreille_droite))
		oposite = OREILLE_MID(ava->oreille_gauche);
	else if(ore == OREILLE_BAS(ava->oreille_droite))
		oposite = OREILLE_BAS(ava->oreille_gauche);
	
	if(ore == OREILLE_HAUT(ava->oreille_droite))
	{
		if(ore->cercle.centre.y+add_y < VISAGE_CRANE(ava->visage)->cercle.centre.y-((VISAGE_CRANE(ava->visage)->cercle.rayon*4)/5))
			add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y-((VISAGE_CRANE(ava->visage)->cercle.rayon*4)/5)-(ore->cercle.centre.y);
		if(ore->cercle.centre.y+ore->cercle.rayon+add_y > OREILLE_MID(ava->oreille_droite)->cercle.centre.y-OREILLE_MID(ava->oreille_droite)->cercle.rayon)
			add_y = OREILLE_MID(ava->oreille_droite)->cercle.centre.y-OREILLE_MID(ava->oreille_droite)->cercle.rayon-(ore->cercle.centre.y+ore->cercle.rayon);
	}	
	else if(ore == OREILLE_MID(ava->oreille_droite))
	{
		add_x = 0;
		if(ore->cercle.centre.y+ore->cercle.rayon+add_y > OREILLE_BAS(ava->oreille_droite)->cercle.centre.y-OREILLE_BAS(ava->oreille_droite)->cercle.rayon)
			add_y = OREILLE_BAS(ava->oreille_droite)->cercle.centre.y-OREILLE_BAS(ava->oreille_droite)->cercle.rayon-(ore->cercle.centre.y+ore->cercle.rayon);
		if(ore->cercle.centre.y-ore->cercle.rayon+add_y < OREILLE_HAUT(ava->oreille_droite)->cercle.centre.y+OREILLE_HAUT(ava->oreille_droite)->cercle.rayon)
			add_y = OREILLE_HAUT(ava->oreille_droite)->cercle.centre.y+OREILLE_HAUT(ava->oreille_droite)->cercle.rayon-(ore->cercle.centre.y-ore->cercle.rayon);
	}
	else if(ore == OREILLE_BAS(ava->oreille_droite))
	{
		if(ore->cercle.centre.y+add_y > VISAGE_CRANE(ava->visage)->cercle.centre.y+((VISAGE_CRANE(ava->visage)->cercle.rayon*7)/5))
			add_y = VISAGE_CRANE(ava->visage)->cercle.centre.y+((VISAGE_CRANE(ava->visage)->cercle.rayon*7)/5)-(ore->cercle.centre.y);
		if(ore->cercle.centre.y-ore->cercle.rayon+add_y < OREILLE_MID(ava->oreille_droite)->cercle.centre.y+OREILLE_MID(ava->oreille_droite)->cercle.rayon)
			add_y = OREILLE_MID(ava->oreille_droite)->cercle.centre.y+OREILLE_MID(ava->oreille_droite)->cercle.rayon-(ore->cercle.centre.y-ore->cercle.rayon);
	}
	if(ore->cercle.centre.x+add_x < VISAGE_CRANE(ava->visage)->cercle.centre.x+((VISAGE_CRANE(ava->visage)->cercle.rayon*4)/5))
		add_x = VISAGE_CRANE(ava->visage)->cercle.centre.x+((VISAGE_CRANE(ava->visage)->cercle.rayon*4)/5)-(ore->cercle.centre.x);
	if(ore->cercle.centre.x+add_x > VISAGE_CRANE(ava->visage)->cercle.centre.x+((VISAGE_CRANE(ava->visage)->cercle.rayon*7)/5))
		add_x = VISAGE_CRANE(ava->visage)->cercle.centre.x+((VISAGE_CRANE(ava->visage)->cercle.rayon*7)/5)-(ore->cercle.centre.x);
	
	if(add_x == 0 && add_y == 0)
		return 0;
	ore->cercle.centre.x = ore->cercle.centre.x + add_x;
	ore->cercle.centre.y = ore->cercle.centre.y + add_y;
	oposite->cercle.centre.x = oposite->cercle.centre.x - add_x;
	oposite->cercle.centre.y = oposite->cercle.centre.y + add_y;
	return 1;
}

int Avatar_Oreille_MoveTo(Avatar *ava, int x, int y)
{
	return Avatar_Oreille_Move(ava, x-ava->selection.yeux->cercle.centre.x, y-ava->selection.yeux->cercle.centre.y);
}

int Avatar_Oreille_Scale(Avatar *ava, int add_scale)
{
	Yeux *ore = ava->selection.yeux;
	Yeux *oposite = NULL;
	if(ore == OREILLE_HAUT(ava->oreille_gauche))
		ore = OREILLE_HAUT(ava->oreille_droite);
	else if(ore == OREILLE_MID(ava->oreille_gauche))
		ore = OREILLE_MID(ava->oreille_droite);
	else if(ore == OREILLE_BAS(ava->oreille_gauche))
		ore = OREILLE_BAS(ava->oreille_droite);
	
	if(ore == OREILLE_HAUT(ava->oreille_droite))
		oposite = OREILLE_HAUT(ava->oreille_gauche);
	else if(ore == OREILLE_MID(ava->oreille_droite))
		oposite = OREILLE_MID(ava->oreille_gauche);
	else if(ore == OREILLE_BAS(ava->oreille_droite))
		oposite = OREILLE_BAS(ava->oreille_gauche);
		
	if(ore->cercle.rayon+add_scale < 0)
		add_scale = -ore->cercle.rayon;
	if(ore->cercle.rayon+add_scale > VISAGE_CRANE(ava->visage)->cercle.rayon/5)
		add_scale = (VISAGE_CRANE(ava->visage)->cercle.rayon/5)-ore->cercle.rayon;
		
	if(add_scale == 0)
		return 0;
	ore->cercle.rayon = ore->cercle.rayon + add_scale;
	oposite->cercle.rayon = oposite->cercle.rayon + add_scale;
	return 1;
}

int Avatar_Cheveux_MoveTo(Avatar *ava, int x, int y)
{
	return Avatar_Cheveux_Move(ava, x-ava->selection.cheveux->centre.x, y-ava->selection.cheveux->centre.y);
}

int Avatar_Cheveux_Move(Avatar *ava, int add_x, int add_y)
{
	Cheveux *chev = ava->selection.cheveux;
	Cheveux *oposite = NULL;
	Cheveux *cur = NULL;
	int top_limit = 0;
	int bot_limit = 0;
	int left_limit = 0;
	int right_limit = 0;
	switch(ava->choix_selection)
	{
		case ASI_Cheveux_Droite:
		cur = ava->cheveux_droite;
		oposite = ava->cheveux_gauche;
		top_limit = -ava->visage_size/2;
		bot_limit = ava->visage_size;
		left_limit = ava->visage_size/2;
		right_limit = (ava->visage_size*17)/16;
		break;
		case ASI_Cheveux_Gauche:
		cur = ava->cheveux_gauche;
		oposite = ava->cheveux_droite;
		top_limit = -ava->visage_size/2;
		bot_limit = ava->visage_size;
		left_limit = -ava->visage_size/16;
		right_limit = ava->visage_size/2;
		break;
		default:
		return 0;
	}
	if(chev == last_chev)
	{
		oposite = last_oposite;
		cur = last_chev;
	}
	else
	{
		while(cur != chev && cur != NULL)
		{
			cur = cur->next;
			oposite = oposite->next;
		}
		if(cur == NULL)
			return 0;
		last_chev = chev;
		last_oposite = oposite;
	}
	if(cur->centre.x+add_x > right_limit)
		add_x = right_limit-cur->centre.x;
	if(cur->centre.x+add_x < left_limit)
		add_x = left_limit-cur->centre.x;
	if(cur->centre.y+add_y < top_limit)
		add_y = top_limit-cur->centre.y;
	if(cur->centre.y+add_y > bot_limit)
		add_y = bot_limit-cur->centre.y;
	if(add_x == 0 || add_y == 0)
		return 0;
	cur->centre.x = cur->centre.x+add_x;
	cur->centre.y = cur->centre.y+add_y;
	oposite->centre.x = oposite->centre.x-add_x;
	oposite->centre.y = oposite->centre.y+add_y;
	return 1;
}

int Avatar_Corps_Move(Avatar *ava, int add_x, int add_y)
{
	Corps *corps = ava->selection.corps;
	Corps *oposite = NULL;
	if(corps == CORPS_EPAULE_D(ava->corps))
		oposite = CORPS_EPAULE_G(ava->corps);
	if(corps == CORPS_EPAULE_G(ava->corps))
		oposite = CORPS_EPAULE_D(ava->corps);
	if(corps == CORPS_BRAS_D(ava->corps))
		oposite = CORPS_BRAS_G(ava->corps);
	if(corps == CORPS_BRAS_G(ava->corps))
		oposite = CORPS_BRAS_D(ava->corps);
	if(corps == CORPS_AVB_D(ava->corps))
		oposite = CORPS_AVB_G(ava->corps);
	if(corps == CORPS_AVB_G(ava->corps))
		oposite = CORPS_AVB_D(ava->corps);
	if(corps == CORPS_MAIN_D(ava->corps))
		oposite = CORPS_MAIN_G(ava->corps);
	if(corps == CORPS_MAIN_G(ava->corps))
		oposite = CORPS_MAIN_D(ava->corps);
	if(corps == CORPS_CUISSE_D(ava->corps))
		oposite = CORPS_CUISSE_G(ava->corps);
	if(corps == CORPS_CUISSE_G(ava->corps))
		oposite = CORPS_CUISSE_D(ava->corps);
	if(corps == CORPS_TIBIA_D(ava->corps))
		oposite = CORPS_TIBIA_G(ava->corps);
	if(corps == CORPS_TIBIA_G(ava->corps))
		oposite = CORPS_TIBIA_D(ava->corps);
	if(corps == CORPS_PIED_D(ava->corps))
		oposite = CORPS_PIED_G(ava->corps);
	if(corps == CORPS_PIED_G(ava->corps))
		oposite = CORPS_PIED_D(ava->corps);
	
	if(corps->cercle.centre.x+add_x > corps->x_max)
		add_x = corps->x_max-corps->cercle.centre.x;
	if(corps->cercle.centre.x+add_x < corps->x_min)
		add_x = corps->x_min-corps->cercle.centre.x;
	if(corps->cercle.centre.y+add_y > corps->y_max)
		add_y = corps->y_max-corps->cercle.centre.y;
	if(corps->cercle.centre.y+add_y < corps->y_min)
		add_y = corps->y_min-corps->cercle.centre.y;
	if(add_x == 0 && add_y == 0)
		return 0;
	corps->cercle.centre.x = corps->cercle.centre.x+add_x;
	corps->cercle.centre.y = corps->cercle.centre.y+add_y;
	if(oposite != NULL)
	{
		oposite->cercle.centre.x = oposite->cercle.centre.x-add_x;
		oposite->cercle.centre.y = oposite->cercle.centre.y+add_y;
	}
	return 1;
}

int Avatar_Corps_MoveTo(Avatar *ava, int x, int y)
{
	int cx=ava->x, cy=ava->y;
	if(Corps_GetXY(ava->selection.corps, ava->corps, &cx, &cy))
	{
		return Avatar_Corps_Move(ava, x-cx, y-cy);
	}
	else
		return 0;
}

int Avatar_Corps_Scale(Avatar *ava, int add_scale)
{
	Corps *corps = ava->selection.corps;
	Corps *oposite = NULL;
	if(corps == CORPS_EPAULE_D(ava->corps))
		oposite = CORPS_EPAULE_G(ava->corps);
	if(corps == CORPS_EPAULE_G(ava->corps))
		oposite = CORPS_EPAULE_D(ava->corps);
	if(corps == CORPS_BRAS_D(ava->corps))
		oposite = CORPS_BRAS_G(ava->corps);
	if(corps == CORPS_BRAS_G(ava->corps))
		oposite = CORPS_BRAS_D(ava->corps);
	if(corps == CORPS_AVB_D(ava->corps))
		oposite = CORPS_AVB_G(ava->corps);
	if(corps == CORPS_AVB_G(ava->corps))
		oposite = CORPS_AVB_D(ava->corps);
	if(corps == CORPS_MAIN_D(ava->corps))
		oposite = CORPS_MAIN_G(ava->corps);
	if(corps == CORPS_MAIN_G(ava->corps))
		oposite = CORPS_MAIN_D(ava->corps);
	if(corps == CORPS_CUISSE_D(ava->corps))
		oposite = CORPS_CUISSE_G(ava->corps);
	if(corps == CORPS_CUISSE_G(ava->corps))
		oposite = CORPS_CUISSE_D(ava->corps);
	if(corps == CORPS_TIBIA_D(ava->corps))
		oposite = CORPS_TIBIA_G(ava->corps);
	if(corps == CORPS_TIBIA_G(ava->corps))
		oposite = CORPS_TIBIA_D(ava->corps);
	if(corps == CORPS_PIED_D(ava->corps))
		oposite = CORPS_PIED_G(ava->corps);
	if(corps == CORPS_PIED_G(ava->corps))
		oposite = CORPS_PIED_D(ava->corps);
		
	if(corps->cercle.rayon+add_scale > corps->ray_max)
		add_scale = corps->ray_max-corps->cercle.rayon;
	if(corps->cercle.rayon+add_scale < corps->ray_min)
		add_scale = corps->ray_min-corps->cercle.rayon;
	
	if(add_scale == 0)
		return 0;
	corps->cercle.rayon = corps->cercle.rayon+add_scale;
	if(oposite != NULL)
		oposite->cercle.rayon = oposite->cercle.rayon+add_scale;
	return 1;
}

Visage *Visage_GetNearest(Visage *vis, int x, int y, int *dmin)
{
	Visage *cur = vis->next;
	Visage *min_vis = NULL;
	int min_dist = 0;
	int tmp_dist = 0;
	do
	{
		tmp_dist = carre(x-cur->cercle.centre.x)+carre(y-cur->cercle.centre.y);
		if((min_vis == NULL || tmp_dist < min_dist) && tmp_dist < carre(cur->cercle.rayon+10))
		{
			min_vis = cur;
			min_dist = tmp_dist;
		}
		cur = cur->next;
	}while(cur != vis);
	if(dmin != NULL && min_vis != NULL)
		*dmin = min_dist;
	return min_vis;
}

Yeux *Yeux_GetNearest(Yeux *yeux, int x, int y, int *dmin)
{
	Yeux *cur = yeux;
	Yeux *min_yeux = NULL;
	int min_dist = 0;
	int tmp_dist = 0;
	while(cur != NULL)
	{
		tmp_dist = carre(x-cur->cercle.centre.x)+carre(y-cur->cercle.centre.y);
		if((min_yeux == NULL || tmp_dist < min_dist) && tmp_dist < carre(cur->cercle.rayon+10))
		{
			min_yeux = cur;
			min_dist = tmp_dist;
		}
		cur = cur->next;
	}
	if(dmin != NULL && min_yeux != NULL)
		*dmin = min_dist;
	return min_yeux;
}

Cheveux *Cheveux_GetNearest(Cheveux *chev, int x, int y, int *dmin)
{
	Cheveux *cur = chev;
	Cheveux *min_chev = NULL;
	int min_dist = 0;
	int tmp_dist = 0;
	while(cur != NULL)
	{
		tmp_dist = carre(x-cur->centre.x)+carre(y-cur->centre.y);
		if((min_chev == NULL || tmp_dist < min_dist) && tmp_dist < 625)
		{
			min_chev = cur;
			min_dist = tmp_dist;
		}
		cur = cur->next;
	}
	if(dmin != NULL && min_chev != NULL)
		*dmin = min_dist;
	return min_chev;
}

Cheveux *Cheveux_GetOposite(Cheveux *source, Cheveux *oposite, Cheveux *indice)
{
	while(source != NULL && oposite != NULL && source != indice)
	{
		source = source->next;
		oposite = oposite->next;
	}
	if(source == NULL)
		return NULL;
	return oposite;
}

int Bouche_Dist(Cercle c, int x, int y)
{
	int dist = carre(x-c.centre.x)+carre(y-c.centre.y);
	if(dist < carre(c.rayon+10))
		return dist;
	return -1;
}

Corps *Corps_GetNearest(Corps *corps, int x, int y, int *dmin)
{
	if(corps == NULL)
		return NULL;
	Corps *res = NULL;
	int dist = carre(x-corps->cercle.centre.x)+carre(y-corps->cercle.centre.y);
	if(((*dmin == -1 || dist < *dmin) && dist < carre(corps->cercle.rayon+10)) && (corps->x_min != corps->x_max || corps->y_min != corps->y_max || corps->ray_min != corps->ray_max))
	{
		res = corps;
		*dmin = dist;
	}
	int i;
	for(i = 0; i < corps->nb_child; i ++)
	{
		int tmp_min = -1;
		Corps *get_corps = Corps_GetNearest(corps->child[i], x-corps->cercle.centre.x, y-corps->cercle.centre.y, &tmp_min);
		if(tmp_min != -1 && (*dmin == -1 || tmp_min < *dmin))
		{
			res = get_corps;
			*dmin = tmp_min;
		}
	}
	return res;
}

int Corps_GetXY(Corps *corps, Corps *main_corps, int *x, int *y)
{
	if(main_corps == NULL)
		return 0;
	if(corps == main_corps)
	{
		*x += corps->cercle.centre.x;
		*y += corps->cercle.centre.y;
		return 1;
	}
	int i;
	for(i = 0; i < main_corps->nb_child; i ++)
	{
		if(Corps_GetXY(corps, main_corps->child[i], x, y))
		{
			*x += main_corps->cercle.centre.x;
			*y += main_corps->cercle.centre.y;
			return 1;
		}
	}
	return 0;
}

int Avatar_MakeSelection(Avatar *ava, int x, int y)
{
	x -= ava->x;
	y -= ava->y;
	/*if(x < 0 || y < 0)
	{
		ava->choix_selection = ASI_None;
		return 0;
	}*/
	int dv = -1;
	Visage *vis = Visage_GetNearest(ava->visage, x, y, &dv);
	int dyd = -1;
	int dyg = -1;
	int dsd = -1;
	int dsg = -1;
	int dn = -1;
	int dod = -1;
	int dog = -1;
	int dcd = -1;
	int dcg = -1;
	int dc = -1;
	int db = Bouche_Dist(ava->bouche, x, y);
	Yeux *yeuxd = Yeux_GetNearest(ava->oeil_droit, x, y, &dyd);
	Yeux *yeuxg = Yeux_GetNearest(ava->oeil_gauche, x, y, &dyg);
	Yeux *sourd = Yeux_GetNearest(ava->sourcil_droit, x, y, &dsd);
	Yeux *sourg = Yeux_GetNearest(ava->sourcil_gauche, x, y, &dsg);
	Yeux *nez = Yeux_GetNearest(ava->nez, x, y, &dn);
	Yeux *ored = Yeux_GetNearest(ava->oreille_droite, x, y, &dod);
	Yeux *oreg = Yeux_GetNearest(ava->oreille_gauche, x, y, &dog);
	Cheveux *chevd = Cheveux_GetNearest(ava->cheveux_droite, x, y, &dcd);
	Cheveux *chevg = Cheveux_GetNearest(ava->cheveux_gauche, x, y, &dcg);
	Corps *corps = Corps_GetNearest(ava->corps, x+ava->x-ava->corps->cercle.centre.x, y+ava->y-ava->corps->cercle.centre.y, &dc);
	int dcur = -1;
	if(dv != -1)
	{
		dcur = dv;
		ava->choix_selection = ASI_Visage;
		ava->selection.visage = vis;
	}
	if(dyd != -1 && (dyd < dcur || dcur == -1))
	{
		dcur = dyd;
		ava->choix_selection = ASI_Oeil_Droit;
		ava->selection.yeux = yeuxd;
	}
	if(dyg != -1 && (dyg < dcur || dcur == -1))
	{
		dcur = dyg;
		ava->choix_selection = ASI_Oeil_Gauche;
		ava->selection.yeux = yeuxg;
	}
	if(dsd != -1 && (dsd < dcur || dcur == -1))
	{
		dcur = dsd;
		ava->choix_selection = ASI_Sourcil_Droit;
		ava->selection.yeux = sourd;
	}
	if(dsg != -1 && (dsg < dcur || dcur == -1))
	{
		dcur = dsg;
		ava->choix_selection = ASI_Sourcil_Gauche;
		ava->selection.yeux = sourg;
	}
	if(dn != -1 && (dn < dcur || dcur == -1))
	{
		dcur = dn;
		ava->choix_selection = ASI_Nez;
		ava->selection.yeux = nez;
	}
	if(dod != -1 && (dod < dcur || dcur == -1))
	{
		dcur = dod;
		ava->choix_selection = ASI_Oreille_Droite;
		ava->selection.yeux = ored;
	}
	if(dog != -1 && (dog < dcur || dcur == -1))
	{
		dcur = dog;
		ava->choix_selection = ASI_Oreille_Gauche;
		ava->selection.yeux = oreg;
	}
	if(db != -1 && (db < dcur || dcur == -1))
	{
		dcur = db;
		ava->choix_selection = ASI_Bouche;
	}
	if(dcd != -1 && (dcd < dcur || dcur == -1))
	{
		dcur = dcd;
		ava->choix_selection = ASI_Cheveux_Droite;
		ava->selection.cheveux = chevd;
	}
	if(dcg != -1 && (dcg < dcur || dcur == -1))
	{
		dcur = dcg;
		ava->choix_selection = ASI_Cheveux_Gauche;
		ava->selection.cheveux = chevg;
	}
	if(dc != -1 && (dc < dcur || dcur == -1))
	{
		dcur = dc;
		ava->choix_selection = ASI_Corps;
		ava->selection.corps = corps;
	}
	if(dcur == -1)
	{
		ava->choix_selection = ASI_None;
		return 0;
	}
	return 1;
}

int Avatar_Move(Avatar *ava, int x, int y)
{
	if(ava->choix_selection != ASI_Corps)
	{
		x -= ava->x;
		y -= ava->y;
		ava->modified = 1;
	}
	switch(ava->choix_selection)
	{
		case ASI_Visage:
		return Visage_MoveTo(ava->selection.visage, ava->visage, x, y, ava->visage_size);
		case ASI_Oeil_Droit:
		case ASI_Oeil_Gauche:
		return Avatar_Yeux_MoveTo(ava, x, y);
		case ASI_Sourcil_Droit:
		case ASI_Sourcil_Gauche:
		return Avatar_Sourcil_MoveTo(ava, x, y);
		case ASI_Nez:
		return Avatar_Nez_MoveTo(ava, x, y);
		case ASI_Bouche:
		return Avatar_Bouche_MoveTo(ava, x, y);
		case ASI_Oreille_Droite:
		case ASI_Oreille_Gauche:
		return Avatar_Oreille_MoveTo(ava, x, y);
		case ASI_Cheveux_Droite:
		case ASI_Cheveux_Gauche:
		return Avatar_Cheveux_MoveTo(ava, x, y);
		case ASI_Corps:
		return Avatar_Corps_MoveTo(ava, x, y);
		default:
		return 0;
	}
}

int Avatar_Scale(Avatar *ava, int add_scale)
{
	ava->modified = 1;
	switch(ava->choix_selection)
	{
		case ASI_Visage:
		return Visage_Scale(ava->selection.visage, ava->visage, add_scale, ava->visage_size);
		case ASI_Oeil_Droit:
		case ASI_Oeil_Gauche:
		return Avatar_Yeux_Scale(ava, add_scale/5);
		case ASI_Sourcil_Droit:
		case ASI_Sourcil_Gauche:
		return Avatar_Sourcil_Scale(ava, add_scale/5);
		case ASI_Nez:
		return Avatar_Nez_Scale(ava, add_scale/5);
		case ASI_Bouche:
		return Avatar_Bouche_Scale(ava, add_scale/5);
		case ASI_Oreille_Droite:
		case ASI_Oreille_Gauche:
		return Avatar_Oreille_Scale(ava, add_scale/5);
		case ASI_Cheveux_Droite:
		{
			Cheveux *oposite = Cheveux_GetOposite(ava->cheveux_droite, ava->cheveux_gauche, ava->selection.cheveux);
			if(add_scale > 0)
			{
				Cheveux_AjoutBefore(&(ava->cheveux_droite), ava->selection.cheveux, ava->selection.cheveux->centre);
				Cheveux_AjoutBefore(&(ava->cheveux_gauche), oposite, oposite->centre);
				return 1;
			}
			else
			{
				Cheveux_Remove(&(ava->cheveux_droite), &(ava->selection.cheveux));
				Cheveux_Remove(&(ava->cheveux_gauche), &oposite);
				ava->choix_selection = ASI_None;
				return 1;
			}
		}
		case ASI_Corps:
		return Avatar_Corps_Scale(ava, add_scale);
		default:
		return 0;
	}
}

void Avatar_FullMoveTo(Avatar *ava, int x, int y)
{
	ava->x = x;
	ava->y = y;
	ava->corps->cercle.centre.x = x;
	ava->corps->cercle.centre.y = y;
}
