#ifndef DEF_HEADER_AVATAR_FILE
#define DEF_HEADER_AVATAR_FILE

#include "avatar_affichage.h"

/*
* est le type choisi
Les fonctions *_Save sauvegardent une structure dans un FILE* choisi
Les fonctions *_Load récupèrent une structure dans une FILE* choisi
*/

void Point_Save(Point p, FILE *flux);
/*
	Sauvegarde un point dans un FILE
	ARGS:
		- Point p : Point à sauvegarder
		- FILE *flux : flux dans lequel on écrit le point
*/

void Cercle_Save(Cercle c, FILE *flux);
/*
	Sauvegarde un cercle dans un FILE
	ARGS:
		- Cercle c : Cercle à sauvegarder
		- FILE *flux : flux dans lequel on écrit le cercle
*/

void Visage_Save(Visage *vis, FILE *flux);
/*
	Sauvegarde un visage dans un FILE
	ARGS:
		- Visage *vis : Visage à sauvegarder
		- FILE *flux : flux dans lequel on écrit le visage
*/

void Yeux_Save(Yeux *yeux, FILE *flux);
/*
	Sauvegarde un oeil dans un FILE
	ARGS:
		- Yeux *yeux : Yeux à sauvegarder
		- FILE *flux : flux dans lequel on écrit l'oeil
*/

void Cheveux_Save(Cheveux *chev, FILE *flux);
/*
	Sauvegarde un polygone dans un FILE
	ARGS:
		- Cheveux *chev : Cheveux à sauvegarder
		- FILE *flux : flux dans lequel on écrit le polygone
*/

void MLV_Color_Save(MLV_Color couleur, FILE *flux);
/*
	Sauvegarde une couleur dans un FILE
	ARGS:
		- MLV_Color couleur : MLV_Color à sauvegarder
		- FILE *flux : flux dans lequel on écrit la couleur
*/

void Corps_Save(Corps *corps, FILE *flux);
/*
	Sauvegarde un corps dans un FILE
	ARGS:
		- Corps *corps : Corps à sauvegarder
		- FILE *flux : flux dans lequel on écrit le corps
*/

int Avatar_Save(Avatar *ava, const char *file_name);
/*
	Sauvegarde un avatar dans un FILE
	ARGS:
		- Avatar *ava : Avatar à sauvegarder
		- FILE *flux : flux dans lequel on écrit l'avatar
*/

Point Point_Load(FILE *flux);
/*
	Charge un point depuis un FILE
	ARGS:
		- FILE *flux : flux dans lequel on lit le point
	RETURN:
		- Point chargé
*/

Cercle Cercle_Load(FILE *flux);
/*
	Charge un cercle depuis un FILE
	ARGS:
		- FILE *flux : flux dans lequel on lit le cercle
	RETURN:
		- Cercle chargé
*/

void Visage_Load(Visage *vis, FILE *flux);
/*
	Charge un visage depuis un FILE
	ARGS:
		- Visage *vis : Visage chargé
		- FILE *flux : flux dans lequel on lit le visage
*/

void Yeux_Load(Yeux *yeux, FILE *flux);
/*
	Charge un oeil depuis un FILE
	ARGS:
		- Yeux *yeux : Visage chargé
		- FILE *flux : flux dans lequel on lit l'oeil
*/

void Cheveux_Load(Cheveux **chev, FILE *flux);
/*
	Charge un polygone depuis un FILE
	ARGS:
		- Cheveux **chev : Cheveux chargé
		- FILE *flux : flux dans lequel on lit le polygone
*/

MLV_Color MLV_Color_Load(FILE *flux);
/*
	Charge une couleur depuis un FILE
	ARGS:
		- FILE *flux : flux dans lequel on lit la couleur
	RETURN:
		- MLV_Color chargé
*/

void Corps_Load(Corps *corps, FILE *flux);
/*
	Charge un corps depuis un FILE
	ARGS:
		- Corps *corps : Corps chargé
		- FILE *flux : flux dans lequel on lit le corps
*/


int Avatar_Load(Avatar *ava, const char *file_name);
/*
	Charge un avatar depuis un FILE
	ARGS:
		- Avatar *ava : Cheveux chargé
		- const char *file_name : nom du fichier dans depuis lequel on va charger l'avatar
	RETURN:
		- 0 si rien n'a pu être chargé (n'est pas un fichier de type avatar pour le projet Three to go)
		- 1 si l'avatar a pu être chargé
*/

#endif
