#include "avatar_resize.h"

Point Point_Resize(Point p, double size)
{
	p.x = (int)(p.x*size);
	p.y = (int)(p.y*size);
	return p;
}

Cercle Cercle_Resize(Cercle c, double size)
{
	c.centre = Point_Resize(c.centre, size);
	c.rayon = (int)(c.rayon*size);
	return c;
}

void Visage_Resize(Visage *vis, double size)
{
	Visage *first = vis;
	do
	{
		vis->cercle = Cercle_Resize(vis->cercle, size);
		vis = vis->next;
	}while(vis != first);
}

void Yeux_Resize(Yeux *yeux, double size)
{
	while(yeux != NULL)
	{
		yeux->cercle = Cercle_Resize(yeux->cercle, size);
		yeux = yeux->next;
	}
}

void Cheveux_Resize(Cheveux *chev, double size)
{
	while(chev != NULL)
	{
		chev->centre = Point_Resize(chev->centre, size);
		chev = chev->next;
	}
}

void Corps_Resize(Corps *corps, double size)
{
	if(corps != NULL)
	{
		corps->cercle = Cercle_Resize(corps->cercle, size);
		int i;
		for(i = 0; i < corps->nb_child; i ++)
		{
			Corps_Resize(corps->child[i], size);
		}
	}
}

void Avatar_Resize(Avatar *ava, double size)
{
	int d = (int)((1.0-size)*ava->visage_size);
	Visage_Resize(ava->visage, size);
	Yeux_Resize(ava->oeil_droit, size);
	Yeux_Resize(ava->oeil_gauche, size);
	Yeux_Resize(ava->sourcil_droit, size);
	Yeux_Resize(ava->sourcil_gauche, size);
	Yeux_Resize(ava->nez, size);
	Yeux_Resize(ava->oreille_droite, size);
	Yeux_Resize(ava->oreille_gauche, size);
	ava->bouche = Cercle_Resize(ava->bouche, size);
	Cheveux_Resize(ava->cheveux_droite, size);
	Cheveux_Resize(ava->cheveux_gauche, size);
	ava->corps->cercle.centre.y = ava->corps->cercle.centre.y-ava->y;
	Corps_Resize(ava->corps, size);
	ava->corps->cercle.centre.y = ava->corps->cercle.centre.y+ava->y-d/8;
	ava->visage_size = ava->visage_size*size;
	ava->x = ava->x + d/2;
	ava->corps->cercle.centre.x = ava->x-d/2;
	ava->modified = 1;
}

void Avatar_ResizeTo(Avatar *ava, int width)
{
	Avatar_Resize(ava, ((double)width)/((double)ava->visage_size));
}
