#ifndef DEF_HEADER_AVATAR_RESIZE
#define DEF_HEADER_AVATAR_RESIZE

#include "avatar_edit.h"

Point Point_Resize(Point p, double size);
/*
	Permet de redimensionner un point selon un certain agrandissement
	ARGS:
		- Point p : Point dont on veut l'agrandissement
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
	RETURN:
		- Point redimensionné
*/

Cercle Cercle_Resize(Cercle c, double size);
/*
	Permet de redimensionner un cercle selon un certain agrandissement
	ARGS:
		- Cercle c : Cercle dont on veut l'agrandissement
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
	RETURN:
		- Cercle redimensionné
*/

void Visage_Resize(Visage *vis, double size);
/*
	Permet de redimensionner un visage selon un certain agrandissement
	ARGS:
		- Visage *vis : Visage que l'on veut agrandir
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
*/

void Yeux_Resize(Yeux *yeux, double size);
/*
	Permet de redimensionner un oeil selon un certain agrandissement
	ARGS:
		- Yeux *yeux : Yeux que l'on veut agrandir
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
*/

void Cheveux_Resize(Cheveux *chev, double size);
/*
	Permet de redimensionner un polygone selon un certain agrandissement
	ARGS:
		- Cheveux *chev : Cheveux que l'on veut agrandir
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
*/

void Corps_Resize(Corps *corps, double size);
/*
	Permet de redimensionner un corps selon un certain agrandissement
	ARGS:
		- Corps *corps : Corps que l'on veut agrandir
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
*/

void Avatar_Resize(Avatar *ava, double size);
/*
	Permet de redimensionner un avatar selon un certain agrandissement
	ARGS:
		- Avatar *ava : Avatar que l'on veut agrandir
		- double size : taille relative de l'agrandissement (1 pour conserver la même taille)
*/

void Avatar_ResizeTo(Avatar *ava, int width);
/*
	Permet de redimensionner un avatar pour qu'il fasse une certaine taille
	ARGS:
		- Avatar *ava : Avatar que l'on veut agrandir
		- int width : taille à laquelle on veut la largeur du visage
*/

#endif
