#include "avatar_struct.h"

Corps *Corps_Create(Cercle c)
{
	Corps *corps = NULL;
	if((corps = (Corps*)malloc(sizeof(Corps))) == NULL)
		return NULL;
	corps->nb_child = 0;
	corps->x_min = 0;
	corps->x_max = 0;
	corps->y_min = 0;
	corps->y_max = 0;
	corps->parent_part = 1;
	corps->child = NULL;
	corps->parent = NULL;
	corps->rotate = 0;
	return corps;
}

int Corps_DefChild(Corps *corps, int nb_child)
{
	if(nb_child <= 0)
		return 0;
	if((corps->child = (Corps**)malloc(nb_child*sizeof(Corps*))) == NULL)
		return 0;
	Cercle c={{0, 0}, 0};
	int i = 0;
	for(i = 0; i < nb_child; i ++)
	{
		if((corps->child[i] = Corps_Create(c)) == NULL)
			return 0;
		corps->child[i]->parent = corps;
	}
	corps->nb_child = nb_child;
	corps->couleur = MLV_rgba(255, 255, 255, 255);
	return 1;
}

void Corps_DefPart(Corps *corps, int x, int y, int rayon, int min_x, int min_y, int max_x, int max_y, double min_ray, double max_ray)
{
	corps->cercle.centre.x = x;
	corps->cercle.centre.y = y;
	corps->cercle.rayon = rayon;
	corps->x_min = min_x;
	corps->y_min = min_y;
	corps->x_max = max_x;
	corps->y_max = max_y;
	if(min_ray <= 0)
		corps->ray_min = rayon;
	else
		corps->ray_min = (int)(((double)rayon)*min_ray);
	if(max_ray <= 0)
		corps->ray_max = rayon;
	else
		corps->ray_max = (int)(((double)rayon)*max_ray);
	if(min_x == 0 && max_x == 0)
	{
		corps->x_min = x;
		corps->x_max = x;
	}
	if(min_y == 0 && max_y == 0)
	{
		corps->y_min = y;
		corps->y_max = y;
	}
}

void Corps_SetColor(Corps *corps, MLV_Color couleur)
{
	if(corps != NULL)
	{
		corps->couleur = couleur;
		int i;
		for(i = 0; i < corps->nb_child; i ++)
		{
			if(corps->child[i]->parent_part)
				Corps_SetColor(corps->child[i], couleur);
		}
	}
}

Corps *Corps_CreateHuman(int x, int y, int size_x, int size_y)
{
	Cercle c = {{x, y}, 0};
	Corps *corps = Corps_Create(c);
	Corps_DefPart(CORPS_COU(corps), x, y, size_x/16, 0, 0, 0, 0, -1, -1);
	Corps_DefChild(CORPS_COU(corps), 1);
	CORPS_BUSTE(corps)->parent_part = 0;
	
	Corps_DefPart(CORPS_BUSTE(corps), 0, size_y/4, size_x/6, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_BUSTE(corps), 3);
	Corps_DefPart(CORPS_EPAULE_D(corps), -size_x/4, 0, size_x/16, -size_x/4, 0, -size_x/5, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_EPAULE_D(corps), 1);
	Corps_DefPart(CORPS_BRAS_D(corps), 0, size_y/6, size_x/16, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_BRAS_D(corps), 1);
	Corps_DefPart(CORPS_AVB_D(corps), 0, size_y/6, size_x/16, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_AVB_D(corps), 1);
	Corps_DefPart(CORPS_MAIN_D(corps), 0, size_y/8, size_x/20, 0, 0, 0, 0, 0.5, 1.5);
	CORPS_MAIN_D(corps)->parent_part = 0;
	
	Corps_DefPart(CORPS_EPAULE_G(corps), size_x/4, 0, size_x/16, size_x/5, 0, size_x/4, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_EPAULE_G(corps), 1);
	Corps_DefPart(CORPS_BRAS_G(corps), 0, size_y/6, size_x/16, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_BRAS_G(corps), 1);
	Corps_DefPart(CORPS_AVB_G(corps), 0, size_y/6, size_x/16, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_AVB_G(corps), 1);
	Corps_DefPart(CORPS_MAIN_G(corps), 0, size_y/8, size_x/20, 0, 0, 0, 0, 0.5, 1.5);
	CORPS_MAIN_G(corps)->parent_part = 0;
	
	Corps_DefPart(CORPS_VENTRE(corps), 0, size_y/6, size_x/6, 0, 0, 0, 0, 0.75, 1.25);
	Corps_DefChild(CORPS_VENTRE(corps), 1);
	Corps_DefPart(CORPS_BASSIN(corps), 0, size_y/6, size_x/8, 0, 0, 0, 0, -1, 1.25);
	Corps_DefChild(CORPS_BASSIN(corps), 2);
	CORPS_BASSIN(corps)->parent_part = 0;
	
	Corps_DefPart(CORPS_CUISSE_D(corps), -size_x/14, size_y/4, size_x/16, -size_x/8, 0, -size_x/16, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_CUISSE_D(corps), 1);
	Corps_DefPart(CORPS_TIBIA_D(corps), 0, size_y/6, size_x/16, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_TIBIA_D(corps), 1);
	Corps_DefPart(CORPS_PIED_D(corps), 0, size_y/8, size_x/20, 0, 0, 0, 0, 0.5, 1.5);
	CORPS_PIED_D(corps)->parent_part = 0;
	
	Corps_DefPart(CORPS_CUISSE_G(corps), size_x/14, size_y/4, size_x/16, size_x/16, 0, size_x/8, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_CUISSE_G(corps), 1);
	Corps_DefPart(CORPS_TIBIA_G(corps), 0, size_y/6, size_x/16, 0, 0, 0, 0, 0.5, 1.5);
	Corps_DefChild(CORPS_TIBIA_G(corps), 1);
	Corps_DefPart(CORPS_PIED_G(corps), 0, size_y/8, size_x/20, 0, 0, 0, 0, 0.5, 1.5);
	CORPS_PIED_G(corps)->parent_part = 0;
	
	Corps_SetColor(CORPS_COU(corps), MLV_rgba(255, 255, 255, 255));
	Corps_SetColor(CORPS_MAIN_D(corps), MLV_rgba(255, 255, 255, 255));
	Corps_SetColor(CORPS_MAIN_G(corps), MLV_rgba(255, 255, 255, 255));
	Corps_SetColor(CORPS_BUSTE(corps), MLV_rgba(106, 144, 181, 255));
	Corps_SetColor(CORPS_BASSIN(corps), MLV_rgba(50, 80, 107, 255));
	Corps_SetColor(CORPS_PIED_D(corps), MLV_rgba(107, 75, 50, 255));
	Corps_SetColor(CORPS_PIED_G(corps), MLV_rgba(107, 75, 50, 255));
	
	return corps;
}

void Corps_Free(Corps **corps)
{
	if(*corps != NULL)
	{
		int i;
		for(i = 0; i < (*corps)->nb_child; i ++)
			Corps_Free(&((*corps)->child[i]));
		if((*corps)->child != NULL)
			free((*corps)->child);
		free(*corps);
		*corps = NULL;
	}
}

MLV_Color Color_To_MLV_Color(Color couleur)
{
	return MLV_rgba(couleur.r, couleur.g, couleur.b, couleur.a);
}

Color MLV_Color_To_Color(MLV_Color couleur)
{
	Uint8 r, g, b, a;
	MLV_convert_color_to_rgba(couleur, &r, &g, &b, &a);
	Color new_couleur;
	new_couleur.r = r;
	new_couleur.g = g;
	new_couleur.b = b;
	new_couleur.a = a;
	return new_couleur;
}

MLV_Color MLV_Color_Mix(int nb_color, ...)
{
	Color tmp;
	Color final = {0, 0, 0, 0};
	int value;
	int i = 0;
	int somme = 0;
	va_list ap;
	va_start(ap, nb_color);
	for(i = 0; i < nb_color; i ++)
	{
		tmp = MLV_Color_To_Color(va_arg(ap, MLV_Color));
		somme += (value = va_arg(ap, int));
		final.r += tmp.r*value;
		final.g += tmp.g*value;
		final.b += tmp.b*value;
		final.a += tmp.a*value;
	}
	va_end(ap);
	if(somme <= 0)
		return MLV_rgba(0, 0, 0, 255);
	final.r = final.r/somme;
	final.g = final.g/somme;
	final.b = final.b/somme;
	final.a = final.a/somme;
	return Color_To_MLV_Color(final);
}

Visage *Visage_AllouePart(Cercle c)
{
	Visage *vis = NULL;
	if((vis = (Visage*)malloc(sizeof(Visage))) == NULL)
		return NULL;
	vis->cercle = c;
	vis->next = vis;
	vis->prev = vis;
	return vis;
}

Visage *Visage_Create()
{
	Visage *vis = NULL;
	Visage *ajout = NULL;
	Cercle c = {{0, 0}, 0};
	int i;
	for(i = 0; i < 5; i ++)
	{
		ajout = NULL;
		if((ajout = Visage_AllouePart(c)) == NULL)
			return NULL;
		if(vis == NULL)
			vis = ajout;
		else
		{
			ajout->next = vis->next;
			ajout->prev = vis;
			vis->next->prev = ajout;
			vis->next = ajout;
		}
	}
	//VISAGE_MENTON_DROITE(vis)->link_with_next = 0;
	return vis;
}

void Visage_Free(Visage **vis)
{
	if(*vis != NULL)
	{
		if((*vis)->next != NULL)
			(*vis)->next->prev = NULL;
		if((*vis)->prev != NULL)
			(*vis)->prev->next = NULL;
		Visage_Free(&((*vis)->next));
		free(*vis);
		*vis = NULL;
	}
}

Yeux *Yeux_AllouePart(Cercle c)
{
	Yeux *yeux = NULL;
	if((yeux = (Yeux*)malloc(sizeof(Yeux))) == NULL)
		return NULL;
	yeux->next = NULL;
	return yeux;
}

Yeux *Yeux_Create(int nb)
{
	Yeux *yeux = NULL;
	Yeux *ajout = NULL;
	Cercle c = {{0, 0}, 0};
	int i;
	for(i = 0; i < nb; i ++)
	{
		ajout = NULL;
		if((ajout = Yeux_AllouePart(c)) == NULL)
			return NULL;
		if(yeux == NULL)
			yeux = ajout;
		else
		{
			ajout->next = yeux;
			yeux = ajout;
		}
	}
	return yeux;
}

void Yeux_Free(Yeux **yeux)
{
	if(*yeux != NULL)
	{
		Yeux_Free(&((*yeux)->next));
		free(*yeux);
		*yeux = NULL;
	}
}

Cheveux *Cheveux_AllouePart(Point p)
{
	Cheveux *chev = NULL;
	if((chev = (Cheveux*)malloc(sizeof(Cheveux))) == NULL)
		return NULL;
	chev->centre = p;
	chev->next = NULL;
	return chev;
}

int Cheveux_AjoutBefore(Cheveux **chev, Cheveux *indice, Point p)
{
	Cheveux *ajout = NULL;
	if((ajout = Cheveux_AllouePart(p)) == NULL)
		return 0;
	if(*chev == NULL || indice == *chev)
	{
		ajout->next = *chev;
		*chev = ajout;
		return 1;
	}
	Cheveux *cur = *chev;
	while(cur->next != indice)
		cur = cur->next;
	ajout->next = cur->next;
	cur->next = ajout;
	return 1;
}

int Cheveux_Remove(Cheveux **chev, Cheveux **indice)
{
	if(*chev == NULL || *indice == NULL)
		return 0;
	if(*indice == *chev)
	{
		*chev = (*chev)->next;
	}
	else
	{
		Cheveux *cur = *chev;
		while(cur->next != *indice)
			cur = cur->next;
		cur->next = cur->next->next;
	}
	free(*indice);
	*indice = NULL;
	return 1;
}

Cheveux *Cheveux_Create(int nb)
{
	Cheveux *chev = NULL;
	int i;
	Point p = {0, 0};
	for(i = 0; i < nb; i ++)
		Cheveux_AjoutBefore(&chev, chev, p);
	return chev;
}

void Cheveux_Free(Cheveux **chev)
{
	if(*chev != NULL)
	{
		Cheveux_Free(&((*chev)->next));
		free(*chev);
		*chev = NULL;
	}
}

void Visage_Init(Visage *vis, int size)
{
	VISAGE_CRANE(vis)->cercle.rayon = (size*5)/16;
	VISAGE_CRANE(vis)->cercle.centre.x = size/2;
	VISAGE_CRANE(vis)->cercle.centre.y = size/3;
	
	VISAGE_MACHOIRE_GAUCHE(vis)->cercle.rayon = size/8;
	VISAGE_MACHOIRE_GAUCHE(vis)->cercle.centre.x = size/2-(size*3)/16;
	VISAGE_MACHOIRE_GAUCHE(vis)->cercle.centre.y = (size*3)/5;
	
	VISAGE_MACHOIRE_DROITE(vis)->cercle.rayon = size/8;
	VISAGE_MACHOIRE_DROITE(vis)->cercle.centre.x = size/2+(size*3)/16;
	VISAGE_MACHOIRE_DROITE(vis)->cercle.centre.y = (size*3)/5;
	
	VISAGE_MENTON_GAUCHE(vis)->cercle.rayon = size/16;
	VISAGE_MENTON_GAUCHE(vis)->cercle.centre.x = size/2-size/16;
	VISAGE_MENTON_GAUCHE(vis)->cercle.centre.y = (size*4)/5;
	
	VISAGE_MENTON_DROITE(vis)->cercle.rayon = size/16;
	VISAGE_MENTON_DROITE(vis)->cercle.centre.x = size/2+size/16;
	VISAGE_MENTON_DROITE(vis)->cercle.centre.y = (size*4)/5;
}

Avatar *Avatar_Create()
{
	Avatar *ava = NULL;
	if((ava = (Avatar*)malloc(sizeof(Avatar))) == NULL)
		return NULL;
	ava->visage_size = 0;
	ava->visage = Visage_Create();
	ava->oeil_droit = Yeux_Create(3);
	ava->oeil_gauche = Yeux_Create(3);
	ava->sourcil_droit = Yeux_Create(4);
	ava->sourcil_gauche = Yeux_Create(4);
	ava->nez = Yeux_Create(3);
	ava->oreille_droite = Yeux_Create(3);
	ava->oreille_gauche = Yeux_Create(3);
	ava->cheveux_droite = Cheveux_Create(6);
	ava->cheveux_gauche = Cheveux_Create(6);
	ava->corps = NULL;
	ava->couleur_peau = MLV_rgba(207, 160, 117, 255);
	ava->couleur_yeux = MLV_rgba(116, 65, 27, 255);
	ava->couleur_poils = MLV_rgba(66, 31, 17, 255);
	ava->choix_selection = ASI_None;
	ava->tete = NULL;
	ava->modified = 0;
	return ava;
}

void Avatar_Init(Avatar *ava, int x, int y, int visage_size, int corps_size)
{
	ava->x = x;
	ava->y = y;
	ava->visage_size = visage_size;
	Visage_Init(ava->visage, visage_size);
	YEUX_INTERNE(ava->oeil_droit)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y;
	YEUX_INTERNE(ava->oeil_gauche)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y;
	YEUX_INTERNE(ava->oeil_droit)->cercle.centre.x = (visage_size*9)/16;
	YEUX_INTERNE(ava->oeil_gauche)->cercle.centre.x = (visage_size*7)/16;
	YEUX_INTERNE(ava->oeil_droit)->cercle.rayon = visage_size/80;
	YEUX_INTERNE(ava->oeil_gauche)->cercle.rayon = YEUX_INTERNE(ava->oeil_droit)->cercle.rayon;
	
	YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y;
	YEUX_MIDDLE(ava->oeil_gauche)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y;
	YEUX_MIDDLE(ava->oeil_droit)->cercle.centre.x = (visage_size*5)/8;
	YEUX_MIDDLE(ava->oeil_gauche)->cercle.centre.x = (visage_size*3)/8;
	YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon = visage_size/40;
	YEUX_MIDDLE(ava->oeil_gauche)->cercle.rayon = YEUX_MIDDLE(ava->oeil_droit)->cercle.rayon;
	
	YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y;
	YEUX_EXTERNE(ava->oeil_gauche)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y;
	YEUX_EXTERNE(ava->oeil_droit)->cercle.centre.x = (visage_size*11)/16;
	YEUX_EXTERNE(ava->oeil_gauche)->cercle.centre.x = (visage_size*5)/16;
	YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon = visage_size/80;
	YEUX_EXTERNE(ava->oeil_gauche)->cercle.rayon = YEUX_EXTERNE(ava->oeil_droit)->cercle.rayon;
	
	NEZ_GAUCHE(ava->nez)->cercle.centre.x = (visage_size/2)-(visage_size/32);
	NEZ_GAUCHE(ava->nez)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y+((VISAGE_CRANE(ava->visage)->cercle.rayon*2)/3);
	NEZ_GAUCHE(ava->nez)->cercle.rayon = (visage_size/64);
	
	NEZ_MIDDLE(ava->nez)->cercle.centre.x = (visage_size/2);
	NEZ_MIDDLE(ava->nez)->cercle.centre.y = NEZ_GAUCHE(ava->nez)->cercle.centre.y+(visage_size/128);
	NEZ_MIDDLE(ava->nez)->cercle.rayon = NEZ_GAUCHE(ava->nez)->cercle.rayon;
	
	NEZ_DROITE(ava->nez)->cercle.centre.x = (visage_size/2)+(visage_size/32);
	NEZ_DROITE(ava->nez)->cercle.centre.y = NEZ_GAUCHE(ava->nez)->cercle.centre.y;
	NEZ_DROITE(ava->nez)->cercle.rayon = NEZ_GAUCHE(ava->nez)->cercle.rayon;
	
	ava->bouche.centre.x = visage_size/2;
	ava->bouche.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y+VISAGE_CRANE(ava->visage)->cercle.rayon;
	ava->bouche.rayon = visage_size/16;
	
	OREILLE_HAUT(ava->oreille_droite)->cercle.centre.x = (visage_size/2)+VISAGE_CRANE(ava->visage)->cercle.rayon+(visage_size/64);
	OREILLE_HAUT(ava->oreille_gauche)->cercle.centre.x = (visage_size/2)-VISAGE_CRANE(ava->visage)->cercle.rayon-(visage_size/64);
	OREILLE_HAUT(ava->oreille_droite)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y-(visage_size/96);
	OREILLE_HAUT(ava->oreille_gauche)->cercle.centre.y = OREILLE_HAUT(ava->oreille_droite)->cercle.centre.y;
	OREILLE_HAUT(ava->oreille_droite)->cercle.rayon = (visage_size/32);
	OREILLE_HAUT(ava->oreille_gauche)->cercle.rayon = OREILLE_HAUT(ava->oreille_droite)->cercle.rayon;
	
	OREILLE_MID(ava->oreille_droite)->cercle.centre.x = (visage_size/2)+VISAGE_CRANE(ava->visage)->cercle.rayon;
	OREILLE_MID(ava->oreille_gauche)->cercle.centre.x = (visage_size/2)-VISAGE_CRANE(ava->visage)->cercle.rayon;
	OREILLE_MID(ava->oreille_droite)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y+(visage_size/12);
	OREILLE_MID(ava->oreille_gauche)->cercle.centre.y = OREILLE_MID(ava->oreille_droite)->cercle.centre.y;
	OREILLE_MID(ava->oreille_droite)->cercle.rayon = (visage_size/96);
	OREILLE_MID(ava->oreille_gauche)->cercle.rayon = OREILLE_MID(ava->oreille_droite)->cercle.rayon;
	
	OREILLE_BAS(ava->oreille_droite)->cercle.centre.x = (visage_size/2)+VISAGE_CRANE(ava->visage)->cercle.rayon+(visage_size/96);
	OREILLE_BAS(ava->oreille_gauche)->cercle.centre.x = (visage_size/2)-VISAGE_CRANE(ava->visage)->cercle.rayon-(visage_size/96);
	OREILLE_BAS(ava->oreille_droite)->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y+(visage_size/8);
	OREILLE_BAS(ava->oreille_gauche)->cercle.centre.y = OREILLE_BAS(ava->oreille_droite)->cercle.centre.y;
	OREILLE_BAS(ava->oreille_droite)->cercle.rayon = (visage_size/64);
	OREILLE_BAS(ava->oreille_gauche)->cercle.rayon = OREILLE_BAS(ava->oreille_droite)->cercle.rayon;
	
	Yeux *cur_d = ava->sourcil_droit;
	Yeux *cur_g = ava->sourcil_gauche;
	int i = 0;
	while(cur_d != NULL)
	{
		if(cur_d == SOURCILS_INTERNE(ava->sourcil_droit))
			cur_d->cercle.rayon = visage_size/120;
		else if(cur_d == SOURCILS_EXTERNE(ava->sourcil_droit))
			cur_d->cercle.rayon = visage_size/80;
		else
			cur_d->cercle.rayon = visage_size/100;
		cur_g->cercle.rayon = cur_d->cercle.rayon;
		cur_d->cercle.centre.x = (visage_size/2)+((visage_size*(i+1))/18);
		cur_g->cercle.centre.x = (visage_size/2)-((visage_size*(i+1))/18);
		cur_d->cercle.centre.y = VISAGE_CRANE(ava->visage)->cercle.centre.y-(visage_size/32)-((visage_size*((i+1)/2))/100);
		cur_g->cercle.centre.y = cur_d->cercle.centre.y;
		cur_d = cur_d->next;
		cur_g = cur_g->next;
		i ++;
	}
	
	{
		Point d[]={	{visage_size/2, VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/2)},
				{visage_size/2, VISAGE_CRANE(ava->visage)->cercle.centre.y-((VISAGE_CRANE(ava->visage)->cercle.rayon*11)/10)},
				{visage_size/2+((VISAGE_CRANE(ava->visage)->cercle.rayon*11)/10), VISAGE_CRANE(ava->visage)->cercle.centre.y-VISAGE_CRANE(ava->visage)->cercle.rayon},
				{visage_size/2+VISAGE_CRANE(ava->visage)->cercle.rayon, VISAGE_CRANE(ava->visage)->cercle.centre.y},
				{visage_size/2+((VISAGE_CRANE(ava->visage)->cercle.rayon*9)/10), VISAGE_CRANE(ava->visage)->cercle.centre.y},
				{visage_size/2+((VISAGE_CRANE(ava->visage)->cercle.rayon*9)/10), VISAGE_CRANE(ava->visage)->cercle.centre.y-(VISAGE_CRANE(ava->visage)->cercle.rayon/3)}};
		Point g[6];
		Cheveux *cur_d = ava->cheveux_droite;
		Cheveux *cur_g = ava->cheveux_gauche;
		for(i = 0; i < 6 && cur_d != NULL && cur_g != NULL; i ++)
		{
			g[i].x = visage_size-d[i].x;
			g[i].y = d[i].y;
			cur_d->centre = d[i];
			cur_g->centre = g[i];
			cur_d = cur_d->next;
			cur_g = cur_g->next;
		}
	}
	
	ava->corps_height = corps_size;
	
	ava->corps = Corps_CreateHuman(x, y+(VISAGE_CRANE(ava->visage)->cercle.rayon/2), visage_size*2, corps_size);
	
	Corps_SetColor(CORPS_MAIN_D(ava->corps), ava->couleur_peau);
	Corps_SetColor(CORPS_MAIN_G(ava->corps), ava->couleur_peau);
	Corps_SetColor(CORPS_COU(ava->corps), ava->couleur_peau);
}

void Avatar_Free(Avatar **ava)
{
	if(*ava != NULL)
	{
		Visage_Free(&((*ava)->visage));
		Yeux_Free(&((*ava)->oeil_droit));
		Yeux_Free(&((*ava)->oeil_gauche));
		Yeux_Free(&((*ava)->sourcil_droit));
		Yeux_Free(&((*ava)->sourcil_gauche));
		Yeux_Free(&((*ava)->nez));
		Yeux_Free(&((*ava)->oreille_droite));
		Yeux_Free(&((*ava)->oreille_gauche));
		Cheveux_Free(&((*ava)->cheveux_droite));
		Cheveux_Free(&((*ava)->cheveux_gauche));
		Corps_Free(&((*ava)->corps));
		if((*ava)->tete != NULL)
			MLV_free_image((*ava)->tete);
		free(*ava);
		*ava = NULL;
	}
}
