#include "error.h"

void print_error(const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char *chaine = NULL;
	if((chaine = (char*)malloc((strlen(format)+strlen("\033[31m\033[1mErreur: \033[0m")+1)*sizeof(char))) != NULL)
	{
		strcpy(chaine, "\033[31m\033[1mErreur: ");
		strcat(chaine, format);
		strcat(chaine, "\033[0m");
		vprintf(chaine, args);
		free(chaine);
	}
	va_end(args);
}

void print_ok(const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char *chaine = NULL;
	if((chaine = (char*)malloc((strlen(format)+strlen("\033[32m\033[1mValidé: \033[0m")+1)*sizeof(char))) != NULL)
	{
		strcpy(chaine, "\033[32m\033[1mValidé: ");
		strcat(chaine, format);
		strcat(chaine, "\033[0m");
		vprintf(chaine, args);
		free(chaine);
	}
	va_end(args);
}

void print_title(const char *title, const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char *chaine = NULL;
	if((chaine = (char*)malloc((strlen(format)+strlen("\033[33m\033[1m: \033[0m")+strlen(title)+1)*sizeof(char))) != NULL)
	{
		strcpy(chaine, "\033[33m\033[1m");
		strcat(chaine, title);
		strcat(chaine, ": ");
		strcat(chaine, format);
		strcat(chaine, "\033[0m");
		vprintf(chaine, args);
		free(chaine);
	}
	va_end(args);
}

void print_subtitle(const char *title, const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char *chaine = NULL;
	if((chaine = (char*)malloc((strlen(format)+strlen("\033[1m: \033[0m")+strlen(title)+1)*sizeof(char))) != NULL)
	{
		strcpy(chaine, "\033[1m");
		strcat(chaine, title);
		strcat(chaine, ": ");
		strcat(chaine, format);
		strcat(chaine, "\033[0m");
		vprintf(chaine, args);
		free(chaine);
	}
	va_end(args);
}

int print_test(int condi, const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char *chaine = NULL;
	if(condi)
	{
		if((chaine = (char*)malloc((strlen(format)+strlen("\033[32m\033[1mValidé: \033[0m")+1)*sizeof(char))) == NULL)
			return 0;
		strcpy(chaine, "\033[32m\033[1mValidé: ");
	}
	else
	{
		if((chaine = (char*)malloc((strlen(format)+strlen("\033[31m\033[1mErreur: \033[0m")+1)*sizeof(char))) == NULL)
			return 0;
		strcpy(chaine, "\033[31m\033[1mErreur: ");
		
	}
	strcat(chaine, format);
	strcat(chaine, "\033[0m");
	vprintf(chaine, args);
	free(chaine);
	va_end(args);
	return condi;
}
