#ifndef DEF_HEADER_ERROR
#define DEF_HEADER_ERROR

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

void print_error(const char *format, ...);
/*
Permet d'afficher un erreur
Fonctionne comme un printf
Sauf qu'on ajoute le préfixe Erreur:
*/
void print_ok(const char *format, ...);
/*
Permet d'afficher un qu'un test est ok par exemple
Fonctionne un printf
Sauf qu'on ajoute le préfixe Validité:
*/
void print_title(const char *title, const char *format, ...);
/*
Permet d'afficher un message en jaune précédé d'un "title"
Fonctionne comme printf
*/
void print_subtitle(const char *title, const char *format, ...);
/*
Permet d'afficher un message en gras précédé d'un "title"
Fonctionne comme printf
*/
int print_test(int condi, const char *format, ...);
/*
Permet d'afficher la chaine formatée:
-si condi == 0 comme une erreur
-sinon comme un test valide
renvoie la valeur de condi
Pratique pour vérifier une condition de test
*/

#endif
