#include "file.h"

MyFile_Data *MF_Data = NULL;
MyFile *MyFile_Alloc(char *name)
{
	MyFile *temp = (MyFile *)malloc(sizeof(MyFile));
	if(temp == NULL)
		return NULL;
	temp->name = (char *)malloc(sizeof(char)*(strlen(name)+1));
	strcpy(temp->name, name);
	temp->d=1;
	temp->weight=0;
	temp->up=NULL;
	temp->ls = (MyFile **)malloc(sizeof(MyFile *)*BASE_TREEFILES);
	temp->nb_ls = 0;
	temp->max_ls = BASE_TREEFILES;
	temp->pos[0]=-1;
	temp->pos[1]=-1;
	temp->hover=0;
	return temp;
}
MyFile *MyFile_PartialAlloc(char *name, MyFile *top)
{
	MyFile *temp = (MyFile *)malloc(sizeof(MyFile));
	if(temp == NULL)
		return NULL;
	temp->name = (char *)malloc(sizeof(char)*(strlen(name)+1));
	strcpy(temp->name, name);
	temp->d=1;
	temp->weight=0;
	temp->up=top;
	temp->ls=NULL;
	temp->nb_ls = 0;
	temp->max_ls = 0;
	temp->pos[0]=-1;
	temp->pos[1]=-1;
	temp->hover=0;
	return temp;
}
void MyFile_Free(MyFile *temp)
{
	if(temp != NULL)
	{
		if(temp->name != NULL)
			free(temp->name);
		if(temp->ls != NULL)
		{
			int i;
			for(i=0;i<temp->nb_ls;i++)
			{
				if(temp->ls[i] != NULL)
				{
					if(temp->ls[i]->name != NULL)
						free(temp->ls[i]->name);
					free(temp->ls[i]);
				}
			}
			free(temp->ls);
		}
		if(temp->up != NULL)
		{
			if(temp->up->name != NULL)
				free(temp->up->name);
			free(temp->up);
		}
		free(temp);
	}
}
int MyFile_AddLs(MyFile *temp, char name[], int d, int weight)
{
	if(temp == NULL)
		return 0;
	if(temp->nb_ls == temp->max_ls)
	{
		MyFile **temp2 = (MyFile **)realloc(temp->ls, sizeof(MyFile *)*(temp->max_ls*2));
		if(temp2 == NULL)
			return 0;
		temp->ls = temp2;
		temp->max_ls *= 2;
	}
	MyFile *new = MyFile_PartialAlloc(name, temp);
	if(new == NULL)
		return 0;
	new->d = d;
	new->weight=weight;
	temp->ls[temp->nb_ls] = new;
	temp->nb_ls++;
	return 1;
}
void MyFile_DevTrFile(char *temp)
{
	char *sauv = NULL, *sauv2 = NULL;
	int i=0;
	while(temp[i]!='\0')
	{
		if(temp[i]=='/')
		{
			if(sauv == NULL)
				sauv = &(temp[i]);
			else
			{
				sauv2 = sauv;
				sauv = &(temp[i]);
			}
		}
		i++;
	}
	if(temp[strlen(temp)-1] == '/')
		*sauv2 = '\0';
	else
		*sauv = '\0';
}
int MyFile_RecupName(FILE *f, char *name)
{
	char c = '\0';
	int i=0;
	while(c != '\n')
	{
		c = fgetc(f);
		if(c != '\n')
		{
			name[i]=c;
			i++;
		}
	}
	name[i]='\0';
	return 1;
}
MyFile *MyFile_Generate(char d[])
{

	MyFile *temp = MyFile_Alloc(d);
	int t;
	char action[1000];
	sprintf(action, "%s/test___file.txt", d);
	FILE *test_file = fopen(action, "w");

	if(test_file == NULL)
		return temp;
	fclose(test_file);

	sprintf(action, "rm %s/test___file.txt", d);
	if(system(action) == -1)
		return temp;

	sprintf(action, "cd %s; ls -l>current.txt", d);
	if(system(action) == -1)
		return temp;

	sprintf(action, "%s/current.txt", d);
	FILE *f = fopen(action, "r");
	if(f == NULL)
	{
		return temp;
	}
	char droits[11], user[40], name[300];
	int taille=0, total;
	char tampon[100];
	if(fscanf(f, "%s %d", tampon, &total) != 2)
		return temp;
	while(fscanf(f, "%s %s %s %s %d %s %s %s ", droits, tampon, user, tampon, &taille, tampon, tampon, tampon) > 0)
	{
		MyFile_RecupName(f, name);
		if(strcmp(name, "current.txt") != 0)
		{
			if(droits[0] == '-')
				MyFile_AddLs(temp, name, 0, taille);
			else
				MyFile_AddLs(temp, name, 1, taille);
		}
	}
	fclose(f);

	sprintf(action, "cd %s; rm current.txt", d);
	if(system(action) == -1)
		return temp;
	
	char *current = (char *)malloc(sizeof(char)*(strlen(d)+1));
	strcpy(current, d);
	MyFile_DevTrFile(current);
	
	MyFile *up = MyFile_PartialAlloc(current, NULL);
	temp->up = up; 

	t = t+42;
	free(current);
	return temp;
}
void MyFile_AffConsole(MyFile *temp)
{
	printf("\n----------------------------------------------\n");
	printf("Top : %s\n", temp->up->name);
	printf("Actual : %s\n", temp->name);
	int i;

	for(i=0;i<temp->nb_ls;i++)
	{
		if(temp->ls[i]->d == 1)
			printf("- %s (directory) - %do\n", temp->ls[i]->name, temp->ls[i]->weight);
		else
			printf("- %s (file) - %do\n", temp->ls[i]->name, temp->ls[i]->weight);
	}
	printf("----------------------------------------------\n");
}
MLV_Image *draw_directory(void)
{
	MLV_Image *img = MLV_create_image(90,90);
	MLV_draw_filled_rectangle_on_image(0,0,90,90,MLV_rgba(160,160,160,255), img);
	{
		int x[4] = {0,10,80,89};
		int y[4] = {20,89,89,20};
		MLV_draw_polygon_on_image(x,y,4,MLV_COLOR_BLACK,img);
	}
	{
		int x[8] = {8,8,20,20,45,45,82,82};
		int y[8] = {20,15,15,5,5,13,13,20};
		MLV_draw_polygon_on_image(x,y,8,MLV_COLOR_BLACK,img);
	}
	return img;
}
MLV_Image *draw_file(void)
{
	MLV_Image *img = MLV_create_image(90,90);
	MLV_draw_filled_rectangle_on_image(0,0,90,90,MLV_rgba(200,200,200,255), img);
	{
		int x[6] = {1,60,60,89,89,1};
		int y[6] = {1,1,30,30,89,89};
		MLV_draw_polygon_on_image(x,y,6,MLV_COLOR_BLACK,img);
	}
	{
		int x[3] = {61,89,61};
		int y[3] = {1,29,29};
		MLV_draw_filled_polygon_on_image(x,y,3,MLV_rgba(210,210,210,255),img);
	}
	return img;
}
MLV_Image *draw_plus(void)
{
	MLV_Image *img = MLV_create_image(90,90);
	MLV_draw_filled_rectangle_on_image(0,0,90,90,MLV_rgba(200,200,200,255), img);
	{
		int x[12] = {15,40,40,50,50,75,75,50,50,40,40,15};
		int y[12] = {40,40,15,15,40,40,50,50,75,75,50,50};
		MLV_draw_filled_polygon_on_image(x,y,12,MLV_rgba(210,210,210,255),img);
		MLV_draw_polygon_on_image(x,y,12,MLV_COLOR_BLACK,img);
	}
	MLV_draw_circle_on_image(45,45,30,MLV_COLOR_BLACK,img);
	return img; 
}
char *MyFile_ConvertWeight(int weight)
{
	char *temp = (char *)malloc(sizeof(char)*8);
	if(weight >= 1000000000)
		sprintf(temp, "%d%s", weight/1000000000, "Go");
	else if(weight >= 1000000)
		sprintf(temp, "%d%s", weight/1000000, "Mo");
	else if(weight >= 1000)
		sprintf(temp, "%d%s", weight/1000, "Ko");
	else
		sprintf(temp, "%d%s", weight, " oct");
	return temp;
}
void MyFile_AffWindow(MyFile *temp, int baseX, int baseY)
{
	MLV_clear_window(MLV_COLOR_WHITE);
	
	if(MF_Data->baseX == -1)
	{
		MF_Data->baseX = baseX;
		MF_Data->baseY = baseY;
	}
	int i;
	MLV_Font *font = MLV_load_font("media/monof55.ttf", 20);
	
	MLV_draw_filled_rectangle(baseX,baseY, 90, 30, MLV_rgba(180,180,180,255));
	MLV_draw_filled_rectangle(baseX+90, baseY, FILE_SCREEN_WIDTH-(baseX+100)-100, 30, MLV_rgba(210,210,210,255));
	MLV_draw_text_with_font(baseX+5, baseY+5, "Dossier ", font, MLV_COLOR_BLACK);
	MLV_draw_text_with_font(baseX+100, baseY+5, temp->name, font, MLV_COLOR_BLACK);
	
	MLV_draw_filled_rectangle(baseX,baseY+40, 110, 30, MLV_rgba(180,180,180,255));
	MLV_draw_filled_rectangle(baseX+110, baseY+40, FILE_SCREEN_WIDTH-(baseX+100)-120, 30, MLV_rgba(210,210,210,255));
	MLV_draw_text_with_font(baseX+5, baseY+45, "Selection ", font, MLV_COLOR_BLACK);
	if(MF_Data->selected != NULL)
		MLV_draw_text_with_font(baseX+120, baseY+45, MF_Data->selected, font, MLV_COLOR_BLACK);
	else
		MLV_draw_text_with_font(baseX+120, baseY+45, "Aucun fichier sélectionné", font, MLV_COLOR_BLACK);
		
	if(MF_Data->method == 1) // sauvegarde
	{
		MLV_draw_filled_rectangle(FILE_SCREEN_WIDTH-250, baseY+40, 140, 30, MLV_rgba(200,130,130,255));
		MLV_draw_text_with_font(FILE_SCREEN_WIDTH-235, baseY+45, "ENREGISTRER", font, MLV_COLOR_BLACK);
	}
	else // chargement
	{	
		MLV_draw_filled_rectangle(FILE_SCREEN_WIDTH-210, baseY+40, 100, 30, MLV_rgba(130,200,130,255));
		MLV_draw_text_with_font(FILE_SCREEN_WIDTH-195, baseY+45, "VALIDER", font, MLV_COLOR_BLACK);
	}
	
	MLV_Image *IMdirect = draw_directory();
	MLV_Image *IMfile = draw_file();
	MLV_Image *IMplus = draw_plus();
	
	int posX=0,posY=30,TextW, TextH;
	MLV_Font *ft_text = MLV_load_font("media/monof55.ttf", 15);
	
	
	if(temp->up != NULL)
	{
		MLV_Color background_up = MLV_rgba(100,200,100,255);
		if(!MyFile_DirectOk(temp->up->name))
			background_up = MLV_rgba(50,100,50,255);
		MLV_draw_filled_rectangle(baseX+posX, baseY+posY+80, 160, 120, background_up);
		//MLV_draw_image(IMdirect, baseX+posX+35, baseY+posY+80);
		MLV_draw_rectangle(baseX+posX+80-50, baseY+posY+80+40, 110, 55, MLV_COLOR_BLACK);  
		MLV_draw_text_with_font(baseX+posX+80-35, baseY+posY+80+60, "Top Folder", ft_text, MLV_COLOR_BLACK);
		temp->up->pos[0] = baseX+posX;
		temp->up->pos[1] = baseY+posY+80;
		posX += 170;
		if(posX > FILE_SCREEN_WIDTH-300)
		{
			posY += 130;
			posX = 0;
		}
	}
	
	for(i=MF_Data->nb_min;i<temp->nb_ls;i++)
	{
		MLV_Color background = MLV_rgba(200,200,200,255);
		
		if(temp->ls[i]->d == 1)
			background = MLV_rgba(160,160,160,255);
		MLV_draw_filled_rectangle(baseX+posX, baseY+posY+80, 160, 120, background);
		
		//MAJ pos
		temp->ls[i]->pos[0] = baseX+posX;
		temp->ls[i]->pos[1] = baseY+posY+80;
		
		if(temp->ls[i]->d  == 1)
			MLV_draw_image(IMdirect, baseX+posX+35, baseY+posY+80);
		else
			MLV_draw_image(IMfile, baseX+posX+35, baseY+posY+84);
		
		if(temp->ls[i]->d == 0)
		{
			char *str_weight = MyFile_ConvertWeight(temp->ls[i]->weight);
			int t_w, t_h;
			MLV_get_size_of_adapted_text_box_with_font(str_weight, ft_text, 0, &t_w, &t_h);
			MLV_draw_text_with_font(baseX+posX+80-t_w/2, baseY+posY+80+55, str_weight, ft_text, MLV_COLOR_BLACK);
			free(str_weight);
		}
		
		char temp_text[22];
		MLV_get_size_of_adapted_text_box_with_font(temp->ls[i]->name, ft_text, 0, &TextW, &TextH);
		if(TextW<158)
		{

			MLV_draw_text_with_font(baseX+posX+80-TextW/2, baseY+posY+80+100, temp->ls[i]->name, ft_text, MLV_COLOR_BLACK);
		}
		else
		{
			
			int j;
			for(j=0;j<17;j++)
				temp_text[j] = temp->ls[i]->name[j];
			temp_text[17] = '.';
			temp_text[18] = '.';
			temp_text[19] = '.';
			temp_text[20] = '\0';
			MLV_get_size_of_adapted_text_box_with_font(temp_text, ft_text, 0, &TextW, &TextH);
			MLV_draw_text_with_font(baseX+posX+80-TextW/2, baseY+posY+80+100, temp_text, ft_text, MLV_COLOR_BLACK);

		}
		posX += 170;
		if(posX > FILE_SCREEN_WIDTH-300)
		{
			posY += 130;
			posX = 0;
		}
	}
	MLV_draw_filled_rectangle(baseX+posX, baseY+posY+80, 120, 120, MLV_rgba(200,200,200,255));
	MLV_draw_image(IMplus, baseX+posX+15, baseY+posY+80+15);
	MF_Data->plus[0] = baseX+posX;
	MF_Data->plus[1] = baseY+posY+80;
	
	MLV_actualise_window();
	MLV_free_image(IMdirect);
	MLV_free_image(IMfile);
	MLV_free_image(IMplus);
	MLV_free_font(font);
	MLV_free_font(ft_text);
}
int MyFile_ListEvent(MyFile *current)
{
	int mouse[2] = {0};
	MLV_Keyboard_button sym = MLV_KEYBOARD_NONE;
	MLV_Mouse_button mouseButton;
	MLV_Event event = MLV_NONE;
	MLV_Button_state state;
	event = MLV_get_event(&sym,NULL,NULL,NULL,NULL, &mouse[0], &mouse[1], &mouseButton, &state);
	
	if(event == MLV_KEY && sym == MLV_KEYBOARD_ESCAPE)
		return -1;
	else if(event == MLV_KEY)
		return 0;
	int pasP = (FILE_SCREEN_WIDTH-300)/160+1;
	
	/***************** SOURIS MOLETTE EVENTS ****************/
	if(event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_WHEELDOWN && state == MLV_PRESSED)
	{
		if(MF_Data->nb_min < current->nb_ls-10)
			MF_Data->nb_min+=pasP;
		MyFile_AffWindow(current,100,50);
		return 1;
	}
	else if(event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_WHEELUP && state == MLV_PRESSED)
	{
		if(MF_Data->nb_min-pasP < 0)
		{
			MF_Data->nb_min = 0;
		}
		else
			MF_Data->nb_min-=pasP;
		MyFile_AffWindow(current, 100, 50);
		return 1;
	}
	/***************** PLUS NEW FILE *************************/
	if(event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_LEFT && state == MLV_RELEASED && (mouse[0]>=MF_Data->plus[0] && mouse[0]<=MF_Data->plus[0]+120 && mouse[1]>=MF_Data->plus[1] && mouse[1]<=MF_Data->plus[1]+120))
	{
		MLV_Input_box *input_box_3 = MLV_create_input_box(MF_Data->plus[0], MF_Data->plus[1], 240, 30, MLV_rgba(120,120,120, 255), MLV_COLOR_BLACK, MLV_rgba(200,200,200, 255), "Nouveau nom : ");
		MLV_draw_all_input_boxes();
		MLV_actualise_window();
		
		MLV_Input_box *temp_box;
		char *texte = NULL, *final_text = NULL;
		do
		{
			event = MLV_get_event(NULL, NULL, NULL,&texte, &temp_box,NULL, NULL, NULL,NULL);
			if(event == MLV_INPUT_BOX && temp_box == input_box_3)
			{
				final_text = texte;
				break;
			}
			MLV_draw_input_box(input_box_3);
			MLV_actualise_window();
		}
		while(1);

		if(final_text != NULL)
		{
			
			if(MF_Data->selected != NULL)
			{
				free(MF_Data->selected);
				MF_Data->selected = NULL;
			}
			char *temp = (char *)malloc(sizeof(char)*(strlen(current->name)+strlen(final_text)+2));
			sprintf(temp, "%s%s%s", current->name, (current->name[strlen(current->name)-1]=='/')?"":"/", final_text);
			MF_Data->selected=temp;
			free(final_text);
			final_text = NULL;
		}
		MLV_free_input_box(input_box_3);
		MyFile_AffWindow(current, 100, 50);
		
	}
	else if(event == MLV_MOUSE_MOTION && MF_Data->plus[3] && !(mouse[0]>=MF_Data->plus[0] && mouse[0]<=MF_Data->plus[0]+120 && mouse[1]>=MF_Data->plus[1] && mouse[1]<=MF_Data->plus[1]+120))
	{
		MF_Data->plus[3]=0;
		MLV_draw_rectangle(MF_Data->plus[0]-3,MF_Data->plus[1]-3, 126, 126, MLV_COLOR_WHITE);
		MLV_draw_rectangle(MF_Data->plus[0]-2,MF_Data->plus[1]-2, 124, 124, MLV_COLOR_WHITE);
		MLV_draw_rectangle(MF_Data->plus[0]-1,MF_Data->plus[1]-1, 122, 122, MLV_COLOR_WHITE);
		MLV_actualise_window();
	}
	else if(event == MLV_MOUSE_MOTION && MF_Data->plus[3] == 0 && (mouse[0]>=MF_Data->plus[0] && mouse[0]<=MF_Data->plus[0]+120 && mouse[1]>=MF_Data->plus[1] && mouse[1]<=MF_Data->plus[1]+120))
	{
		MF_Data->plus[3]=1;
		MLV_draw_rectangle(MF_Data->plus[0]-3,MF_Data->plus[1]-3, 126, 126, MLV_rgba(130,130,130,255));
		MLV_draw_rectangle(MF_Data->plus[0]-2,MF_Data->plus[1]-2, 124, 124, MLV_rgba(70,70,70,255));
		MLV_draw_rectangle(MF_Data->plus[0]-1,MF_Data->plus[1]-1, 122, 122, MLV_COLOR_BLACK);
		MLV_actualise_window();
	}
	
	/***********************  EVENTS SAUVEGARDE **********************/
	if(MF_Data->method == 1 && event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_LEFT && state == MLV_RELEASED && (mouse[0]>=FILE_SCREEN_WIDTH-250 && mouse[0]<=FILE_SCREEN_WIDTH-110 && mouse[1]>=MF_Data->baseY+40 && mouse[1]<=MF_Data->baseY+40+30))
	{
		return -1;
	}
	else if(MF_Data->method == 1 && event == MLV_MOUSE_MOTION && MF_Data->hover && !(mouse[0]>=FILE_SCREEN_WIDTH-250 && mouse[0]<=FILE_SCREEN_WIDTH-110 && mouse[1]>=MF_Data->baseY+40 && mouse[1]<=MF_Data->baseY+40+30))
	{
		MLV_Font *font = MLV_load_font("media/monof55.ttf", 20);
		MLV_draw_filled_rectangle(FILE_SCREEN_WIDTH-250, MF_Data->baseY+40, 140, 30, MLV_rgba(200,130,130,255));
		MLV_draw_text_with_font(FILE_SCREEN_WIDTH-235, MF_Data->baseY+45, "ENREGISTRER", font, MLV_COLOR_BLACK);
		MLV_actualise_window();
		MLV_free_font(font);
		MF_Data->hover = 0;
		return 1;
	}
	else if(MF_Data->method == 1 && event == MLV_MOUSE_MOTION && !(MF_Data->hover) && (mouse[0]>=FILE_SCREEN_WIDTH-250 && mouse[0]<=FILE_SCREEN_WIDTH-110 && mouse[1]>=MF_Data->baseY+40 && mouse[1]<=MF_Data->baseY+40+30))
	{
		MLV_Font *font = MLV_load_font("media/monof55.ttf", 20);
		MLV_draw_filled_rectangle(FILE_SCREEN_WIDTH-250, MF_Data->baseY+40, 140, 30, MLV_rgba(230,100,100,255));
		MLV_draw_text_with_font(FILE_SCREEN_WIDTH-235, MF_Data->baseY+45, "ENREGISTRER", font, MLV_COLOR_BLACK);
		MLV_actualise_window();
		MLV_free_font(font);
		MF_Data->hover = 1;
		return 1;
	}
	
	
	/***********************  EVENTS CHARGEMENT **********************/
	if(MF_Data->method == 0 && event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_LEFT && state == MLV_RELEASED && (mouse[0]>=FILE_SCREEN_WIDTH-210 && mouse[0]<=FILE_SCREEN_WIDTH-110 && mouse[1]>=MF_Data->baseY+40 && mouse[1]<=MF_Data->baseY+40+30))
	{
		return -1;
	}
	else if(MF_Data->method == 0 && event == MLV_MOUSE_MOTION && MF_Data->hover && !(mouse[0]>=FILE_SCREEN_WIDTH-210 && mouse[0]<=FILE_SCREEN_WIDTH-110 && mouse[1]>=MF_Data->baseY+40 && mouse[1]<=MF_Data->baseY+40+30))
	{
		MLV_Font *font = MLV_load_font("media/monof55.ttf", 20);
		MLV_draw_filled_rectangle(FILE_SCREEN_WIDTH-210, MF_Data->baseY+40, 100, 30, MLV_rgba(130,200,130,255));
		MLV_draw_text_with_font(FILE_SCREEN_WIDTH-195, MF_Data->baseY+45, "VALIDER", font, MLV_COLOR_BLACK);
		MLV_actualise_window();
		MLV_free_font(font);
		MF_Data->hover = 0;
		return 1;
	}
	else if(MF_Data->method == 0 && event == MLV_MOUSE_MOTION && !(MF_Data->hover) && (mouse[0]>=FILE_SCREEN_WIDTH-210 && mouse[0]<=FILE_SCREEN_WIDTH-110 && mouse[1]>=MF_Data->baseY+40 && mouse[1]<=MF_Data->baseY+40+30))
	{
		MLV_Font *font = MLV_load_font("media/monof55.ttf", 20);
		MLV_draw_filled_rectangle(FILE_SCREEN_WIDTH-210, MF_Data->baseY+40, 100, 30, MLV_rgba(100,170,100,255));
		MLV_draw_text_with_font(FILE_SCREEN_WIDTH-195, MF_Data->baseY+45, "VALIDER", font, MLV_COLOR_BLACK);
		MLV_actualise_window();
		MLV_free_font(font);
		MF_Data->hover = 1;
		return 1;
	}
	
	
	if(event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_LEFT && state == MLV_RELEASED && (mouse[0]>=current->up->pos[0] && mouse[0]<=current->up->pos[0]+160 && mouse[1]>=current->up->pos[1] && mouse[1]<=current->up->pos[1]+120))
	{
		if(MyFile_DirectOk(current->up->name))
		{
			MyFile *new = MyFile_Generate(current->up->name);
			MF_Data->nb_min = 0;
			MyFile_AffWindow(new,100,50);
			int c=1;
			while(c!=-1)
				c = MyFile_ListEvent(new);
			MyFile_Free(new);
			return -1;
		}
		return 1;
	}
	else if(event == MLV_MOUSE_MOTION && current->up->hover && !(mouse[0]>=current->up->pos[0] && mouse[0]<=current->up->pos[0]+160 && mouse[1]>=current->up->pos[1] && mouse[1]<=current->up->pos[1]+120))
	{
		current->up->hover=0;
		MLV_draw_rectangle(current->up->pos[0]-3,current->up->pos[1]-3, 166, 126, MLV_COLOR_WHITE);
		MLV_draw_rectangle(current->up->pos[0]-2,current->up->pos[1]-2, 164, 124, MLV_COLOR_WHITE);
		MLV_draw_rectangle(current->up->pos[0]-1,current->up->pos[1]-1, 162, 122, MLV_COLOR_WHITE);
		MLV_actualise_window();
		
	}
	else if(event == MLV_MOUSE_MOTION && current->up->hover == 0 && (mouse[0]>=current->up->pos[0] && mouse[0]<=current->up->pos[0]+160 && mouse[1]>=current->up->pos[1] && mouse[1]<=current->up->pos[1]+120))
	{
		current->up->hover=1;
		MLV_draw_rectangle(current->up->pos[0]-3,current->up->pos[1]-3, 166, 126, MLV_rgba(130,130,130,255));
		MLV_draw_rectangle(current->up->pos[0]-2,current->up->pos[1]-2, 164, 124, MLV_rgba(70,70,70,255));
		MLV_draw_rectangle(current->up->pos[0]-1,current->up->pos[1]-1, 162, 122, MLV_COLOR_BLACK);
		MLV_actualise_window();
		
	}

	int i;
	for(i=MF_Data->nb_min;i<current->nb_ls;i++)
	{
		if(event == MLV_MOUSE_BUTTON && mouseButton == MLV_BUTTON_LEFT && state == MLV_RELEASED && (mouse[0]>=current->ls[i]->pos[0] && mouse[0]<=current->ls[i]->pos[0]+160 && mouse[1]>=current->ls[i]->pos[1] && mouse[1]<=current->ls[i]->pos[1]+120))
		{
			if(current->ls[i]->d == 1)
			{
				MF_Data->nb_min = 0;
				char temp[1000] = "";
				sprintf(temp, "%s%s%s", current->name, (current->name[strlen(current->name)-1]=='/')?"":"/", current->ls[i]->name);

				MyFile *new = MyFile_Generate(temp);
				
				MyFile_AffWindow(new,100,50);
				int c=1;
				while(c!=-1)
					c = MyFile_ListEvent(new);
				MyFile_Free(new);
				return -1;
			}
			else
			{
				char temp[1000] = "";
				sprintf(temp, "%s%s%s", current->name, (current->name[strlen(current->name)-1]=='/')?"":"/", current->ls[i]->name);
				char *temp2 = (char *)malloc(sizeof(char)*(strlen(temp)+1));
				strcpy(temp2, temp);
				if(temp2 == NULL)
					return 0;
				MF_Data->selected = temp2;
				current->ls[i]->hover=0;
				MyFile_AffWindow(current,100,50);
				return 1;
			}
		}
		if(event == MLV_MOUSE_MOTION && current->ls[i]->hover && !(mouse[0]>=current->ls[i]->pos[0] && mouse[0]<=current->ls[i]->pos[0]+160 && mouse[1]>=current->ls[i]->pos[1] && mouse[1]<=current->ls[i]->pos[1]+120))
		{
			current->ls[i]->hover=0;
			MLV_draw_rectangle(current->ls[i]->pos[0]-3,current->ls[i]->pos[1]-3, 166, 126, MLV_COLOR_WHITE);
			MLV_draw_rectangle(current->ls[i]->pos[0]-2,current->ls[i]->pos[1]-2, 164, 124, MLV_COLOR_WHITE);
			MLV_draw_rectangle(current->ls[i]->pos[0]-1,current->ls[i]->pos[1]-1, 162, 122, MLV_COLOR_WHITE);
			MLV_actualise_window();
			
		}
		else if(event == MLV_MOUSE_MOTION && current->ls[i]->hover == 0 && (mouse[0]>=current->ls[i]->pos[0] && mouse[0]<=current->ls[i]->pos[0]+160 && mouse[1]>=current->ls[i]->pos[1] && mouse[1]<=current->ls[i]->pos[1]+120))
		{
			current->ls[i]->hover=1;
			MLV_draw_rectangle(current->ls[i]->pos[0]-3,current->ls[i]->pos[1]-3, 166, 126, MLV_rgba(130,130,130,255));
			MLV_draw_rectangle(current->ls[i]->pos[0]-2,current->ls[i]->pos[1]-2, 164, 124, MLV_rgba(70,70,70,255));
			MLV_draw_rectangle(current->ls[i]->pos[0]-1,current->ls[i]->pos[1]-1, 162, 122, MLV_COLOR_BLACK);
			MLV_actualise_window();
		}

	}
	MLV_wait_milliseconds(1);
	return 1;
}

int MyFile_DirectOk(char *name)
{
	char *home = MF_Data->Home_Directory;
	if(strlen(name)<strlen(home))
		return 0;
	int i;
	for(i=0;i<strlen(home);i++)
	{
		if(home[i] != name[i])
			return 0;
	}
	return 1;
	
}

void MyFile_Init(void)
{
	if(MF_Data == NULL)
	{
		MF_Data = (MyFile_Data *)malloc(sizeof(MyFile_Data));
		if(MF_Data == NULL)
			exit(EXIT_FAILURE);
		MF_Data->Home_Directory = (char *)MLV_get_home_directory();
		MF_Data->selected = NULL;
		MF_Data->method = 0;
		MF_Data->hover = 0;
		MF_Data->baseX = -1;
		MF_Data->baseY = -1;
		MF_Data->nb_min = 0;
		MF_Data->plus[0] = -1;
		MF_Data->plus[1] = -1;
	}
	else
		printf("MyFile_Init() already be done.\n");
}
void MyFile_Quit()
{
	if(MF_Data != NULL)
	{
		if(MF_Data->Home_Directory != NULL)
		{
			free(MF_Data->Home_Directory);
			MF_Data->Home_Directory = NULL;
		}
		if(MF_Data->selected != NULL)
		{
			MF_Data->selected = NULL;
		}
		free(MF_Data);
		MF_Data=NULL;
	}
	else
		printf("Please do MyFile_Init() before this.\n");
}
char *MyFile_ChargFile(void)
{
	if(MF_Data == NULL)
	{
		printf("Please do MyFile_Init() before this.\n");
		return NULL;
	}

	MF_Data->method = 0; // Method = Chargement

	MyFile *current = MyFile_Generate(MF_Data->Home_Directory);

	MyFile_AffWindow(current,100,50);

	while(MyFile_ListEvent(current) != -1);

	MyFile_Free(current);
	
	return MF_Data->selected;
}
int MyFile_SauvFile(char *text)
{
	if(MF_Data == NULL)
	{
		printf("Please do MyFile_Init() before this.\n");
		return 0;
	}
	if(text == NULL)
	{
		printf("<MyFile_SauvFile> Arg 1 IS NULL\n");
		return 0;
	}
	MF_Data->method = 1; // Method = Sauvegarde
	
	MyFile *current = MyFile_Generate(MF_Data->Home_Directory);
	
	MyFile_AffWindow(current, 100, 50);
	
	int c = 1;
	while(c != -1 && c != -2)
	{
		c = MyFile_ListEvent(current);
	}
	
	MyFile_Free(current);
	
	if(MF_Data->selected != NULL)
	{
		FILE *f = fopen(MF_Data->selected, "w");
		if(f == NULL)
			return 0;
		if(fputs(text, f) == EOF)
		{
			fclose(f);
			return 0;
		}
		fclose(f);
	}
	
	return c+2;
}
/*
int main(int argc, char *argv[])
{


	MLV_create_window("Test files", "Files", 1000,800);
	//MLV_enable_full_screen();
	

	MyFile_Init();
	
	// Sauvegarde d'une chaîne de caractère 
	char *salut = (char *)malloc(sizeof(char)*10);
	sprintf(salut, "Hello !");
	MyFile_SauvFile(salut);	
	free(salut);
	
	// Chargement d'un path
	char *chaine_recup = MyFile_ChargFile();
	if(chaine_recup != NULL)
	{
		printf("Chaine récupérée : %s\n", chaine_recup);
		free(chaine_recup);
	}
	
	MLV_free_window();
	return EXIT_SUCCESS;
}*/
