#ifndef DEF_HEADER_INIT_DATA
#define DEF_HEADER_INIT_DATA

#include "struct_data.h"

/*
Header content le prototype des fonctions d'initialisation des structures
*/

PlayedToken *PlayedToken_Create();
/*
Permet de créer une structure PlayedToken Allouée dynamiquement
*/
void PlayedToken_Free(PlayedToken **jetonjoue);
/*
Permet de libérer une structure PlayedToken
*/
void PlayedToken_FreeWithNext(PlayedToken **jetonjoue);
/*
Permet de libérer une structure PlayedToken ainsi que les PlayedToken suivants s'il existent
*/

TokenList *TokenList_Create();
/*
Permet de créer une structure ListToken Allouée dynamiquement
*/
void TokenList_Free(TokenList **listejeton);
/*
Permet de libérer une structure ListToken
*/

AnimToken *AnimToken_Create();
/*
Permet de créer une structure AnimToken Allouée dynamiquement
*/
void AnimToken_Free(AnimToken **jetonanim);
/*
Permet de libérer une structure AnimToken
*/
void AnimToken_FreeWithNext(AnimToken **jetonanim);
/*
Permet de libérer une structure AnimToken ainsi que les AnimToken suivants s'il existent
*/

AnimList *AnimList_Create();
/*
Permet de créer une structure AnimList Allouée dynamiquement
*/
void AnimList_Free(AnimList **listeanim);
/*
Permet de libérer une structure AnimList
*/

AnimData *AnimData_Create();
/*
Permet de créer une structure AnimData Allouée dynamiquement
*/
void AnimData_Free(AnimData **animdata);
/*
Permet de libérer une structure AnimData
*/
void AnimData_Clear(AnimData *animdata);
/*
Permet de remettre la AnimList à 0
*/

Tuto *Tuto_Create();
/*
Permet de créer un structure Tuto
*/
void Tuto_Free(Tuto **t);
/*
Permet de libérer une structure Tuto
*/

int Jeu_Create();
/*
Permet d'initialiser la variable globale jeu
*/
void Jeu_Free();
/*
Permet de libérer la variable globale jeu
*/
#endif
