#include "jeu.h"

MLV_Event Jeu_WaitEvent(int *x, int *y)
{
	return MLV_wait_keyboard_or_mouse_or_seconds(NULL, NULL, NULL, x, y, 1);
}

int Jeu_Play()
{
	MLV_change_frame_rate(50);
	int x, y;
	if(!jeu->is_loaded)
	{
		if((jeu->genjeton = TokenList_GenerateAlea(5, jeu->nb_colors, jeu->nb_shapes)) == NULL)
			return 0;
		if((jeu->listejeton = TokenList_Create()) == NULL)
			return 0;
		jeu->party_time = 120;
		jeu->score = 0;
	}
	if(jeu->prepare_sprites != NULL)
		jeu->prepare_sprites(NB_COLOR, NB_SHAPE);
	int last_score = jeu->score;
	int trio_tours = 0;
	int menu_quit = 0;
	jeu->start_time = time(NULL);
	Tuto *tuto_main = NULL;
	if(jeu->is_tuto && !jeu->is_loaded)
	{
		Token jeton;
		TokenList_Free(&(jeu->genjeton));
		if((jeu->genjeton = TokenList_Create()) == NULL)
			return 0;
		Token_Change(&jeton, VERT, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->genjeton, jeton);
		Token_Change(&jeton, ROUGE, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->genjeton, jeton);
		Token_Change(&jeton, ROUGE, TRIANGLE);
		TokenList_AjouterToken_EnFin(jeu->genjeton, jeton);
		Token_Change(&jeton, BLEU, TRIANGLE);
		TokenList_AjouterToken_EnFin(jeu->genjeton, jeton);
		Token_Change(&jeton, VERT, TRIANGLE);
		TokenList_AjouterToken_EnFin(jeu->genjeton, jeton);
		
		Token_Change(&jeton, ROUGE, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, ROUGE, DIAMANT);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, BLEU, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, VERT, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, ROUGE, TRIANGLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, ROUGE, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, BLEU, TRIANGLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, ROUGE, TRIANGLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, VERT, DIAMANT);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		Token_Change(&jeton, VERT, CERCLE);
		TokenList_AjouterToken_EnFin(jeu->listejeton, jeton);
		
		jeu->party_time = 42*3600;
		Tuto_Ajouter(&tuto_main, "Cliquez sur le cercle cyan à droite\nPour combiner les jetons verts", (WIDTH*2)/3, HEIGHT/3, Control_Fin, CR_None);
		Tuto_Ajouter(&tuto_main, "Cliquez sur le cercle cyan à gauche\nPour combiner les jetons rouges", WIDTH/6, HEIGHT/3, Control_Tete, CR_None);
		Tuto_Ajouter(&tuto_main, "Maintenant combinez les jetons\nPar Forme", (WIDTH*2)/3, HEIGHT/3, Control_Fin, CR_None);
		Tuto_Ajouter(&tuto_main, "Cliquez sur une forme rouge\nPuis cliquez sur la couleur rouge\nPour effectuer une rotation", WIDTH/2, HEIGHT/2, Control_None, CR_Couleur);
		Tuto_Ajouter(&tuto_main, "Maintenant amusez vous !", WIDTH/2, HEIGHT/2, Control_None, CR_None);
	}
	jeu->is_loaded = 0;
	Tuto *tuto = tuto_main;
	jeu->actif = 1;
	Avatar_ResizeTo(jeu->avatar, WIDTH/8);
	Avatar_FullMoveTo(jeu->avatar, WIDTH/2, HEIGHT/3);
	while(jeu->actif)
	{
		if(jeu->need_refresh)
		{
			jeu->afficher();
			if(jeu->afficher_avatar != NULL)
				jeu->afficher_avatar(jeu->avatar);
			jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
			jeu->afficher_Liste(jeu->listejeton, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
			jeu->afficher_control();
			Tuto_Afficher(tuto);
			MLV_actualise_window();
			if(tuto != NULL && tuto->control_action == Control_None && tuto->cr_action == CR_None)
			{
				MLV_wait_mouse(NULL, NULL);
				tuto = Tuto_Validate(tuto, Control_None, CR_None);
			}
			jeu->need_refresh = 0;
			if(jeu->is_tuto && tuto == NULL)
			{
				Tuto_Free(&tuto_main);
				tuto = NULL;
				jeu->is_tuto = 0;
				jeu->start_time = time(NULL);
				jeu->party_time = 120;
				jeu->need_refresh = 1;
			}
		}
		switch(Jeu_WaitEvent(&x, &y))
		{
			case MLV_MOUSE_BUTTON:
			switch(jeu->get_control_action(x, y))
			{
				case Control_Tete:
				if(!Tuto_CheckAction(tuto, Control_Tete))
					break;
				tuto = Tuto_Validate(tuto, Control_Tete, CR_None);
				if(jeu->move_jeton != NULL)
				{
					jeu->afficher();
					jeu->afficher_Liste(jeu->listejeton, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
					TokenList_AjouterToken_EnTete(jeu->listejeton, jeu->genjeton->head->jeton);
					TokenList_Remove(jeu->genjeton, jeu->genjeton->head);
					TokenList_AjouterToken_Alea(jeu->genjeton, jeu->nb_colors, jeu->nb_shapes);
					//jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
					jeu->afficher_control();
					MLV_save_screen();
					jeu->move_jeton(jeu->listejeton->head->jeton, WIDTH/2, jeu->genListe_Y(), jeu->spPosX(jeu->listejeton->taille, 0), jeu->spPosY(jeu->listejeton->taille, 0));
				}
				else
				{
					TokenList_AjouterToken_EnTete(jeu->listejeton, jeu->genjeton->head->jeton);
					TokenList_Remove(jeu->genjeton, jeu->genjeton->head);
					TokenList_AjouterToken_Alea(jeu->genjeton, NB_COLOR, NB_SHAPE);
				}
				jeu->need_refresh = 1;
				break;
				case Control_Fin:
				if(!Tuto_CheckAction(tuto, Control_Fin))
					break;
				tuto = Tuto_Validate(tuto, Control_Fin, CR_None);
				if(jeu->move_jeton != NULL)
				{
					jeu->afficher();
					jeu->afficher_Liste(jeu->listejeton, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
					TokenList_AjouterToken_EnFin(jeu->listejeton, jeu->genjeton->head->jeton);
					TokenList_Remove(jeu->genjeton, jeu->genjeton->head);
					TokenList_AjouterToken_Alea(jeu->genjeton, jeu->nb_colors, jeu->nb_shapes);
					//jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
					jeu->afficher_control();
					MLV_save_screen();
					jeu->move_jeton(jeu->listejeton->tail->jeton, WIDTH/2, jeu->genListe_Y(), jeu->spPosX(jeu->listejeton->taille, jeu->listejeton->taille-1), jeu->spPosY(jeu->listejeton->taille, jeu->listejeton->taille-1));
				}
				else
				{
					TokenList_AjouterToken_EnFin(jeu->listejeton, jeu->genjeton->head->jeton);
					TokenList_Remove(jeu->genjeton, jeu->genjeton->head);
					TokenList_AjouterToken_Alea(jeu->genjeton, NB_COLOR, NB_SHAPE);
				}
				jeu->need_refresh = 1;
				break;
				case Control_None:
				if(!Tuto_CheckAction(tuto, Control_None))
					break;
				tuto = Tuto_Validate(tuto, Control_None, CR_None);
				{
					PlayedToken *cur = NULL;
					if((cur = jeu->get_PlayedToken(jeu->listejeton, x, y)) != NULL)
					{
						/*int decal = 1;
						if(jeu->listejeton->taille % 2 == 0)
							decal = 0;*/
						if(jeu->afficher_choix_rotate(cur, jeu->spPosX(jeu->listejeton->taille, TokenList_GetId_OfPlayedToken(jeu->listejeton, cur)), jeu->spPosY(jeu->listejeton->taille, TokenList_GetId_OfPlayedToken(jeu->listejeton, cur))))
						{//((x+((JETON_SIZE/2)*(decal)))/(JETON_SIZE))*(JETON_SIZE)+((JETON_SIZE/2)*(!decal))
							MLV_actualise_window();
							jeu->need_refresh = 1;
							int nx, ny;
							MLV_Event ev;
							while((ev = Jeu_WaitEvent(&nx, &ny)) != MLV_MOUSE_BUTTON && jeu->actif)
							{
								if(ev == MLV_NONE && time(NULL) >= jeu->start_time + jeu->party_time)
									jeu->actif = 0;
								jeu->afficher();
								if(jeu->afficher_avatar != NULL)
									jeu->afficher_avatar(jeu->avatar);
								jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
								jeu->afficher_Liste(jeu->listejeton, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
								jeu->afficher_control();
								jeu->afficher_choix_rotate(cur, jeu->spPosX(jeu->listejeton->taille, TokenList_GetId_OfPlayedToken(jeu->listejeton, cur)), jeu->spPosY(jeu->listejeton->taille, TokenList_GetId_OfPlayedToken(jeu->listejeton, cur)));
								MLV_actualise_window();
							}
							if(jeu->actif)
							{
								switch(jeu->get_choix_rotate_action(jeu->spPosX(jeu->listejeton->taille, TokenList_GetId_OfPlayedToken(jeu->listejeton, cur)), jeu->spPosY(jeu->listejeton->taille, TokenList_GetId_OfPlayedToken(jeu->listejeton, cur)), nx, ny))
								{
									case CR_Couleur:
									if(!Tuto_CheckCR(tuto, CR_Couleur))
										break;
									tuto = Tuto_Validate(tuto, Control_None, CR_Couleur);
									if(cur->nextColor == cur)
										break;
									if(jeu->afficher_rotate != NULL)
									{
										jeu->afficher();
										if(jeu->afficher_avatar != NULL)
											jeu->afficher_avatar(jeu->avatar);
										jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
										jeu->afficher_control();
										MLV_save_screen();
										jeu->afficher_rotate(jeu->listejeton, CR_Couleur, cur->jeton.color, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
									}
									TokenList_RotateLeftByColor(jeu->listejeton, cur);
									break;
									case CR_Forme:
									if(!Tuto_CheckCR(tuto, CR_Forme))
										break;
									tuto = Tuto_Validate(tuto, Control_None, CR_Forme);
									if(cur->nextForm == cur)
										break;
									if(jeu->afficher_rotate != NULL)
									{
										jeu->afficher();
										if(jeu->afficher_avatar != NULL)
											jeu->afficher_avatar(jeu->avatar);
										jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
										jeu->afficher_control();
										MLV_save_screen();
										jeu->afficher_rotate(jeu->listejeton, CR_Forme, cur->jeton.form, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
									}
									TokenList_RotateLeftByForm(jeu->listejeton, cur);
									break;
									default:
									tuto = Tuto_Validate(tuto, Control_None, CR_None);
									break;
								}
							}
						}
						else
							tuto = Tuto_Validate(tuto, Control_None, CR_None);
					}
				}
				break;
			}
			trio_tours = 0;
			while(TokenList_RemoveTrio(jeu->listejeton, &(jeu->score)))
			{
				if(jeu->afficher_AnimList != NULL)
				{
					jeu->afficher();
					if(jeu->afficher_avatar != NULL)
						jeu->afficher_avatar(jeu->avatar);
					jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
					jeu->afficher_control();
					MLV_save_screen();
					jeu->afficher_AnimList(jeu->animdata->listeanim, jeu->startPosX(jeu->animdata->listeanim->taille), jeu->startPosY(jeu->animdata->listeanim->taille));
				}
				if(trio_tours != 0)
				{
					jeu->score += ((jeu->score-last_score)*fibo(2+(trio_tours)*3));
				}
				jeu->afficher();
				if(jeu->afficher_avatar != NULL)
					jeu->afficher_avatar(jeu->avatar);
				jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
				jeu->afficher_Liste(jeu->listejeton, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
				jeu->afficher_control();
				MLV_actualise_window();
				jeu->score += (((jeu->score-last_score)*((jeu->nb_shapes+jeu->nb_colors/2)-2)) - (jeu->score-last_score));
				if(jeu->afficher_ajout_score != NULL)
					jeu->afficher_ajout_score(jeu->score-last_score, WIDTH/2, (HEIGHT)/4);
				trio_tours ++;
				last_score = jeu->score;
				jeu->party_time += jeu->nb_shapes+jeu->nb_colors-6;
			}
			if(jeu->listejeton->taille == LISTE_LIMITE)
			{
				jeu->actif = 0;
			}
			break;
			case MLV_KEY:
			{
				int actual_time = time(NULL);
				menu_quit &= !(jeu->actif &= Jeu_Menu_In_Game());
				jeu->party_time += time(NULL)-actual_time;//On ne pénalise pas un joueur sur son temps s'il a lancé le menu
				jeu->need_refresh = 1;
			}
			break;
			case MLV_NONE:
			jeu->need_refresh = 1;
			break;
			default:
			break;
		}
		if(time(NULL) >= jeu->start_time + jeu->party_time)
			jeu->actif = 0;
	}
	if(!menu_quit && jeu->score != 0)
		maj_score(jeu->pseudo, jeu->score);
	if(jeu->is_tuto)
		Tuto_Free(&tuto_main);
	if(jeu->listejeton != NULL)
		TokenList_Free(&(jeu->listejeton));
	if(jeu->genjeton != NULL)
		TokenList_Free(&(jeu->genjeton));
	MLV_change_frame_rate(100);
	return 1;
}

void Jeu_Set_Game_Mode(Game_Mode new_mode)
{
	switch(new_mode)
	{
		case Game_Mode_Base:
		jeu->prepare_sprites = NULL;
		jeu->afficher = Jeu_Base_Afficher;
		jeu->afficher_Liste = Jeu_Base_Afficher_Liste;
		jeu->afficher_GenListe = Jeu_Base_Afficher_Liste;
		jeu->afficher_AnimList = NULL;
		jeu->afficher_control = Jeu_Base_Afficher_Controles;
		jeu->afficher_plateau = Jeu_Base_Afficher_Plateau;
		jeu->afficher_jeton = Jeu_Base_Afficher_Jeton;
		jeu->get_control_action = Jeu_Base_Control_GetAction;
		jeu->get_PlayedToken = Jeu_Base_GetPlayedToken;
		jeu->afficher_choix_rotate = Jeu_Base_Afficher_ChoixRotate;
		jeu->get_choix_rotate_action = Jeu_Base_Choix_Rotate_GetAction;
		jeu->afficher_rotate = NULL;
		jeu->move_jeton = NULL;
		jeu->startPosX = Jeu_Base_StartPosX_Liste;
		jeu->startPosY = Jeu_Base_StartPosY_Liste;
		jeu->spPosX = Jeu_Base_SpPosX_Liste;
		jeu->spPosY = Jeu_Base_SpPosY_Liste;
		jeu->afficher_ajout_score = NULL;
		jeu->genListe_Y = Jeu_Base_GenListe_Y;
		jeu->afficher_avatar = NULL;
		break;
		case Game_Mode_Anim:
		jeu->prepare_sprites = Jeu_Anim_Prepare_Sprites;
		jeu->afficher = Jeu_Anim_Afficher;
		jeu->afficher_Liste = Jeu_Anim_Afficher_Liste;
		jeu->afficher_GenListe = Jeu_Anim_Afficher_GenListe;
		jeu->afficher_AnimList = Jeu_Anim_Afficher_Anim_Liste;
		jeu->afficher_control = Jeu_Anim_Afficher_Controles;
		jeu->afficher_plateau = Jeu_Anim_Afficher_Plateau;
		jeu->afficher_jeton = Jeu_Anim_Afficher_Jeton;
		jeu->get_control_action = Jeu_Anim_Control_GetAction;
		jeu->get_PlayedToken = Jeu_Anim_GetPlayedToken;
		jeu->afficher_choix_rotate = Jeu_Anim_Afficher_ChoixRotate;
		jeu->get_choix_rotate_action = Jeu_Anim_Choix_Rotate_GetAction;
		jeu->afficher_rotate = Jeu_Anim_ShowRotateLeft;
		jeu->move_jeton = Jeu_Anim_MoveJeton_Anim;
		jeu->startPosX = Jeu_Anim_StartPosX_Liste;
		jeu->startPosY = Jeu_Anim_StartPosY_Liste;
		jeu->spPosX = Jeu_Anim_SpPosX_Liste;
		jeu->spPosY = Jeu_Anim_SpPosY_Liste;
		jeu->afficher_ajout_score = Jeu_Anim_PrintAnim_Score_Ajout;
		jeu->genListe_Y = Jeu_Anim_GenListe_Y;
		jeu->afficher_avatar = Avatar_AfficherPerso;
		break;
		default:
		return;
	}
	jeu->game_mode = new_mode;
}

void Jeu_Show_Images()
{
	int i, j, k, l;
	MLV_clear_window(MLV_COLOR_BLACK);
	for(i = 0; i < NB_COLOR; i ++)
	{
		for(j = 0; j < NB_SHAPE; j ++)
		{
			MLV_draw_image(jeu->animdata->jetonimage[i][j], i*JETON_SIZE, j*JETON_SIZE);
		}
	}
	MLV_actualise_window();
	MLV_wait_mouse(NULL, NULL);
	for(l = 0; l < NB_ANIM_IMG; l ++)
	{
		for(k = 0; k < NB_FRAMES; k ++)
		{
			MLV_clear_window(MLV_COLOR_BLACK);
			for(i = 0; i < NB_COLOR; i ++)
			{
				for(j = 0; j < NB_SHAPE; j ++)
				{
					MLV_draw_image(jeu->animdata->jetonimageanim[i][j][l][k], i*JETON_SIZE, j*JETON_SIZE);
				}
			}
			MLV_draw_text(0, 0, "(%d, %d)", MLV_COLOR_WHITE, l, k);
			MLV_actualise_window();
			MLV_wait_mouse(NULL, NULL);
		}
	}
}

void Jeu_Set_Difficulty(Difficulty lv)
{
	if(lv == TUTO)
		jeu->is_tuto = 1;
	jeu->nb_colors = jeu->nb_shapes = lv;
}

void Jeu_Set_Screen_Dimensions(int width, int height)
{
	jeu->width = width;
	jeu->height = height;
	MLV_change_window_size(WIDTH, HEIGHT);
}


int continuer(void)
{
	return 1337;
}
int retour_au_menu(void)
{
	return -2;
}
int Jeu_Menu_In_Game()
{
	ButtonList *lst2 = ButtonList_Init();
	MLV_Font *font = MLV_load_font("media/sewer.ttf", 60);
	ButtonList_AddButton(lst2, SCREEN_WIDTH/2, 300, 5, "CONTINUER", font, continuer);
	ButtonList_AddButton(lst2, SCREEN_WIDTH/2, 390, 5, "SAUVEGARDER", font, Sauv_Partie);
	ButtonList_AddButton(lst2, SCREEN_WIDTH/2, 480, 5, "CLASSEMENT", font, classement2);
	ButtonList_AddButton(lst2, SCREEN_WIDTH/2, 570, 5, "RETOUR AU MENU", font, retour_au_menu);
	
	// Affichages
	ButtonList_AnimButtons(lst2);
	draw_titleMain("media/sewer.ttf", "THREE TO GO", 90, lst2);
	MLV_draw_filled_rectangle(SCREEN_WIDTH/2-lst2->max_width/2-80,233,lst2->max_width+160,240+lst2->nb*50-20,MLV_rgba(15,15,15,255));
	MLV_draw_rectangle(SCREEN_WIDTH/2-lst2->max_width/2-80,98,lst2->max_width+160,377+lst2->nb*50-20,MLV_rgba(120,120,120,50));
	ButtonList_AffAll(lst2);
	
	int c=1;
	while(c != -2 && c!= 1337)
	{
		c = ButtonList_Event(lst2);
		if(c == -1)
		{
			jeu->afficher();
			jeu->afficher_GenListe(jeu->genjeton, WIDTH/2, jeu->genListe_Y());
			jeu->afficher_Liste(jeu->listejeton, jeu->startPosX(jeu->listejeton->taille), jeu->startPosY(jeu->listejeton->taille));
			jeu->afficher_control();
			draw_titleMain("media/sewer.ttf", "THREE TO GO", 90, lst2);
			MLV_draw_filled_rectangle(SCREEN_WIDTH/2-lst2->max_width/2-80,233,lst2->max_width+160,240+lst2->nb*50-20,MLV_rgba(15,15,15,255));
			MLV_draw_rectangle(SCREEN_WIDTH/2-lst2->max_width/2-80,98,lst2->max_width+160,377+lst2->nb*50-20,MLV_rgba(120,120,120,50));
			ButtonList_AffAll(lst2);
			MLV_actualise_window();
		}
	}
	
	MLV_free_font(font);
	ButtonList_FreeAll(&lst2);
	if(c == -2)
		return 0;
	if(c == 1337)
		return 1;
	return 1;
}
