#ifndef DEF_HEADER_JEU
#define DEF_HEADER_JEU

#include "struct_data.h"
#include "init_data.h"
#include "modif_data.h"
#include "tuto.h"
#include "avatar.h"

#include "jeu_base.h"
#include "jeu_anim.h"

#include "menu.h"

int Jeu_Play();
/*
Lance une partie selon le paramètre prédefinis à l'avance dans le jeu
*/

void Jeu_Set_Game_Mode(Game_Mode new_mode);
/*
Permet de définir le mode d'affichage du jeu
*/

void Jeu_Set_Difficulty(Difficulty lv);
/*
Permet de définir le niveau de difficluté de la partie qui va suivre
*/

int Jeu_Load_Partie(const char *file_name);
/*
Permet de charger une partie avant de lancer le jeu
*/

int Jeu_Menu_In_Game();
/*
Permet de lancer le menu durant le jeu
renvoie 0 pour dire qu'on sort du jeu
renvoie 1 pour dire qu'on continue le jeu
Si on effectue le chargement d'une partie/retour au menu principal on renvoie 0
Si on quitte le jeu on renvoie 0
Si on sauvegarde une partie ou qu'on continue à jouer on renvoie 1
*/

void Jeu_Set_Screen_Dimensions(int width, int height);
/*
Permet de redéfinir la taille de la fenêtre
*/

MLV_Event Jeu_WaitEvent(int *x, int *y);
/*
Permet de gérer les événements du jeu
*/

void Jeu_Show_Images();
/*
Fonction de test permettant d'observer les images générées des jetons par la programme
*/

#endif
