#include "jeu_anim.h"

int Jeu_Anim_GenListe_Y()
{
	return (HEIGHT)/2;
}

int Jeu_Anim_StartPosX_Liste(int taille)
{
	return (WIDTH/2 - (((taille-1) * JETON_SIZE)/2));
}

int Jeu_Anim_StartPosY_Liste(int taille)
{
	return (JETON_SIZE + (5*HEIGHT)/8);
}

int Jeu_Anim_SpPosX_Liste(int taille, int id)
{
	return Jeu_Anim_StartPosX_Liste(taille) + (id * JETON_SIZE);
}

int Jeu_Anim_SpPosY_Liste(int taille, int id)
{
	return Jeu_Anim_StartPosY_Liste(taille);
}

void Jeu_Anim_Afficher()
{
	MLV_clear_window(MLV_COLOR_BLACK);
	if(jeu->plateau != NULL)
		MLV_draw_image(jeu->plateau, 0, 0);
	Jeu_Anim_Afficher_Plateau((5*HEIGHT)/8);
	MLV_draw_text_with_font(10, 10, "Score: %d", jeu->police, MLV_COLOR_YELLOW, jeu->score);
	if(!jeu->is_tuto)
		afficher_temps(10, 60);
}

void Jeu_Anim_Afficher_Plateau(int y)
{
	MLV_draw_filled_rectangle(0, y, WIDTH, 2*JETON_SIZE, MLV_rgba(127, 127, 127, 255));
	MLV_draw_filled_rectangle(0, y, WIDTH, JETON_SIZE/4, MLV_rgba(196, 196, 196, 255));
	MLV_draw_filled_rectangle(0, y+(2*JETON_SIZE)-(JETON_SIZE/4), WIDTH, JETON_SIZE/4, MLV_rgba(63, 63, 63, 255));
	MLV_draw_filled_rectangle(0, y, WIDTH, JETON_SIZE/16, MLV_rgba(226, 226, 226, 255));
	MLV_draw_filled_rectangle(0, y+(2*JETON_SIZE)-(JETON_SIZE/16), WIDTH, JETON_SIZE/16, MLV_rgba(31, 31, 31, 255));
}

void Jeu_Anim_Afficher_Jeton(Token jeton, int x, int y)
{
	//if(jeton != NULL)
	{
		MLV_draw_image(	jeu->animdata->jetonimage[jeton.color][jeton.form],
				x-(MLV_get_image_width(jeu->animdata->jetonimage[jeton.color][jeton.form])/2),
				y-(MLV_get_image_height(jeu->animdata->jetonimage[jeton.color][jeton.form])/2));
	}
}

void Jeu_Anim_Afficher_Jeton_BySize(Token jeton, int x, int y, int size, int type)
{
	//if(jeton != NULL)
	{
		MLV_draw_image(	jeu->animdata->jetonimageanim[jeton.color][jeton.form][type][size],
				x-(MLV_get_image_width(jeu->animdata->jetonimageanim[jeton.color][jeton.form][type][size])/2),
				y-(MLV_get_image_height(jeu->animdata->jetonimageanim[jeton.color][jeton.form][type][size])/2));
		/*MLV_Image *copie = MLV_copy_image(jeu->animdata->jetonimage[jeton.color][jeton.form]);
		MLV_scale_image(copie, ((double)size)/((double)(JETON_SIZE)));
		MLV_draw_image(copie, x-(MLV_get_image_width(copie)/2), y-(MLV_get_image_height(copie)/2));
		MLV_free_image(copie);*/
	}
}

void Jeu_Anim_Afficher_Liste(TokenList *listejeton, int x, int y)
{
	PlayedToken *cur = listejeton->head;
	while(cur != NULL)
	{
		Jeu_Anim_Afficher_Jeton(cur->jeton, x, y);
		cur = cur->next;
		x += JETON_SIZE;
	}
}

void Jeu_Anim_Afficher_GenListe(TokenList *listejeton, int x, int y)
{
	PlayedToken *cur = listejeton->head;
	int i = 0;
	while(cur != NULL)
	{
		
		Jeu_Anim_Afficher_Jeton_BySize(cur->jeton, x, y, i*2, SCALE);
		y -= MLV_get_image_height(jeu->animdata->jetonimageanim[cur->jeton.color][cur->jeton.form][SCALE][i*2]);
		x -= MLV_get_image_height(jeu->animdata->jetonimageanim[cur->jeton.color][cur->jeton.form][SCALE][i*2])*2;
		cur = cur->next;
		i++;
	}
}

void Jeu_Anim_Afficher_Anim_Liste(AnimList *listeanim, int x, int y)
{
	int t = 0;
	int x_base = x;
	int *anim_id_x = NULL;
	int *anim_id_nb = NULL;
	int anim_id_max=0;
	int nb_dispa = 0;
	if((anim_id_x = (int*)calloc(listeanim->taille, sizeof(int))) == NULL);
	else if((anim_id_nb = (int*)calloc(listeanim->taille, sizeof(int))) == NULL);
	else
	{
		AnimToken *cur = listeanim->head;
		x = x_base;
		while(cur != NULL)
		{
			if(cur->disparition)
			{
				anim_id_max = max(anim_id_max, cur->anim_id);
				anim_id_x[cur->anim_id] += x;
				anim_id_nb[cur->anim_id] ++;
				nb_dispa ++;
			}
			cur = cur->next;
			x += JETON_SIZE;
		}
		anim_id_max ++;
		for(t = 0; t < anim_id_max; t ++)
		{
			if(anim_id_nb[t] != 0)
				anim_id_x[t] /= anim_id_nb[t];
		}
		for(t = 0; t < 5; t ++)
		{
			x = x_base;
			MLV_load_screen();
			cur = listeanim->head;
			while(cur != NULL)
			{
				if(cur->disparition)
					Jeu_Anim_Afficher_Jeton_BySize(cur->jeton, ((x*(5-t))+(anim_id_x[cur->anim_id]*t))/5, y, t*2, SHINE_SCALE);
				else
					Jeu_Anim_Afficher_Jeton(cur->jeton, x, y);
				cur = cur->next;
				x += JETON_SIZE;
			}
			MLV_actualise_window();
			//MLV_wait_milliseconds(10);
			MLV_delay_according_to_frame_rate();
		}
		MLV_load_screen();
		Jeu_Anim_Afficher_Liste(jeu->listejeton, x_base+((nb_dispa*JETON_SIZE)/2), y);
		MLV_save_screen();
		Token jeton = {BLANC, CERCLE};
		int i = 0;
		for(t = 0; t <= 5; t ++)
		{
			MLV_load_screen();
			for(i = 0; i < anim_id_max; i ++)
			{
				Jeu_Anim_Afficher_Jeton_BySize(jeton, (((WIDTH/2)*t)+(anim_id_x[i]*(5-t)))/5, (((HEIGHT/2)*t)+(y*(5-t)))/5, 5, SCALE);
			}
			MLV_actualise_window();
			MLV_delay_according_to_frame_rate();
		}
	}
	free(anim_id_x);
	free(anim_id_nb);
}

void Jeu_Anim_Afficher_Anim_Liste_Hiden(AnimList *listeanim, int x, int y)
{
	AnimToken *cur = listeanim->head;
	while(cur != NULL)
	{
		if(!cur->disparition)
			Jeu_Anim_Afficher_Jeton(cur->jeton, x, y);
		cur = cur->next;
		x += JETON_SIZE;
	}
}

void Jeu_Anim_Afficher_Controles()
{
	MLV_Image *tmp = MLV_Image_Create_Cercle(MLV_COLOR_CYAN, 50*2);
	MLV_draw_image(tmp, -(MLV_get_image_width(tmp)/2)+WIDTH/4, -(MLV_get_image_height(tmp)/2)+HEIGHT/2);
	MLV_draw_image(tmp, -(MLV_get_image_width(tmp)/2)+(3*WIDTH)/4, -(MLV_get_image_height(tmp)/2)+HEIGHT/2);
	/*MLV_draw_filled_circle(WIDTH/4, HEIGHT/2, 50, MLV_COLOR_CYAN);
	MLV_draw_filled_circle((3*WIDTH)/4, HEIGHT/2, 50, MLV_COLOR_CYAN);*/
	MLV_free_image(tmp);
}

Control Jeu_Anim_Control_GetAction(int x, int y)
{
	if(x < WIDTH/2)
	{
		if(pow(x-WIDTH/4, 2)+pow(y-HEIGHT/2, 2) < 2500)
			return Control_Tete;
	}
	else
	{	if(pow(x-(3*WIDTH)/4, 2)+pow(y-HEIGHT/2, 2) < 2500)
			return Control_Fin;
	}
	return Control_None;
}

void Jeu_Anim_MoveJeton_Anim(Token jeton, int x_start, int y_start, int x_end, int y_end)
{
	int t;
	for(t = 0; t < 4; t ++)
	{
		MLV_load_screen();
		if(x_end > x_start)
		{
			CORPS_BRAS_D(jeu->avatar->corps)->rotate = t*10;
			CORPS_BRAS_G(jeu->avatar->corps)->rotate = t*5;
			CORPS_AVB_D(jeu->avatar->corps)->rotate = t*10;
			CORPS_AVB_G(jeu->avatar->corps)->rotate = t*5;
		}
		else if(x_end < x_start)
		{
			CORPS_BRAS_D(jeu->avatar->corps)->rotate = -t*5;
			CORPS_BRAS_G(jeu->avatar->corps)->rotate = -t*10;
			CORPS_AVB_D(jeu->avatar->corps)->rotate = -t*5;
			CORPS_AVB_G(jeu->avatar->corps)->rotate = -t*10;
		}
		else
		{
			CORPS_BRAS_D(jeu->avatar->corps)->rotate = -t*10;
			CORPS_BRAS_G(jeu->avatar->corps)->rotate = t*10;
			CORPS_AVB_D(jeu->avatar->corps)->rotate = -t*5;
			CORPS_AVB_G(jeu->avatar->corps)->rotate = t*5;
		}
		Avatar_AfficherPerso(jeu->avatar);
		jeu->afficher_GenListe(jeu->genjeton, WIDTH/2-JETON_SIZE*2+(t*JETON_SIZE*2)/5, jeu->genListe_Y()-JETON_SIZE+(t*JETON_SIZE)/5);
		Jeu_Anim_MoveJeton(jeton, x_start, y_start, x_end, y_end, t+1, 5);
		MLV_actualise_window();
		MLV_wait_milliseconds(5);
	}
	CORPS_BRAS_D(jeu->avatar->corps)->rotate = 0;
	CORPS_BRAS_G(jeu->avatar->corps)->rotate = 0;
	CORPS_AVB_D(jeu->avatar->corps)->rotate = 0;
	CORPS_AVB_G(jeu->avatar->corps)->rotate = 0;
}

void Jeu_Anim_MoveJeton(Token jeton, int x_start, int y_start, int x_end, int y_end, int temps_actuel, int temps_total)
{
	//if(jeton != NULL)
	{
		int vx = ((x_end-x_start)*temps_actuel)/temps_total;
		int vy = ((y_end-y_start)*temps_actuel)/temps_total;
		Jeu_Anim_Afficher_Jeton(jeton, x_start+vx, y_start+vy);
	}
}

void Jeu_Anim_MoveJetonRotation(Token jeton, int x_start, int y_start, int x_end, int y_end, int amplitude, int temps_actuel, int temps_total)
{
	//if(jeton != NULL)
	{
		int x = x_start + (((x_end-x_start)*temps_actuel)/temps_total);
		int y_base = y_start + (((y_end-y_start)*temps_actuel)/temps_total);
		int y = y_base + ((-4*amplitude*(x-x_start)*(x-x_end))/carre(x_start-x_end));
		Jeu_Anim_Afficher_Jeton(jeton, x, y);
	}
}

void Jeu_Anim_ShowRotateLeft(TokenList *listejeton, Choix_Rotate cr, int attrib, int x, int y)
{
	int *pos_debut = NULL;
	int *pos_fin = NULL;
	Token *jetons = NULL;
	int nb_jetons = 0;
	if(	(pos_debut = (int*)malloc(listejeton->taille*sizeof(int))) != NULL
		&& (pos_fin = (int*)malloc(listejeton->taille*sizeof(int))) != NULL
		&& (jetons = (Token*)malloc(listejeton->taille*sizeof(Token))) != NULL)
	{
		if(cr == CR_Couleur)
		{
			PlayedToken *debut = listejeton->head_color[attrib];
			PlayedToken *cur = debut;
			if(cur != NULL)
			{
				do
				{
					jetons[nb_jetons] = cur->jeton;
					pos_debut[nb_jetons] = x + (TokenList_GetId_OfPlayedToken(listejeton, cur) * JETON_SIZE);
					pos_fin[nb_jetons] = x + (TokenList_GetId_OfPlayedToken(listejeton, cur->prevColor) * JETON_SIZE);
					nb_jetons ++;
					cur = cur->prevColor;
				}while(cur != debut);
			}
			AnimData_Clear(jeu->animdata);
			cur = listejeton->head;
			while(cur != NULL)
			{
				AnimList_AjouterToken_EnFin(jeu->animdata->listeanim, cur->jeton);
				if(cur->jeton.color == attrib)
					jeu->animdata->listeanim->tail->disparition = 1;
				cur = cur->next;
			}
		}
		else if(cr == CR_Forme)
		{
			PlayedToken *debut = listejeton->head_shape[attrib];
			PlayedToken *cur = debut;
			if(cur != NULL)
			{
				do
				{
					jetons[nb_jetons] = cur->jeton;
					pos_debut[nb_jetons] = x + (TokenList_GetId_OfPlayedToken(listejeton, cur) * JETON_SIZE);
					pos_fin[nb_jetons] = x + (TokenList_GetId_OfPlayedToken(listejeton, cur->prevForm) * JETON_SIZE);
					nb_jetons ++;
					cur = cur->prevForm;
				}while(cur != debut);
			}
			AnimData_Clear(jeu->animdata);
			cur = listejeton->head;
			while(cur != NULL)
			{
				AnimList_AjouterToken_EnFin(jeu->animdata->listeanim, cur->jeton);
				if(cur->jeton.form == attrib)
					jeu->animdata->listeanim->tail->disparition = 1;
				cur = cur->next;
			}
		}
		if(nb_jetons > 0)
		{
			MLV_load_screen();
			Jeu_Anim_Afficher_Anim_Liste_Hiden(jeu->animdata->listeanim, x, y);
			MLV_save_screen();
			int t, i, s;
			for(t = 0; t < 7; t ++)
			{
				MLV_load_screen();
				for(i = 0; i < nb_jetons; i ++)
				{
					s = 1;
					if(pos_debut[i]>pos_fin[i])
						s = -1;
					Jeu_Anim_MoveJetonRotation(jetons[i], pos_debut[i], y, pos_fin[i], y, s*JETON_SIZE, t+1, 8);
				}
				MLV_actualise_window();
				MLV_wait_milliseconds(5);
			}
		}
		free(jetons);
		free(pos_debut);
		free(pos_fin);
	}
}

PlayedToken *Jeu_Anim_GetPlayedToken(TokenList *listejeton, int x, int y)
{
	if(y > JETON_SIZE/2 + (5*HEIGHT)/8 && y < (JETON_SIZE*3)/2 + (5*HEIGHT)/8)
	{
		int id = (-(WIDTH/2 - (((listejeton->taille-1) * JETON_SIZE)/2)) + x + (JETON_SIZE/2));
		if(id < 0)
			return NULL;
		id /= JETON_SIZE;
		//printf("%d %d %d\n", -(WIDTH/2 - (((listejeton->taille-1) * JETON_SIZE)/2)) + x, JETON_SIZE, ((-(WIDTH/2 - (((listejeton->taille-1) * JETON_SIZE)/2)) + x)/JETON_SIZE));
		if(id >= 0 && id < listejeton->taille)
		{
			return TokenList_GetPlayedToken_ById(listejeton, id);
		}
	}
	return NULL;
}

int Jeu_Anim_Afficher_ChoixRotate(PlayedToken *cur, int x, int y)
{
	int aff = 0;
	if(cur->nextColor != cur)
	{
		MLV_draw_filled_rectangle(x-(JETON_SIZE/2), y-((JETON_SIZE*3)/2), JETON_SIZE, JETON_SIZE, MLV_COLOR_WHITE);
		MLV_draw_filled_rectangle(x-(JETON_SIZE/2)+1, y-((JETON_SIZE*3)/2)+1, JETON_SIZE-2, JETON_SIZE-2, MLV_COLOR_BLACK);
		MLV_draw_filled_rectangle(x-(JETON_SIZE/2)+2, y-((JETON_SIZE*3)/2)+2, JETON_SIZE-4, JETON_SIZE-4, Get_MLV_Color(cur->jeton.color));
		aff = 1;
	}
	if(cur->nextForm != cur)
	{
		Jeu_Base_Afficher_JetonRC(cur->jeton, x, y+JETON_SIZE, 0, MLV_COLOR_WHITE);
		Jeu_Base_Afficher_JetonRC(cur->jeton, x, y+JETON_SIZE, 1, MLV_COLOR_BLACK);
		Jeu_Base_Afficher_JetonRC(cur->jeton, x, y+JETON_SIZE, 2, MLV_COLOR_WHITE);
		aff = 1;
	}
	return aff;
}

Choix_Rotate Jeu_Anim_Choix_Rotate_GetAction(int base_x, int base_y, int x, int y)
{
	if(y < base_y)
	{
		if(	y > base_y-((JETON_SIZE*3)/2)
			&& y < base_y-((JETON_SIZE*3)/2)+JETON_SIZE
			&& x > base_x-(JETON_SIZE/2)
			&& x < base_x-(JETON_SIZE/2)+JETON_SIZE)
			return CR_Couleur;
	}
	else
	{
		{
		if(	y > base_y+((JETON_SIZE)/2)
			&& y < base_y+((JETON_SIZE)/2)+JETON_SIZE
			&& x > base_x-(JETON_SIZE/2)
			&& x < base_x-(JETON_SIZE/2)+JETON_SIZE)
			return CR_Forme;
		}
	}
	return CR_None;
}

void Jeu_Anim_Prepare_Sprites(int nb_colors, int nb_shapes)
{
	if(!jeu->animdata->loaded)
	{
		int i, j, k, l;
		MLV_Image *tmp = NULL;
		for(i = 0; i < nb_colors; i ++)
		{
			for(j = 0; j < nb_shapes; j ++)
			{
				switch(j)
				{
					case CERCLE:
					jeu->animdata->jetonimage[i][j] = MLV_Image_Create_Cercle(Get_MLV_Color(i), JETON_SIZE-6);
					tmp = MLV_Image_Create_Cercle(Get_MLV_Color(i), JETON_SIZE+2);
					break;
					case TRIANGLE:
					jeu->animdata->jetonimage[i][j] = MLV_Image_Create_Triangle(Get_MLV_Color(i), JETON_SIZE-6);
					tmp = MLV_Image_Create_Triangle(Get_MLV_Color(i), JETON_SIZE+2);
					break;
					case CARRE:
					jeu->animdata->jetonimage[i][j] = MLV_Image_Create_Carre(Get_MLV_Color(i), JETON_SIZE-6);
					tmp = MLV_Image_Create_Carre(Get_MLV_Color(i), JETON_SIZE+2);
					break;
					case DIAMANT:
					jeu->animdata->jetonimage[i][j] = MLV_Image_Create_Losange(Get_MLV_Color(i), JETON_SIZE-6);
					tmp = MLV_Image_Create_Losange(Get_MLV_Color(i), JETON_SIZE+2);
					break;
					case ETOILE:
					jeu->animdata->jetonimage[i][j] = MLV_Image_Create_Etoile(Get_MLV_Color(i), JETON_SIZE-6);
					tmp = MLV_Image_Create_Etoile(Get_MLV_Color(i), JETON_SIZE+2);
					break;
					case HEXAGONE:
					jeu->animdata->jetonimage[i][j] = MLV_Image_Create_Hexagone(Get_MLV_Color(i), JETON_SIZE-6);
					tmp = MLV_Image_Create_Hexagone(Get_MLV_Color(i), JETON_SIZE+2);
					break;
				}
				MLV_Image_applyteinte(tmp, MLV_Color_supteinte, 127);
				for(k = 0; k < NB_ANIM_IMG; k ++)
				{
					switch(k)
					{
						case SCALE:
						jeu->animdata->jetonimageanim[i][j][k][0] = MLV_copy_image(jeu->animdata->jetonimage[i][j]);
						break;
						case SHINE_SCALE:
						MLV_draw_image_on_image(jeu->animdata->jetonimage[i][j], tmp, 4, 4);
						jeu->animdata->jetonimageanim[i][j][k][0] = MLV_copy_image(tmp);
						break;
					}
					for(l = 1; l < NB_FRAMES; l ++)
					{
						jeu->animdata->jetonimageanim[i][j][k][l] = MLV_copy_image(jeu->animdata->jetonimageanim[i][j][k][0]);
						MLV_scale_image(jeu->animdata->jetonimageanim[i][j][k][l], (((double)(NB_FRAMES-l))/((double)NB_FRAMES)));
					}
				}
				MLV_free_image(tmp);
			}
		}
		if(jeu->plateau != NULL)
			MLV_free_image(jeu->plateau);
		jeu->plateau = MLV_create_image(WIDTH, HEIGHT);
		tmp = NULL;
		srand(time(NULL));
		for(i = 0; i < WIDTH; i += JETON_SIZE)
		{
			for(j = 0; j < HEIGHT; j += JETON_SIZE)
			{
				if(rand()%11 != 0)
				{
					switch(rand()%nb_shapes)
					{
						case CERCLE:
						tmp = MLV_Image_Create_Cercle(MLV_Color_teinte(Get_MLV_Color(rand()%nb_colors), 63), JETON_SIZE);
						break;
						case TRIANGLE:
						tmp = MLV_Image_Create_Triangle(MLV_Color_teinte(Get_MLV_Color(rand()%nb_colors), 63), JETON_SIZE);
						break;
						case CARRE:
						tmp = MLV_Image_Create_Carre(MLV_Color_teinte(Get_MLV_Color(rand()%nb_colors), 63), JETON_SIZE);
						break;
						case DIAMANT:
						tmp = MLV_Image_Create_Losange(MLV_Color_teinte(Get_MLV_Color(rand()%nb_colors), 63), JETON_SIZE);
						break;
						case ETOILE:
						tmp = MLV_Image_Create_Etoile(MLV_Color_teinte(Get_MLV_Color(rand()%nb_colors), 63), JETON_SIZE);
						break;
						case HEXAGONE:
						tmp = MLV_Image_Create_Hexagone(MLV_Color_teinte(Get_MLV_Color(rand()%nb_colors), 63), JETON_SIZE);
						break;
					}
					MLV_draw_image_on_image(tmp, jeu->plateau, i, j);
					MLV_free_image(tmp);
				}
			}
		}
		MLV_set_alpha_on_image(63, jeu->plateau);
		jeu->animdata->loaded = 1;
	}
	else if(MLV_get_image_width(jeu->plateau) != WIDTH)
	{
		AnimData_Free(&(jeu->animdata));
		jeu->animdata = AnimData_Create();
		MLV_free_image(jeu->plateau);
		jeu->plateau = NULL;
		Jeu_Anim_Prepare_Sprites(nb_colors, nb_shapes);
	}
}

MLV_Image *MLV_Image_Create_Losange(MLV_Color couleur, int size)
{
	MLV_Image *tmp = MLV_create_image(size+1, size+1);
	MLV_draw_filled_rectangle_on_image(0, 0, size+1, size+1, MLV_rgba(255, 0, 255, 255), tmp);
	{
		int x[] = {0, size/2, size, size/2};
		int y[] = {size/2, 0, size/2, size};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_teinte(couleur, 50), tmp);
	}
	int bord = 1;
	int image_width = size-(2*bord);
	int image_height = image_width;
	{
		int x[] = {bord, bord+image_width/2, image_width+bord, bord+image_width/2};
		int y[] = {bord+image_height/2, bord, bord+image_height/2, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 4, couleur, tmp);
	}
	{
		int x[] = {bord, bord+image_width/2, bord+image_width/2, bord+image_width/5};
		int y[] = {bord+image_height/2, bord, bord+image_height/5, bord+image_height/2};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_supteinte(couleur, 127), tmp);
	}
	{
		int x[] = {bord+image_width, bord+image_width/2, bord+image_width/2, bord+(image_width*4)/5};
		int y[] = {bord+image_height/2, bord+image_height, bord+(image_height*4)/5, bord+image_height/2};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_teinte(couleur, 127), tmp);
	}
	{
		int x[] = {bord+image_width/2, bord+image_width, bord+(image_width*4)/5, bord+image_width/2};
		int y[] = {bord, bord+image_height/2, bord+image_height/2, bord+image_height/5};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_supteinte(couleur, 63), tmp);
	}
	{
		int x[] = {bord, bord+image_width/5, bord+image_width/2, bord+image_width/2};
		int y[] = {bord+image_height/2, bord+image_height/2, bord+(image_height*4)/5, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_teinte(couleur, 190), tmp);
	}
	MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	return tmp;
}

MLV_Image *MLV_Image_Create_Cercle(MLV_Color couleur, int size)
{
	MLV_Image *tmp = MLV_create_image(size+1, size+1);
	MLV_draw_filled_rectangle_on_image(0, 0, size+1, size+1, MLV_rgba(255, 0, 255, 255), tmp);
	{
		MLV_draw_filled_circle_on_image(size/2, size/2, size/2, MLV_Color_teinte(couleur, 50), tmp);
	}
	int bord = 1;
	int image_width = size-(2*bord);
	int image_height = image_width;
	{
		MLV_draw_filled_circle_on_image(bord+image_width/2, bord+image_height/2, image_width/2, MLV_Color_teinte(couleur, 127), tmp);
	}
	{
		image_width -= (bord*8);
		image_height -= (bord*8);
		MLV_draw_filled_circle_on_image(4*bord+image_width/2, 4*bord+image_height/2, image_width/2, MLV_Color_teinte(couleur, 190), tmp);
	}
	{
		image_width -= (bord*8);
		image_height -= (bord*8);
		MLV_draw_filled_circle_on_image(8*bord+image_width/2, 8*bord+image_height/2, image_width/2, MLV_Color_teinte(couleur, 220), tmp);
	}
	{
		image_width -= (bord*8);
		image_height -= (bord*8);
		MLV_draw_filled_circle_on_image(16*bord+image_width/2, 16*bord+image_height/2, image_width/2, couleur, tmp);
	}
	{
		image_width = size/2;
		image_height = size/2;
		MLV_draw_filled_circle_on_image(size/2, size/2, image_width/2, MLV_Color_supteinte(couleur, 63), tmp);
	}
	{
		image_width = size/3;
		image_height = size/3;
		MLV_draw_filled_circle_on_image(size/3, size/3, image_width/2, MLV_Color_supteinte(couleur, 127), tmp);
	}
	MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	return tmp;
}

MLV_Image *MLV_Image_Create_Carre(MLV_Color couleur, int size)
{
	MLV_Image *tmp = MLV_create_image(size, size);
	//MLV_draw_filled_rectangle_on_image(0, 0, JETON_SIZE+1, JETON_SIZE+1, MLV_rgba(255, 0, 255, 255), tmp);
	{
		MLV_draw_filled_rectangle_on_image(0, 0, size, size, MLV_Color_teinte(couleur, 50), tmp);
	}
	int bord = 1;
	int image_width = size-(2*bord)-1;
	int image_height = image_width;
	MLV_draw_filled_rectangle_on_image(bord, bord, image_width, image_height, couleur, tmp);
	{
		int x[] = {bord, bord+image_width, bord+(image_width*4)/5, bord+image_width/5};
		int y[] = {bord, bord, bord+image_height/5, bord+image_height/5};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_supteinte(couleur, 63), tmp);
	}
	{
		int x[] = {bord+(image_width*4)/5, bord+image_width, bord+image_width, bord+(image_width*4)/5};
		int y[] = {bord+image_height/5, bord, bord+image_height, bord+(image_height*4)/5};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_teinte(couleur, 127), tmp);
	}
	{
		int x[] = {bord, bord+image_width/5, bord+image_width/5, bord};
		int y[] = {bord, bord+image_height/5, bord+(image_height*4)/5, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_supteinte(couleur, 127), tmp);
	}
	{
		int x[] = {bord, bord+image_width/5, bord+(image_width*4)/5, bord+image_width};
		int y[] = {bord+image_height, bord+(image_height*4)/5, bord+(image_height*4)/5, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_teinte(couleur, 190), tmp);
	}
	//MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	return tmp;
}

MLV_Image *MLV_Image_Create_Triangle(MLV_Color couleur, int size)
{
	MLV_Image *tmp = MLV_create_image(size+1, size+1);
	MLV_draw_filled_rectangle_on_image(0, 0, size+1, size+1, MLV_rgba(255, 0, 255, 255), tmp);
	{
		int x[] = {size/2, size, 0};
		int y[] = {0, size, size};
		MLV_draw_filled_polygon_on_image(x, y, 3, MLV_Color_teinte(couleur, 50), tmp);
	}
	int bord = 1;
	int image_width = size-(2*bord);
	int image_height = image_width;
	{
		int x[] = {bord+image_width/2, bord+image_width, bord};
		int y[] = {bord, bord+image_height, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 3, couleur, tmp);
	}
	{
		int x[] = {bord+image_width/2, bord+image_width, bord+(image_width*4)/5, bord+image_width/2};
		int y[] = {bord, bord+image_height, bord+(image_height*9)/10, bord+image_height/5};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_supteinte(couleur, 63), tmp);
	}
	{
		int x[] = {bord+image_width/2, bord+image_width/2, bord+image_width/5, bord};
		int y[] = {bord, bord+image_height/5, bord+(image_height*9)/10, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_supteinte(couleur, 127), tmp);
	}
	{
		int x[] = {bord, bord+image_width/5, bord+(image_width*4)/5, bord+image_width};
		int y[] = {bord+image_height, bord+(image_height*9)/10, bord+(image_height*9)/10, bord+image_height};
		MLV_draw_filled_polygon_on_image(x, y, 4, MLV_Color_teinte(couleur, 190), tmp);
	}
	MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	return tmp;
}

MLV_Image *MLV_Image_Create_Etoile(MLV_Color couleur, int size)
{
	MLV_Image *tmp = MLV_create_image(size+1, size+1);
	MLV_draw_filled_rectangle_on_image(0, 0, size+1, size+1, MLV_rgba(255, 0, 255, 255), tmp);
	{
		int x[10];
		int y[10];
		int i;
		for(i = 0; i < 5; i ++)
		{
			x[2*i] = (size/2)+(((size/2)+1)*cos(radian_convert((i*72)-90)));
			y[2*i] = (size/2)+(((size/2)+1)*sin(radian_convert((i*72)-90)));
		}
		for(i = 0; i < 5; i ++)
		{
			x[(2*i)+1] = (size/2)+(((size/4)+1)*cos(radian_convert((i*72)+36-90)));
			y[(2*i)+1] = (size/2)+(((size/4)+1)*sin(radian_convert((i*72)+36-90)));
		}
		MLV_draw_filled_polygon_on_image(x, y, 10, MLV_Color_teinte(couleur, 50), tmp);
	}
	{
		int x[10];
		int y[10];
		int i;
		for(i = 0; i < 5; i ++)
		{
			x[2*i] = (size/2)+((size/2)*cos(radian_convert((i*72)-90)));
			y[2*i] = (size/2)+((size/2)*sin(radian_convert((i*72)-90)));
		}
		for(i = 0; i < 5; i ++)
		{
			x[(2*i)+1] = (size/2)+((size/4)*cos(radian_convert((i*72)+36-90)));
			y[(2*i)+1] = (size/2)+((size/4)*sin(radian_convert((i*72)+36-90)));
		}
		MLV_draw_filled_polygon_on_image(x, y, 10, couleur, tmp);
	}
	{
		int x[4];
		int y[4];
		int i;
		MLV_Color new_couleur;
		for(i = 0; i < 5; i ++)
		{
			x[0] = (size/2)+((size/2)*cos(radian_convert((i*72)-90)));
			x[1] = (size/2)+((size/4)*cos(radian_convert((i*72)+36-90)));
			x[2] = (size/2)+(((size/4)-(size/8))*cos(radian_convert((i*72)+36-90)));
			x[3] = (size/2)+(((size/2)-(size/8))*cos(radian_convert((i*72)-90)));
			y[0] = (size/2)+((size/2)*sin(radian_convert((i*72)-90)));
			y[1] = (size/2)+((size/4)*sin(radian_convert((i*72)+36-90)));
			y[2] = (size/2)+(((size/4)-(size/8))*sin(radian_convert((i*72)+36-90)));
			y[3] = (size/2)+(((size/2)-(size/8))*sin(radian_convert((i*72)-90)));
			switch(i)
			{
				case 4:
				new_couleur = MLV_Color_teinte(couleur, 220);
				break;
				case 0:
				new_couleur = MLV_Color_teinte(couleur, 220);
				break;
				case 1:
				new_couleur = MLV_Color_teinte(couleur, 127);
				break;
				case 2:
				new_couleur = MLV_Color_teinte(couleur, 127);
				break;
				case 3:
				new_couleur = MLV_Color_teinte(couleur, 127);
				break;
			}
			MLV_draw_filled_polygon_on_image(x, y, 4, new_couleur, tmp);
			x[0] = (size/2)+((size/2)*cos(radian_convert((i*72)-90)));
			x[1] = (size/2)+((size/4)*cos(radian_convert(((i-1)*72)+36-90)));
			x[2] = (size/2)+(((size/4)-(size/8))*cos(radian_convert(((i-1)*72)+36-90)));
			x[3] = (size/2)+(((size/2)-(size/8))*cos(radian_convert((i*72)-90)));
			y[0] = (size/2)+((size/2)*sin(radian_convert((i*72)-90)));
			y[1] = (size/2)+((size/4)*sin(radian_convert(((i-1)*72)+36-90)));
			y[2] = (size/2)+(((size/4)-(size/8))*sin(radian_convert(((i-1)*72)+36-90)));
			y[3] = (size/2)+(((size/2)-(size/8))*sin(radian_convert((i*72)-90)));
			switch(i)
			{
				case 0:
				new_couleur = MLV_Color_supteinte(couleur, 96);
				break;
				case 1:
				new_couleur = MLV_Color_teinte(couleur, 190);
				break;
				case 2:
				new_couleur = MLV_Color_teinte(couleur, 220);
				break;
				case 3:
				new_couleur = MLV_Color_teinte(couleur, 220);
				break;
				case 4:
				new_couleur = MLV_Color_supteinte(couleur, 63);
				break;
			}
			MLV_draw_filled_polygon_on_image(x, y, 4, new_couleur, tmp);
		}
	}
	MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	return tmp;
}

MLV_Image *MLV_Image_Create_Hexagone(MLV_Color couleur, int size)
{
	MLV_Image *tmp = MLV_create_image(size+1, size+1);
	MLV_draw_filled_rectangle_on_image(0, 0, size+1, size+1, MLV_rgba(255, 0, 255, 255), tmp);
	{
		int x[6];
		int y[6];
		int i;
		for(i = 0; i < 6; i ++)
		{
			x[i] = (size/2)+(((size/2)+1)*cos(radian_convert((i*60)-90)));
			y[i] = (size/2)+(((size/2)+1)*sin(radian_convert((i*60)-90)));
		}
		MLV_draw_filled_polygon_on_image(x, y, 6, MLV_Color_teinte(couleur, 50), tmp);
	}
	{
		int x[6];
		int y[6];
		int i;
		for(i = 0; i < 6; i ++)
		{
			x[i] = (size/2)+(((size/2))*cos(radian_convert((i*60)-90)));
			y[i] = (size/2)+(((size/2))*sin(radian_convert((i*60)-90)));
		}
		MLV_draw_filled_polygon_on_image(x, y, 6, couleur, tmp);
	}
	{
		int x[4];
		int y[4];
		int i;
		MLV_Color new_couleur;
		for(i = 0; i < 6; i ++)
		{
			x[0] = (size/2)+(((size/2))*cos(radian_convert((i*60)-90)));
			x[1] = (size/2)+(((size/2))*cos(radian_convert(((i+1)*60)-90)));
			x[2] = (size/2)+(((size/2)-(size/5))*cos(radian_convert(((i+1)*60)-90)));
			x[3] = (size/2)+(((size/2)-(size/5))*cos(radian_convert((i*60)-90)));
			y[0] = (size/2)+(((size/2))*sin(radian_convert((i*60)-90)));
			y[1] = (size/2)+(((size/2))*sin(radian_convert(((i+1)*60)-90)));
			y[2] = (size/2)+(((size/2)-(size/5))*sin(radian_convert(((i+1)*60)-90)));
			y[3] = (size/2)+(((size/2)-(size/5))*sin(radian_convert((i*60)-90)));
			switch(i)
			{
				case 5:
				new_couleur = MLV_Color_supteinte(couleur, 127);
				break;
				case 0:
				new_couleur = MLV_Color_supteinte(couleur, 63);
				break;
				case 1:
				new_couleur = MLV_Color_teinte(couleur, 220);
				break;
				case 2:
				new_couleur = MLV_Color_teinte(couleur, 127);
				break;
				case 3:
				new_couleur = MLV_Color_teinte(couleur, 220);
				break;
				case 4:
				new_couleur = MLV_Color_supteinte(couleur, 63);
				break;
			}
			MLV_draw_filled_polygon_on_image(x, y, 4, new_couleur, tmp);
		}
	}
	MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	return tmp;
}

void MLV_setcolorkey_on_image(MLV_Image *image, MLV_Color couleur)
{
	if(image != NULL)
	{
		int image_width = MLV_get_image_width(image);
		int image_height = MLV_get_image_height(image);
		int i, j;
		int r, g, b, a;
		Uint8 main_r, main_g, main_b, main_a;
		MLV_convert_color_to_rgba(couleur, &main_r, &main_g, &main_b, &main_a);
		for(i = 0; i < image_width; i ++)
		{
			for(j = 0; j < image_height; j ++)
			{
				MLV_get_pixel_on_image(image, i, j, &r, &g, &b, &a);
				if(r==main_r && g==main_g && b==main_b)
				{
					MLV_set_pixel_on_image(i, j, MLV_rgba(r, g, b, 0), image);
				}
			}
		}
	}
}

void Jeu_Anim_PrintAnim_Score_Ajout(int score, int x, int y)
{
	MLV_Color couleur = MLV_rgba(255-min((score-120)/10, 255), 255, 0, 255);
	int w, h;
	y+=JETON_SIZE;
	MLV_get_size_of_text_with_font("+%d", &w, &h, jeu->police, score);
	MLV_Image *tmp = MLV_create_image(w+2, h+2);
	MLV_draw_filled_rectangle_on_image(0, 0, w+2, h+2, MLV_rgba(255, 0, 255, 255), tmp);
	MLV_setcolorkey_on_image(tmp, MLV_rgba(255, 0, 255, 255));
	int i, j;
	for(i = 0; i <= 2; i += 2)
	{
		for(j = 0; j <= 2; j += 2)
		{
			MLV_draw_text_with_font_on_image(i, j, "+%d", jeu->police, MLV_Color_teinte(couleur, 63), tmp, score);
		}
	}
	MLV_draw_text_with_font_on_image(1, 1, "+%d", jeu->police, couleur, tmp, score);
	MLV_Image *tmp_anim = NULL;
	MLV_save_screen();
	for(i = 0; i < 6; i ++)
	{
		MLV_load_screen();
		tmp_anim = MLV_copy_image(tmp);
		if(i < 3)
			MLV_scale_image(tmp_anim, ((double)i)/3);
		else
			MLV_scale_image(tmp_anim, ((double)(3-(i-3)))/3);
		MLV_draw_image(tmp_anim, x-(MLV_get_image_width(tmp_anim)/2), y-(MLV_get_image_height(tmp_anim)/2));
		MLV_wait_milliseconds(10);
		MLV_actualise_window();
		MLV_free_image(tmp_anim);
	}
	MLV_free_image(tmp);
}

void MLV_Image_applyteinte(MLV_Image *image, MLV_Color fct(MLV_Color, int), int teinte)
{
	if(image != NULL)
	{
		int image_width = MLV_get_image_width(image);
		int image_height = MLV_get_image_height(image);
		int i, j;
		int r, g, b, a;
		for(i = 0; i < image_width; i ++)
		{
			for(j = 0; j < image_height; j ++)
			{
				MLV_get_pixel_on_image(image, i, j, &r, &g, &b, &a);
				MLV_set_pixel_on_image(i, j, fct(MLV_rgba(r, g, b, a), teinte), image);
			}
		}
	}
}

MLV_Color MLV_Color_supteinte(MLV_Color couleur, int teinte)
{
	Uint8 r, g, b, a;
	MLV_convert_color_to_rgba(couleur, &r, &g, &b, &a);
	if(r != 255)
	{
		r = r+(((255-r)*teinte)/(255));
	}
	if(g != 255)
	{
		g = g+(((255-g)*teinte)/(255));
	}
	if(b != 255)
	{
		b = b+(((255-b)*teinte)/(255));
	}
	return MLV_rgba(r, g, b, a);
}
