#ifndef DEF_HEADER_JEU_ANIM
#define DEF_HEADER_JEU_ANIM

#include "struct_data.h"
#include "init_data.h"
#include "modif_data.h"

#include "jeu_base.h"

int Jeu_Anim_GenListe_Y();
/*
Donne l'ordonnée à laquelle placer la liste de jetons générés
*/

int Jeu_Anim_StartPosX_Liste(int taille);
/*
Donne l'abscisse de départ de la liste faisant office de plateau pour le jeu
*/

int Jeu_Anim_StartPosY_Liste(int taille);
/*
Donne l'ordonnée de départ de la liste faisant office de plateau pour le jeu
*/

int Jeu_Anim_SpPosX_Liste(int taille, int id);
/*
Donne l'abscisse de la liste faisant office de plateau pour le jeu selon l'identifiant du jeton
*/

int Jeu_Anim_SpPosY_Liste(int taille, int id);
/*
Donne l'ordonnée de la liste faisant office de plateau pour le jeu selon l'identifiant du jeton
*/

void Jeu_Anim_Afficher();

void Jeu_Anim_Afficher_Plateau(int y);

void Jeu_Anim_Afficher_Jeton(Token jeton, int x, int y);

void Jeu_Anim_Afficher_Jeton_BySize(Token jeton, int x, int y, int size, int type);

void Jeu_Anim_Afficher_Liste(TokenList *listejeton, int x, int y);

void Jeu_Anim_Afficher_GenListe(TokenList *listejeton, int x, int y);

void Jeu_Anim_Afficher_Anim_Liste(AnimList *listeanim, int x, int y);

void Jeu_Anim_Afficher_Anim_Liste_Hiden(AnimList *listeanim, int x, int y);

void Jeu_Anim_Afficher_Controles();

Control Jeu_Anim_Control_GetAction(int x, int y);

void Jeu_Anim_MoveJeton(Token jeton, int x_start, int y_start, int x_end, int y_end, int temps_actuel, int temps_total);

void Jeu_Anim_MoveJeton_Anim(Token jeton, int x_start, int y_start, int x_end, int y_end);

void Jeu_Anim_MoveJetonRotation(Token jeton, int x_start, int y_start, int x_end, int y_end, int amplitude, int temps_actuel, int temps_total);

void Jeu_Anim_ShowRotateLeft(TokenList *listejeton, Choix_Rotate cr, int attrib, int x, int y);

PlayedToken *Jeu_Anim_GetPlayedToken(TokenList *listejeton, int x, int y);

int Jeu_Anim_Afficher_ChoixRotate(PlayedToken *cur, int x, int y);

Choix_Rotate Jeu_Anim_Choix_Rotate_GetAction(int base_x, int base_y, int x, int y);

MLV_Image *MLV_Image_Create_Losange(MLV_Color couleur, int size);

MLV_Image *MLV_Image_Create_Cercle(MLV_Color couleur, int size);

MLV_Image *MLV_Image_Create_Carre(MLV_Color couleur, int size);

MLV_Image *MLV_Image_Create_Triangle(MLV_Color couleur, int size);

MLV_Image *MLV_Image_Create_Etoile(MLV_Color couleur, int size);

MLV_Image *MLV_Image_Create_Hexagone(MLV_Color couleur, int size);

void MLV_setcolorkey_on_image(MLV_Image *image, MLV_Color couleur);

MLV_Color MLV_Color_supteinte(MLV_Color couleur, int teinte);
/*
Permet l'ajout d'intensité à une MLV_Color par transition vers MLV_COLOR_WHITE
si teinte = 0
	renvoie couleur
si teinte = 255
	renvoie MLV_COLOR_WHITE
*/

void MLV_Image_applyteinte(MLV_Image *image, MLV_Color fct(MLV_Color, int), int teinte);
/*
Applique une fonction MLV_Color_supteinte/MLV_Color_teinte à toutes les couleurs d'une image
*/

void Jeu_Anim_Prepare_Sprites(int nb_colors, int nb_shapes);
/*
Construit les images calculées utilisées dans le jeu pour ne pas avoir à les recréer pendant le jeu
*/

void Jeu_Anim_PrintAnim_Score_Ajout(int score, int x, int y);

#endif
