#include "jeu_base.h"

int Jeu_Base_GenListe_Y()
{
	return (HEIGHT)/4;
}

int Jeu_Base_StartPosX_Liste(int taille)
{
	return (WIDTH/2 - (((taille-1) * JETON_SIZE)/2));
}

int Jeu_Base_StartPosY_Liste(int taille)
{
	return (JETON_SIZE + (3*HEIGHT)/4);
}

int Jeu_Base_SpPosX_Liste(int taille, int id)
{
	return Jeu_Base_StartPosX_Liste(taille) + (id * JETON_SIZE);
}

int Jeu_Base_SpPosY_Liste(int taille, int id)
{
	return Jeu_Base_StartPosY_Liste(taille);
}

void Jeu_Base_Afficher()
{
	MLV_clear_window(MLV_COLOR_BLACK);
	Jeu_Base_Afficher_Plateau((3*HEIGHT)/4);
	MLV_draw_text_with_font(10, 10, "Score: %d", jeu->police, MLV_COLOR_YELLOW, jeu->score);
	if(!jeu->is_tuto)
		afficher_temps(10, 60);
}

void afficher_temps(int x, int y)
{
	int t = jeu->start_time+jeu->party_time - time(NULL);
	if(t == 0)
		MLV_draw_text_with_font(10, 60, "Temps restant: Fini", jeu->police, MLV_COLOR_YELLOW);
	else if(t >= 60)
	{
		MLV_draw_text_with_font(10, 60, "Temps restant: %d\"%d", jeu->police, MLV_COLOR_YELLOW, t/60, t%60);
	}
	else
		MLV_draw_text_with_font(10, 60, "Temps restant: %d", jeu->police, MLV_COLOR_YELLOW, t);
}

void Jeu_Base_Afficher_Plateau(int y)
{
	MLV_draw_filled_rectangle(0, y, WIDTH, 2*JETON_SIZE, MLV_COLOR_GRAY);
}

void Jeu_Base_Afficher_Jeton(Token jeton, int x, int y)
{
	//if(jeton != NULL)
	{
		MLV_Color couleur = Get_MLV_Color(jeton.color);
		switch(jeton.form)
		{
			case CERCLE:
			MLV_draw_filled_circle(x, y, (JETON_SIZE/2)-5, couleur);
			break;
			case CARRE:
			MLV_draw_filled_rectangle(x-(JETON_SIZE/2)+5, y-(JETON_SIZE/2)+5, JETON_SIZE-10, JETON_SIZE-10, couleur);
			break;
			case TRIANGLE:
			{
				int tx[] = {x, x-(JETON_SIZE/2)+5, x+(JETON_SIZE/2)-5};
				int ty[] = {y-(JETON_SIZE/2)+5, y+(JETON_SIZE/2)-5, y+(JETON_SIZE/2)-5};
				MLV_draw_filled_polygon(tx, ty, 3, couleur);
			}
			break;
			case DIAMANT:
			{
				int tx[] = {x, x-(JETON_SIZE/2)+5, x, x+(JETON_SIZE/2)-5};
				int ty[] = {y-(JETON_SIZE/2)+5, y, y+(JETON_SIZE/2)-5, y};
				MLV_draw_filled_polygon(tx, ty, 4, couleur);
			}
			break;
			case ETOILE:
			{
				int tx[10];
				int ty[10];
				int i;
				for(i = 0; i < 5; i ++)
				{
					tx[2*i] = x+((JETON_SIZE/2)*cos(radian_convert((i*72)-90)));
					ty[2*i] = y+((JETON_SIZE/2)*sin(radian_convert((i*72)-90)));
				}
				for(i = 0; i < 5; i ++)
				{
					tx[(2*i)+1] = x+((JETON_SIZE/4)*cos(radian_convert((i*72)+36-90)));
					ty[(2*i)+1] = y+((JETON_SIZE/4)*sin(radian_convert((i*72)+36-90)));
				}
				MLV_draw_filled_polygon(tx, ty, 10, couleur);
			}
			break;
			case HEXAGONE:
			{
				int tx[6];
				int ty[6];
				int i;
				for(i = 0; i < 6; i ++)
				{
					tx[i] = x+((JETON_SIZE/2)*cos(radian_convert((i*60)-90)));
					ty[i] = y+((JETON_SIZE/2)*sin(radian_convert((i*60)-90)));
				}
				MLV_draw_filled_polygon(tx, ty, 6, couleur);
			}
			break;
		}
	}
}

void Jeu_Base_Afficher_JetonRC(Token jeton, int x, int y, int reduce, MLV_Color couleur)
{
	//if(jeton != NULL)
	{
		switch(jeton.form)
		{
			case CERCLE:
			MLV_draw_filled_circle(x, y, (JETON_SIZE/2)-5-reduce, couleur);
			break;
			case CARRE:
			MLV_draw_filled_rectangle(x-(JETON_SIZE/2)+5+reduce, y-(JETON_SIZE/2)+5+reduce, JETON_SIZE-10-(reduce*2), JETON_SIZE-10-(reduce*2), couleur);
			break;
			case TRIANGLE:
			{
				int tx[] = {x, x-(JETON_SIZE/2)+5+reduce, x+(JETON_SIZE/2)-5-reduce};
				int ty[] = {y-(JETON_SIZE/2)+5+reduce, y+(JETON_SIZE/2)-5-reduce, y+(JETON_SIZE/2)-5-reduce};
				MLV_draw_filled_polygon(tx, ty, 3, couleur);
			}
			break;
			case DIAMANT:
			{
				int tx[] = {x, x-(JETON_SIZE/2)+5+reduce, x, x+(JETON_SIZE/2)-5-reduce};
				int ty[] = {y-(JETON_SIZE/2)+5+reduce, y, y+(JETON_SIZE/2)-5-reduce, y};
				MLV_draw_filled_polygon(tx, ty, 4, couleur);
			}
			break;
			case ETOILE:
			{
				int tx[10];
				int ty[10];
				int i;
				for(i = 0; i < 5; i ++)
				{
					tx[2*i] = x+(((JETON_SIZE/2)-reduce)*cos(radian_convert((i*72)-90)));
					ty[2*i] = y+(((JETON_SIZE/2)-reduce)*sin(radian_convert((i*72)-90)));
				}
				for(i = 0; i < 5; i ++)
				{
					tx[(2*i)+1] = x+(((JETON_SIZE/4)-reduce)*cos(radian_convert((i*72)+36-90)));
					ty[(2*i)+1] = y+(((JETON_SIZE/4)-reduce)*sin(radian_convert((i*72)+36-90)));
				}
				MLV_draw_filled_polygon(tx, ty, 10, couleur);
			}
			break;
			case HEXAGONE:
			{
				int tx[6];
				int ty[6];
				int i;
				for(i = 0; i < 6; i ++)
				{
					tx[i] = x+(((JETON_SIZE/2)-reduce)*cos(radian_convert((i*60)-90)));
					ty[i] = y+(((JETON_SIZE/2)-reduce)*sin(radian_convert((i*60)-90)));
				}
				MLV_draw_filled_polygon(tx, ty, 6, couleur);
			}
			break;
		}
	}
}

void Jeu_Base_Afficher_Liste(TokenList *listejeton, int x, int y)
{
	PlayedToken *cur = listejeton->head;
	while(cur != NULL)
	{
		Jeu_Base_Afficher_Jeton(cur->jeton, x, y);
		cur = cur->next;
		x += JETON_SIZE;
	}
}

void Jeu_Base_Afficher_Controles()
{
	MLV_draw_filled_circle(WIDTH/4, HEIGHT/2, 50, MLV_COLOR_CYAN);
	MLV_draw_filled_circle((3*WIDTH)/4, HEIGHT/2, 50, MLV_COLOR_CYAN);
}

Control Jeu_Base_Control_GetAction(int x, int y)
{
	if(x < WIDTH/2)
	{
		if(pow(x-WIDTH/4, 2)+pow(y-HEIGHT/2, 2) < 2500)
			return Control_Tete;
	}
	else
	{	if(pow(x-(3*WIDTH)/4, 2)+pow(y-HEIGHT/2, 2) < 2500)
			return Control_Fin;
	}
	return Control_None;
}

PlayedToken *Jeu_Base_GetPlayedToken(TokenList *listejeton, int x, int y)
{
	if(y > JETON_SIZE/2 + (3*HEIGHT)/4 && y < (JETON_SIZE*3)/2 + (3*HEIGHT)/4)
	{
		int id = (-(WIDTH/2 - (((listejeton->taille-1) * JETON_SIZE)/2)) + x + (JETON_SIZE/2));
		if(id < 0)
			return NULL;
		id /= JETON_SIZE;
		//printf("%d %d %d\n", -(WIDTH/2 - (((listejeton->taille-1) * JETON_SIZE)/2)) + x, JETON_SIZE, ((-(WIDTH/2 - (((listejeton->taille-1) * JETON_SIZE)/2)) + x)/JETON_SIZE));
		if(id >= 0 && id < listejeton->taille)
		{
			printf("id:%d\n", id);
			return TokenList_GetPlayedToken_ById(listejeton, id);
		}
	}
	return NULL;
}

int Jeu_Base_Afficher_ChoixRotate(PlayedToken *cur, int x, int y)
{
	int aff = 0;
	if(cur->nextColor != cur)
	{
		MLV_draw_filled_rectangle(x-(JETON_SIZE/2), y-((JETON_SIZE*3)/2), JETON_SIZE, JETON_SIZE, MLV_COLOR_WHITE);
		MLV_draw_filled_rectangle(x-(JETON_SIZE/2)+1, y-((JETON_SIZE*3)/2)+1, JETON_SIZE-2, JETON_SIZE-2, MLV_COLOR_BLACK);
		MLV_draw_filled_rectangle(x-(JETON_SIZE/2)+2, y-((JETON_SIZE*3)/2)+2, JETON_SIZE-4, JETON_SIZE-4, Get_MLV_Color(cur->jeton.color));
		aff = 1;
	}
	if(cur->nextForm != cur)
	{
		Jeu_Base_Afficher_JetonRC(cur->jeton, x, y+JETON_SIZE, 0, MLV_COLOR_WHITE);
		Jeu_Base_Afficher_JetonRC(cur->jeton, x, y+JETON_SIZE, 1, MLV_COLOR_BLACK);
		Jeu_Base_Afficher_JetonRC(cur->jeton, x, y+JETON_SIZE, 2, MLV_COLOR_WHITE);
		aff = 1;
	}
	return aff;
}

Choix_Rotate Jeu_Base_Choix_Rotate_GetAction(int base_x, int base_y, int x, int y)
{
	if(y < base_y)
	{
		if(	y > base_y-((JETON_SIZE*3)/2)
			&& y < base_y-((JETON_SIZE*3)/2)+JETON_SIZE
			&& x > base_x-(JETON_SIZE/2)
			&& x < base_x-(JETON_SIZE/2)+JETON_SIZE)
			return CR_Couleur;
	}
	else
	{
		{
		if(	y > base_y+((JETON_SIZE)/2)
			&& y < base_y+((JETON_SIZE)/2)+JETON_SIZE
			&& x > base_x-(JETON_SIZE/2)
			&& x < base_x-(JETON_SIZE/2)+JETON_SIZE)
			return CR_Forme;
		}
	}
	return CR_None;
}
