#include "modif_data.h"

int Token_Change(Token *jeton, int color, int form)
{
	if(jeton != NULL)
	{
		if(color < NB_COLOR)
			(*jeton).color = color;
		if(form < NB_SHAPE)
			(*jeton).form = form;
		return 1;
	}
	return 0;
}

int Token_Copy(Token *copie, Token jeton)
{
	if(copie != NULL)
	{
		Token_Change(copie, jeton.color, jeton.form);
		return 1;
	}
	return 0;
}

int PlayedToken_Change(PlayedToken *jetonjoue, int color, int form)
{
	return Token_Change(&(jetonjoue->jeton), color, form);
}

int TokenList_AjouterToken_EnTete(TokenList *listejeton, Token jeton)
{
	if(listejeton != NULL)
	{
		PlayedToken *new_jeton = NULL;
		if((new_jeton = PlayedToken_Create()) == NULL)
			return 0;
		Token_Copy(&(new_jeton->jeton), jeton);
		if(listejeton->taille == 0)
		{
			new_jeton->next = NULL;
			new_jeton->nextColor = new_jeton;
			new_jeton->prevColor = new_jeton;
			new_jeton->nextForm = new_jeton;
			new_jeton->prevForm = new_jeton;
			 
			listejeton->head = new_jeton;
			listejeton->tail = new_jeton;
			listejeton->head_color[jeton.color] = new_jeton;
			listejeton->head_shape[jeton.form] = new_jeton;
			listejeton->taille = 1;
		}
		else if(listejeton->taille < LISTE_LIMITE)
		{
			new_jeton->next = listejeton->head;
			if(listejeton->head_color[jeton.color] != NULL)
			{
				new_jeton->nextColor = listejeton->head_color[jeton.color];
				new_jeton->prevColor = PlayedToken_FinCouleur(listejeton->head_color[jeton.color]);
				PlayedToken_FinCouleur(listejeton->head_color[jeton.color])->nextColor = new_jeton;
				listejeton->head_color[jeton.color]->prevColor = new_jeton;
				listejeton->head_color[jeton.color] = new_jeton;
			}
			else
			{
				listejeton->head_color[jeton.color] = new_jeton;
				new_jeton->nextColor = new_jeton;
				new_jeton->prevColor = new_jeton;
			}
			if(listejeton->head_shape[jeton.form] != NULL)
			{
				new_jeton->nextForm = listejeton->head_shape[jeton.form];
				new_jeton->prevForm = PlayedToken_FinForme(listejeton->head_shape[jeton.form]);
				PlayedToken_FinForme(listejeton->head_shape[jeton.form])->nextForm = new_jeton;
				listejeton->head_shape[jeton.form]->prevForm = new_jeton;
				listejeton->head_shape[jeton.form] = new_jeton;
			}
			else
			{
				listejeton->head_shape[jeton.form] = new_jeton;
				new_jeton->nextForm = new_jeton;
				new_jeton->prevForm = new_jeton;
			}
			
			listejeton->head = new_jeton;
			listejeton->taille ++;
		}
		else
		{
			PlayedToken_Free(&new_jeton);
			return 0;
		}
		return 1;
	}
	return 0;
}

int TokenList_AjouterToken_EnFin(TokenList *listejeton, Token jeton)
{
	if(listejeton != NULL)
	{
		PlayedToken *new_jeton = NULL;
		if((new_jeton = PlayedToken_Create()) == NULL)
			return 0;
		Token_Copy(&(new_jeton->jeton), jeton);
		if(listejeton->taille == 0)
		{
			new_jeton->next = NULL;
			new_jeton->nextColor = new_jeton;
			new_jeton->prevColor = new_jeton;
			new_jeton->nextForm = new_jeton;
			new_jeton->prevForm = new_jeton;
			
			listejeton->head = new_jeton;
			listejeton->tail = new_jeton;
			listejeton->head_color[jeton.color] = new_jeton;
			listejeton->head_shape[jeton.form] = new_jeton;
			listejeton->taille = 1;
		}
		else if(listejeton->taille < LISTE_LIMITE)
		{
			new_jeton->next = NULL;
			if(listejeton->head_color[jeton.color] != NULL)
			{
				new_jeton->prevColor = PlayedToken_FinCouleur(listejeton->head_color[jeton.color]);
				new_jeton->nextColor = listejeton->head_color[jeton.color];
				PlayedToken_FinCouleur(listejeton->head_color[jeton.color])->nextColor = new_jeton;
				listejeton->head_color[jeton.color]->prevColor = new_jeton;
			}
			else
			{
				listejeton->head_color[jeton.color] = new_jeton;
				new_jeton->nextColor = new_jeton;
				new_jeton->prevColor = new_jeton;
			}
			if(listejeton->head_shape[jeton.form] != NULL)
			{
				new_jeton->prevForm = PlayedToken_FinForme(listejeton->head_shape[jeton.form]);
				new_jeton->nextForm = listejeton->head_shape[jeton.form];
				PlayedToken_FinForme(listejeton->head_shape[jeton.form])->nextForm = new_jeton;
				listejeton->head_shape[jeton.form]->prevForm = new_jeton;
			}
			else
			{
				listejeton->head_shape[jeton.form] = new_jeton;
				new_jeton->nextForm = new_jeton;
				new_jeton->prevForm = new_jeton;
			}
			
			listejeton->tail->next = new_jeton;
			listejeton->tail = new_jeton;
			listejeton->taille ++;
		}
		else
		{
			PlayedToken_Free(&new_jeton);
			return 0;
		}
		return 1;
	}
	return 0;
}

PlayedToken *PlayedToken_FinCouleur(PlayedToken *jetonjoue)
{
	if(jetonjoue == NULL)
		return NULL;
	PlayedToken *cur = jetonjoue;
	PlayedToken *first = cur;
	while(cur->nextColor != first)//Aucun soucis, on compare des adresses
	{
		cur = cur->nextColor;
	}
	return cur;
}

PlayedToken *PlayedToken_FinForme(PlayedToken *jetonjoue)
{
	if(jetonjoue == NULL)
		return NULL;
	PlayedToken *cur = jetonjoue;
	PlayedToken *first = cur;
	while(cur->nextForm != first)
	{
		cur = cur->nextForm;
	}
	return cur;
}

int TokenList_RotateRightByColor(TokenList *listejeton, PlayedToken *jetonjoue)
{
	if(listejeton == NULL || jetonjoue == NULL || jetonjoue->nextColor == jetonjoue)
		return 0;
	Token startjeton= {0,0};
	Token_Copy(&startjeton, jetonjoue->jeton);
	PlayedToken *cur = jetonjoue;
	PlayedToken *first = cur;
	while(cur->prevColor != first)
	{
		Token_Copy(&(cur->jeton), cur->prevColor->jeton);
		cur = cur->prevColor;
	}
	Token_Copy(&(cur->jeton), startjeton);
	
	//Mise à jour de la liste des formes
	cur = listejeton->head;
	int i;
	for(i = 0; i < NB_SHAPE; i ++)
	{
		listejeton->head_shape[i] = NULL;
	}
	cur = listejeton->head;
	while(cur != NULL)//On recrée tous les liens entre formes
	{
		if(listejeton->head_shape[cur->jeton.form] == NULL)
		{
			listejeton->head_shape[cur->jeton.form] = cur;
			cur->prevForm = cur;
			cur->nextForm = cur;
		}
		else
		{
			cur->nextForm = listejeton->head_shape[cur->jeton.form];
			cur->prevForm = listejeton->head_shape[cur->jeton.form]->prevForm;
			listejeton->head_shape[cur->jeton.form]->prevForm->nextForm = cur;
			listejeton->head_shape[cur->jeton.form]->prevForm = cur;
		}
		cur = cur->next;
	}
	return 1;
}

int TokenList_RotateLeftByColor(TokenList *listejeton, PlayedToken *jetonjoue)
{
	if(listejeton == NULL || jetonjoue == NULL || jetonjoue->nextColor == jetonjoue)
		return 0;
	Token startjeton= {0,0};
	Token_Copy(&startjeton, jetonjoue->jeton);
	PlayedToken *cur = jetonjoue;
	PlayedToken *first = cur;
	while(cur->nextColor != first)
	{
		Token_Copy(&(cur->jeton), cur->nextColor->jeton);
		cur = cur->nextColor;
	}
	Token_Copy(&(cur->jeton), startjeton);
	
	//Mise à jour de la liste des formes
	cur = listejeton->head;
	int i;
	for(i = 0; i < NB_SHAPE; i ++)
	{
		listejeton->head_shape[i] = NULL;
	}
	cur = listejeton->head;
	while(cur != NULL)//On recrée tous les liens entre formes
	{
		if(listejeton->head_shape[cur->jeton.form] == NULL)
		{
			listejeton->head_shape[cur->jeton.form] = cur;
			cur->prevForm = cur;
			cur->nextForm = cur;
		}
		else
		{
			cur->nextForm = listejeton->head_shape[cur->jeton.form];
			cur->prevForm = listejeton->head_shape[cur->jeton.form]->prevForm;
			listejeton->head_shape[cur->jeton.form]->prevForm->nextForm = cur;
			listejeton->head_shape[cur->jeton.form]->prevForm = cur;
		}
		cur = cur->next;
	}
	return 1;
}

int TokenList_RotateRightByForm(TokenList *listejeton, PlayedToken *jetonjoue)
{
	if(listejeton == NULL || jetonjoue == NULL || jetonjoue->nextForm == jetonjoue)
		return 0;
	Token startjeton= {0,0};
	Token_Copy(&startjeton, jetonjoue->jeton);
	PlayedToken *cur = jetonjoue;
	PlayedToken *first = cur;
	while(cur->prevForm != first)
	{
		Token_Copy(&(cur->jeton), cur->prevForm->jeton);
		cur = cur->prevForm;
	}
	Token_Copy(&(cur->jeton), startjeton);
	
	//Mise à jour de la liste des formes
	cur = listejeton->head;
	int i;
	for(i = 0; i < NB_COLOR; i ++)
	{
		listejeton->head_color[i] = NULL;
	}
	cur = listejeton->head;
	while(cur != NULL)//On recrée tous les liens entre formes
	{
		if(listejeton->head_color[cur->jeton.color] == NULL)
		{
			listejeton->head_color[cur->jeton.color] = cur;
			cur->prevColor = cur;
			cur->nextColor = cur;
		}
		else
		{
			cur->nextColor = listejeton->head_color[cur->jeton.color];
			cur->prevColor = listejeton->head_color[cur->jeton.color]->prevColor;
			listejeton->head_color[cur->jeton.color]->prevColor->nextColor = cur;
			listejeton->head_color[cur->jeton.color]->prevColor = cur;
		}
		cur = cur->next;
	}
	return 1;
}

int TokenList_RotateLeftByForm(TokenList *listejeton, PlayedToken *jetonjoue)
{
	if(listejeton == NULL || jetonjoue == NULL || jetonjoue->nextForm == jetonjoue)
		return 0;
	Token startjeton= {0,0};
	Token_Copy(&startjeton, jetonjoue->jeton);
	PlayedToken *cur = jetonjoue;
	PlayedToken *first = cur;
	while(cur->nextForm != first)
	{
		Token_Copy(&(cur->jeton), cur->nextForm->jeton);
		cur = cur->nextForm;
	}
	Token_Copy(&(cur->jeton), startjeton);
	
	//Mise à jour de la liste des formes
	cur = listejeton->head;
	int i;
	for(i = 0; i < NB_COLOR; i ++)
	{
		listejeton->head_color[i] = NULL;
	}
	cur = listejeton->head;
	while(cur != NULL)//On recrée tous les liens entre formes
	{
		if(listejeton->head_color[cur->jeton.color] == NULL)
		{
			listejeton->head_color[cur->jeton.color] = cur;
			cur->prevColor = cur;
			cur->nextColor = cur;
		}
		else
		{
			cur->nextColor = listejeton->head_color[cur->jeton.color];
			cur->prevColor = listejeton->head_color[cur->jeton.color]->prevColor;
			listejeton->head_color[cur->jeton.color]->prevColor->nextColor = cur;
			listejeton->head_color[cur->jeton.color]->prevColor = cur;
		}
		cur = cur->next;
	}
	return 1;
}

int TokenList_Remove(TokenList *listejeton, PlayedToken *jetonjoue)
{
	if(listejeton == NULL || jetonjoue == NULL)
		return 0;
	if(jetonjoue->nextColor == jetonjoue)
		listejeton->head_color[jetonjoue->jeton.color] = NULL;
	else if(listejeton->head_color[jetonjoue->jeton.color] == jetonjoue)
		listejeton->head_color[jetonjoue->jeton.color] = jetonjoue->nextColor;
	if(jetonjoue->nextForm == jetonjoue)
		listejeton->head_shape[jetonjoue->jeton.form] = NULL;
	else if(listejeton->head_shape[jetonjoue->jeton.form] == jetonjoue)
		listejeton->head_shape[jetonjoue->jeton.form] = jetonjoue->nextForm;
	jetonjoue->nextColor->prevColor = jetonjoue->prevColor;
	jetonjoue->prevColor->nextColor = jetonjoue->nextColor;
	jetonjoue->nextForm->prevForm = jetonjoue->prevForm;
	jetonjoue->prevForm->nextForm = jetonjoue->nextForm;
	if(listejeton->head == jetonjoue)
	{
		if((listejeton->head = jetonjoue->next) == NULL)
			listejeton->tail = NULL;
	}
	else
	{
		PlayedToken *cur = listejeton->head;
		while(cur->next != jetonjoue)
		{
			cur = cur->next;
		}
		if((cur->next = jetonjoue->next) == NULL)
			listejeton->tail = cur;
	}
	listejeton->taille --;
	PlayedToken_Free(&jetonjoue);
	return 1;
}

int TokenList_RemoveTrio(TokenList *listejeton, int *score)
{
	if(listejeton == NULL || listejeton->taille <= 2)
		return 0;
	PlayedToken *cur = listejeton->head;
	PlayedToken *tmp;
	int couleur = -1;
	int forme = -1;
	int couleur_ench = 0;
	int forme_ench = 0;
	PlayedToken *first_couleur = NULL;
	PlayedToken *first_forme = NULL;
	int modif = 0;
	int nb_to_del = 0;
	PlayedToken **del_list;
	if((del_list = (PlayedToken**)malloc(listejeton->taille*sizeof(PlayedToken*))) == NULL)
		return 0;
	int *anim_id_list;
	if((anim_id_list = (int*)malloc(listejeton->taille*sizeof(int))) == NULL)
		return 0;
	int anim_id = 0;
	int i = 0;
	int ajout_score = 0;
	while(1)
	{
		//fprintf(stderr, "%p\n", cur);
		if(cur == NULL || couleur != cur->jeton.color)
		{
			if(couleur_ench >= 3)
			{
				for(i = 0; i < couleur_ench; i ++)
				{
					tmp = first_couleur;
					first_couleur = first_couleur->next;
					if(!in_PlayedTokenList(tmp, del_list, nb_to_del))
					{
						del_list[nb_to_del] = tmp;
						anim_id_list[nb_to_del] = anim_id;
						nb_to_del ++;
					}
					//TokenList_Remove(listejeton, cur);
				}
				ajout_score += fibo(couleur_ench)*10;
				modif ++;
				anim_id ++;
			}
			if(cur != NULL)
			{
				couleur = cur->jeton.color;
				couleur_ench = 1;
				first_couleur = cur;
			}
		}
		else
		{
			couleur_ench ++;
		}
		if(cur == NULL || forme != cur->jeton.form)
		{
			if(forme_ench >= 3)
			{
				for(i = 0; i < forme_ench; i ++)
				{
					tmp = first_forme;
					first_forme = first_forme->next;
					if(!in_PlayedTokenList(tmp, del_list, nb_to_del))
					{
						del_list[nb_to_del] = tmp;
						anim_id_list[nb_to_del] = anim_id;
						nb_to_del ++;
					}
					//TokenList_Remove(listejeton, cur);
				}
				ajout_score += fibo(forme_ench)*10;
				modif ++;
				anim_id ++;
			}
			if(cur != NULL)
			{
				forme = cur->jeton.form;
				forme_ench = 1;
				first_forme = cur;
			}
		}
		else
		{
			forme_ench ++;
		}
		if(cur == NULL)
			break;
		cur = cur->next;
	}
	//fprintf(stderr, "%d\n", nb_to_del);
	if(nb_to_del > 0)
	{
		AnimData_Clear(jeu->animdata);
		cur = listejeton->head;
		while(cur != NULL)
		{
			AnimList_AjouterToken_EnFin(jeu->animdata->listeanim, cur->jeton);
			for(i = 0; i < nb_to_del; i ++)
			{
				if(del_list[i] == cur)
				{
					jeu->animdata->listeanim->tail->disparition = 1;
					jeu->animdata->listeanim->tail->anim_id = anim_id_list[i];
					break;
				}
			}
			cur = cur->next;
		}
		ajout_score *= nb_to_del;
	}
	int ench = 1;
	for(i = 0; i < nb_to_del; i ++)//Si jamais on a un enchainement du style c1/f1-c1/f2-c1/f2-c2/f2 par exemple on supprimera 4 éléments au lieu de 3
	{
		if(i < nb_to_del -1 && del_list[i]->next == del_list[i+1])//Permet d'ajouter du score en cas de combos rapprochés
			ench ++;
		else
		{
			//printf("Enchainement: %d\n", ench);
			ajout_score *= fibo(ench);
			ench = 1;
		}
		TokenList_Remove(listejeton, del_list[i]);
	}
	if(score != NULL)
		*score = *score + ajout_score;
	free(anim_id_list);
	free(del_list);
	return nb_to_del;
}

int in_PlayedTokenList(PlayedToken *e, PlayedToken **l, int taille)
{
	int i = 0;
	for(i = 0; i < taille; i ++)
	{
		if(e == l[i])
			return 1;
	}
	return 0;
}

TokenList *TokenList_GenerateAlea(int taille, int max_couleur, int max_forme)
{
	TokenList *listejeton = TokenList_Create();
	if(listejeton == NULL)
		return NULL;
	int i;
	srand(time(NULL));
	for(i = 0; i < taille; i ++)
	{
		/*Token_Change(jeton, rand()%max_couleur, rand()%max_forme);
		TokenList_AjouterToken_EnFin(listejeton, jeton);*/
		TokenList_AjouterToken_Alea(listejeton, max_couleur, max_forme);
	}
	return listejeton;
}

int TokenList_AjouterToken_Alea(TokenList *listejeton, int max_couleur, int max_forme)
{
	Token jeton;
	do
	{
		Token_Change(&jeton, rand()%max_couleur, rand()%max_forme);
	}while(listejeton->tail != NULL && (jeton.color == listejeton->tail->jeton.color || jeton.form == listejeton->tail->jeton.form));
	int res = TokenList_AjouterToken_EnFin(listejeton, jeton);
	return res;
}

int TokenList_GetId_OfPlayedToken(TokenList *listejeton, PlayedToken *jetonjoue)
{
	if(listejeton == NULL)
		return -1;
	PlayedToken *cur = listejeton->head;
	int i = 0;
	while(cur != NULL)
	{
		if(cur == jetonjoue)
			return i;
		i ++;
		cur = cur->next;
	}
	return -1;
}

PlayedToken *TokenList_GetPlayedToken_ById(TokenList *listejeton, int id)
{
	int i = 0;
	PlayedToken *cur = listejeton->head;
	while(cur != NULL)
	{
		if(i == id)
			return cur;
		i++;
		cur = cur->next;
	}
	return NULL;
}

int AnimList_AjouterToken_EnTete(AnimList *listeanim, Token jeton)
{
	if(listeanim != NULL)
	{
		AnimToken *new_jeton = NULL;
		if((new_jeton = AnimToken_Create()) == NULL)
			return 0;
		Token_Copy(&(new_jeton->jeton), jeton);
		if(listeanim->head == NULL)
		{
			listeanim->head = new_jeton;
			listeanim->tail = new_jeton;
			listeanim->taille = 1;
		}
		else
		{
			new_jeton->next = listeanim->head;
			listeanim->head = new_jeton;
			listeanim->taille = listeanim->taille + 1;
		}
		return 1;
	}
	return 0;
}

int AnimList_AjouterToken_EnFin(AnimList *listeanim, Token jeton)
{
	if(listeanim != NULL)
	{
		AnimToken *new_jeton = NULL;
		if((new_jeton = AnimToken_Create()) == NULL)
			return 0;
		Token_Copy(&(new_jeton->jeton), jeton);
		if(listeanim->head == NULL)
		{
			listeanim->head = new_jeton;
			listeanim->tail = new_jeton;
			listeanim->taille = 1;
		}
		else
		{
			listeanim->tail->next = new_jeton;
			listeanim->tail = new_jeton;
			listeanim->taille = listeanim->taille + 1;
		}
		return 1;
	}
	return 0;
}

int AnimList_Remove(AnimList *listeanim, AnimToken *jetonanim)
{
	if(listeanim != NULL && jetonanim != NULL)
	{
		AnimToken *cur = listeanim->head;
		if(cur == NULL)
			return 0;
		if(jetonanim == listeanim->head)
		{
			listeanim->head = jetonanim->next;
			if(listeanim->head == NULL)
				listeanim->tail = NULL;
			AnimToken_Free(&jetonanim);
			listeanim->taille = listeanim->taille - 1;
			return 1;
		}
		while(cur->next != NULL)
		{
			if(cur->next == jetonanim)
			{
				cur->next = jetonanim->next;
				if(jetonanim == listeanim->tail)
					listeanim->tail = cur;
				AnimToken_Free(&jetonanim);
				listeanim->taille = listeanim->taille - 1;
				return 1;
			}
			cur = cur->next;
		}
		return 0;
	}
	return 0;
}

int Tuto_Ajouter(Tuto **t, const char *message, int x, int y, Control control_action, Choix_Rotate cr)
{
	Tuto *ajout = NULL;
	if((ajout = Tuto_Create()) == NULL)
		return 0;
	if((ajout->message = (char*)malloc((strlen(message)+1)*sizeof(char))) == NULL)
		return 0;
	strcpy(ajout->message, message);
	ajout->x = x;
	ajout->y = y;
	ajout->control_action = control_action;
	ajout->cr_action = cr;
	if(*t == NULL)
	{
		ajout->next = *t;
		*t = ajout;
		return 1;
	}
	Tuto *cur = *t;
	while(cur->next != NULL)
		cur = cur->next;
	cur->next = ajout;
	return 1;
}

int fibo(int n)
{
	if(n <= 1)
		return n;
	int n_1=1, n_2=0, res=1;
	int i;
	for(i = 2; i < n; i ++)
	{
		n_2 = n_1;
		n_1 = res;
		res = n_2 + n_1;
	}
	return res;
}

MLV_Color Get_MLV_Color(int couleur)
{
	switch(couleur)
	{
		case ROUGE:
		return MLV_COLOR_RED;
		case VERT:
		return MLV_COLOR_GREEN;
		case BLEU:
		return MLV_COLOR_BLUE;
		case JAUNE:
		return MLV_COLOR_YELLOW;
		case NOIR:
		return MLV_rgba(30, 30, 30, 255);
		case BLANC:
		return MLV_rgba(220, 220, 220, 255);
	}
	return MLV_COLOR_GREY;
}
