#ifndef DEF_HEADER_STRUCT_JETON_MODIF
#define DEF_HEADER_STRUCT_JETON_MODIF

/*
Header contenant les fonctions de modification des jetons
*/

#include "struct_data.h"
#include "init_data.h"

int Token_Change(Token *jeton, int color, int form);
/*
Permet de définir ou redéfinir les caractéristiques d'un Token*
*/
int Token_Copy(Token *copie, Token jeton);
/*
Permet de faire une copie d'un Token jeton
Les deux jetons doivent être créés à l'avance
renvoie 0 si la copie n'a pas été effectuée
1 sinon
*/
int PlayedToken_Change(PlayedToken *jetonjoue, int color, int form);
/*
Permet de définir ou redéfinir les caractéristiques du Token d'un PlayedToken* sans manipuler l'ojet directement
*/
int TokenList_AjouterToken_EnTete(TokenList *listejeton, Token jeton);
/*
Permet d'ajouter un jeton au début de la liste
*/
int TokenList_AjouterToken_EnFin(TokenList *listejeton, Token jeton);
/*
Permet d'ajouter un jeton à la fin de la liste
*/
PlayedToken *PlayedToken_FinCouleur(PlayedToken *jetonjoue);
/*
Permet d'obtenir le dernier jeton de la couleur de jetonjoue
*/
PlayedToken *PlayedToken_FinForme(PlayedToken *jetonjoue);
/*
Permet d'obtenir le dernier jeton de la forme de jetonjoue
*/
int TokenList_RotateRightByColor(TokenList *listejeton, PlayedToken *jetonjoue);
/*
Permet de faire tourner vers la droite les Token de même couleur que jetonjoue
*/
int TokenList_RotateLeftByColor(TokenList *listejeton, PlayedToken *jetonjoue);
/*
Permet de faire tourner vers la gauche les Token de même couleur que jetonjoue
*/
int TokenList_RotateRightByForm(TokenList *listejeton, PlayedToken *jetonjoue);
/*
Permet de faire tourner vers la droite les Token de même couleur que jetonjoue
*/
int TokenList_RotateLeftByForm(TokenList *listejeton, PlayedToken *jetonjoue);
/*
Permet de faire tourner vers la gauche les Token de même forme que jetonjoue
*/
int TokenList_Remove(TokenList *listejeton, PlayedToken *jetonjoue);
/*
Permet de retirer un élément d'une TokenList en connaissant son adresse
On pourrait envoyer seulement jetonjoue, mais on mettra les head_color et head_shape de listejeton à jour
si on retire la dernière forme ou couleur de la liste
*/
int TokenList_RemoveTrio(TokenList *listejeton, int *score);
/*
*/
int in_PlayedTokenList(PlayedToken *e, PlayedToken **l, int taille);

TokenList *TokenList_GenerateAlea(int taille, int max_couleur, int max_forme);
/*
Génère une TokenList de taille taille avec des jetons aléatoires de couleur maximale max_couleur et forme maximale max_forme
*/

int TokenList_AjouterToken_Alea(TokenList *listejeton, int max_couleur, int max_forme);

PlayedToken *TokenList_GetPlayedToken_ById(TokenList *listejeton, int id);

int TokenList_GetId_OfPlayedToken(TokenList *listejeton, PlayedToken *jetonjoue);

int AnimList_AjouterToken_EnTete(AnimList *listeanim, Token jeton);

int AnimList_AjouterToken_EnFin(AnimList *listeanim, Token jeton);

int AnimList_Remove(AnimList *listeanim, AnimToken *jetonanim);

int Tuto_Ajouter(Tuto **t, const char *message, int x, int y, Control control_action, Choix_Rotate cr);

int fibo(int n);
/*
Fonction fibonacci qui sera utile pour le calcul de score
*/

MLV_Color Get_MLV_Color(int couleur);
/*
Donne la couleur associée à un jeton
*/

#endif
