#include "test.h"

int TEST_ALL()
{
	int ok = 1;
	
	MLV_create_window(CAPTION, "test", 1, 1);		
	Jeu_Create();
	
	ok &= TEST_AjoutEnTete();
	ok &= TEST_AjoutEnFin();
	ok &= TEST_Retire();
	ok &= TEST_Rotation();
	ok &= TEST_Trio();
	ok &= TEST_Annexe();
	
	Jeu_Free();
	MLV_free_window();
	
	return print_test(ok, "Résultat de TEST_ALL\n");
}

int TEST_AjoutEnTete()
{
	print_title("TEST_AjoutEnTete", "Début:\n");
	int ok = 1;
	int subok = 1;
	Token jeton;
	TokenList *listejeton = TokenList_Create();
	
	print_subtitle("TEST", "Début/Liste vide\n");
	subok &= print_test(!TokenList_AjouterToken_EnTete(NULL, jeton), "Liste non créée\n");
	afficherConsole(listejeton->head);
	subok &= print_test(listejeton->head == NULL, "Test liste vide\n");
	subok &= print_test(listejeton->taille == 0, "Taille vaut 0\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	const int couleur_debut_test = 0;
	
	Token_Change(&jeton, couleur_debut_test, 0);
	print_subtitle("TEST", "Ajout d'un jeton %d|%d (1 élément)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 1, "Taille vaut 1\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Liste non vide\n"))
	{
		subok &= print_test(listejeton->tail != NULL && listejeton->head == listejeton->tail, "Vérification de tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next == NULL, "Suivant nul\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor == listejeton->head_color[jeton.color], "Couleur suivante est lui même\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->head_color[jeton.color], "Couleur précédente est lui même\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == listejeton->head_shape[jeton.form], "Forme suivante est lui même\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->head_shape[jeton.form], "Forme précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		subok &= print_test(listejeton->head_color[(jeton.color+1)%NB_COLOR] == NULL, "Non ajout en tete d'une autre liste des couleurs\n");
		afficherConsoleCouleur(listejeton->head_color[(jeton.color+1)%NB_COLOR]);
		subok &= print_test(listejeton->head_shape[(jeton.form+1)%NB_SHAPE] == NULL, "Non ajout en tete d'une autre liste des formes\n");
		afficherConsoleCouleur(listejeton->head_shape[(jeton.form+1)%NB_SHAPE]);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	PlayedToken *ancien = listejeton->head;
	
	print_subtitle("TEST", "Ajout d'un même jeton %d|%d (2 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 2, "Taille vaut 2\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(ancien == listejeton->tail, "L'ancien jeton est devenu tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next == listejeton->tail, "Suivant est tail\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor == listejeton->tail, "Couleur suivante est tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->tail, "Couleur précente est tail\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == listejeton->tail, "Forme suivante est tail\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->tail, "Forme précente est tail\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		subok &= print_test(listejeton->head_color[(jeton.color+1)%NB_COLOR] == NULL, "Non ajout en tete d'une autre liste des couleurs\n");
		afficherConsoleCouleur(listejeton->head_color[(jeton.color+1)%NB_COLOR]);
		subok &= print_test(listejeton->head_shape[(jeton.form+1)%NB_SHAPE] == NULL, "Non ajout en tete d'une autre liste des formes\n");
		afficherConsoleCouleur(listejeton->head_shape[(jeton.form+1)%NB_SHAPE]);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, (jeton.color+1)%NB_COLOR, (jeton.form+1)%NB_SHAPE);
	ancien = listejeton->tail;
	
	print_subtitle("TEST", "Ajout d'un autre jeton %d|%d (3 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 3, "Taille vaut 3\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(ancien == listejeton->tail, "L'ancien jeton est tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor == listejeton->head_color[jeton.color], "Couleur suivante est lui même\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->head_color[jeton.color], "Couleur précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == listejeton->head_shape[jeton.form], "Forme suivante est lui même\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->head_shape[jeton.form], "Forme précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, jeton.color, (jeton.form+1)%NB_SHAPE);
	ancien = listejeton->head;
	
	print_subtitle("TEST", "Ajout d'un autre jeton (modification forme) %d|%d (4 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 4, "Taille vaut 4\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor == ancien, "Couleur suivante est l'ancien jeton\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == ancien, "Couleur précente est l'ancien jeton\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == listejeton->head_shape[jeton.form], "Forme suivante est lui même\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->head_shape[jeton.form], "Forme précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, (jeton.color+1)%NB_COLOR, jeton.form);
	ancien = listejeton->head;
	
	print_subtitle("TEST", "Ajout d'un autre jeton (modification couleur) %d|%d (5 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 5, "Taille vaut 5\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor == listejeton->head_color[jeton.color], "Couleur suivante est lui même\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == ancien, "Forme suivante est l'ancien jeton\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, couleur_debut_test, jeton.form);
	ancien = listejeton->head;
	
	print_subtitle("TEST", "Ajout d'un autre jeton (couleur de debut du test) %d|%d (6 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 6, "Taille vaut 6\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor != listejeton->head_color[jeton.color]->prevColor, "Couleur suivante différente de la précedente\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == ancien, "Forme suivante est l'ancien jeton\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm != ancien && listejeton->head_shape[jeton.form]->prevForm != listejeton->head, "Forme précedente n'est ni l'ancien jeton ni elle même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	while(TokenList_AjouterToken_EnTete(listejeton, jeton));
	ok &= print_test(listejeton->taille == LISTE_LIMITE, "Taille vaut %d\n", listejeton->taille);
	
	TokenList_Free(&listejeton);
	listejeton = NULL;
	
	print_test(ok, "Résultat final\n");
	print_title("TEST_AjoutEnTete", "Fin\n\n");
	return ok;
}

int TEST_AjoutEnFin()
{
	print_title("TEST_AjoutEnFin", "Début:\n");
	int ok = 1;
	int subok = 1;
	Token jeton;
	TokenList *listejeton = TokenList_Create();
	
	print_subtitle("TEST", "Début/Liste vide\n");
	subok &= print_test(!TokenList_AjouterToken_EnFin(NULL, jeton), "Liste non créée\n");
	afficherConsole(listejeton->head);
	subok &= print_test(listejeton->head == NULL, "Test liste vide\n");
	subok &= print_test(listejeton->taille == 0, "Taille vaut 0\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	const int couleur_debut_test = 0;
	
	Token_Change(&jeton, couleur_debut_test, 0);
	print_subtitle("TEST", "Ajout d'un jeton %d|%d (1 élément)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 1, "Taille vaut 1\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Liste non vide\n"))
	{
		subok &= print_test(listejeton->tail != NULL && listejeton->head == listejeton->tail, "Vérification de tail\n");
		subok &= print_test(listejeton->head->jeton.color == jeton.color && listejeton->head->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next == NULL, "Suivant nul\n");
		subok &= print_test(listejeton->head_color[jeton.color] == listejeton->head, "Ajout en tete de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->nextColor == listejeton->head_color[jeton.color], "Couleur suivante est lui même\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->head_color[jeton.color], "Couleur précédente est lui même\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form] == listejeton->head, "Ajout en tete de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->nextForm == listejeton->head_shape[jeton.form], "Forme suivante est lui même\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->head_shape[jeton.form], "Forme précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		subok &= print_test(listejeton->head_color[(jeton.color+1)%NB_COLOR] == NULL, "Non ajout en tete d'une autre liste des couleurs\n");
		afficherConsoleCouleur(listejeton->head_color[(jeton.color+1)%NB_COLOR]);
		subok &= print_test(listejeton->head_shape[(jeton.form+1)%NB_SHAPE] == NULL, "Non ajout en tete d'une autre liste des formes\n");
		afficherConsoleCouleur(listejeton->head_shape[(jeton.form+1)%NB_SHAPE]);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	PlayedToken *ancien = listejeton->head;
	
	print_subtitle("TEST", "Ajout d'un même jeton %d|%d (2 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 2, "Taille vaut 2\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(ancien == listejeton->head, "L'ancien jeton est devenu tail\n");
		subok &= print_test(listejeton->tail->jeton.color == jeton.color && listejeton->tail->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant head non nul\n");
		subok &= print_test(listejeton->head->next == listejeton->tail, "Suivant est tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->tail, "Ajout en fin de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->nextColor == listejeton->head, "Couleur suivante est tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->prevColor == listejeton->head, "Couleur précente est tail\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->tail, "Ajout en fin de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->nextForm == listejeton->head, "Forme suivante est tail\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->prevForm == listejeton->head, "Forme précente est tail\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		subok &= print_test(listejeton->head_color[(jeton.color+1)%NB_COLOR] == NULL, "Non ajout en tete d'une autre liste des couleurs\n");
		afficherConsoleCouleur(listejeton->head_color[(jeton.color+1)%NB_COLOR]);
		subok &= print_test(listejeton->head_shape[(jeton.form+1)%NB_SHAPE] == NULL, "Non ajout en tete d'une autre liste des formes\n");
		afficherConsoleCouleur(listejeton->head_shape[(jeton.form+1)%NB_SHAPE]);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, (jeton.color+1)%NB_COLOR, (jeton.form+1)%NB_SHAPE);
	ancien = listejeton->tail;
	
	print_subtitle("TEST", "Ajout d'un autre jeton %d|%d (3 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 3, "Taille vaut 3\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(ancien->next == listejeton->tail, "ajout après l'ancien\n");
		subok &= print_test(listejeton->tail->jeton.color == jeton.color && listejeton->tail->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant head non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant de head n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->tail, "Ajout en fin de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->nextColor == listejeton->head_color[jeton.color]->prevColor, "Couleur suivante est lui même\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->prevColor == listejeton->head_color[jeton.color]->prevColor, "Couleur précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->tail, "Ajout en fin de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->nextForm == listejeton->head_shape[jeton.form]->prevForm, "Forme suivante est lui même\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->prevForm == listejeton->head_shape[jeton.form]->prevForm, "Forme précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, jeton.color, (jeton.form+1)%NB_SHAPE);
	ancien = listejeton->tail;
	
	print_subtitle("TEST", "Ajout d'un autre jeton (modification forme) %d|%d (4 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 4, "Taille vaut 4\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(listejeton->tail->jeton.color == jeton.color && listejeton->tail->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->tail, "Ajout en fin de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->nextColor == ancien, "Couleur suivante est l'ancien jeton\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->prevColor == ancien, "Couleur précente est l'ancien jeton\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->tail, "Ajout en fin de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->nextForm == listejeton->head_shape[jeton.form], "Forme suivante est lui même\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->prevForm == listejeton->head_shape[jeton.form], "Forme précente est lui même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, (jeton.color+1)%NB_COLOR, jeton.form);
	ancien = listejeton->tail;
	
	print_subtitle("TEST", "Ajout d'un autre jeton (modification couleur) %d|%d (5 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 5, "Taille vaut 5\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(listejeton->tail->jeton.color == jeton.color && listejeton->tail->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->tail, "Ajout en fin de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->nextColor == listejeton->head_color[jeton.color], "Couleur suivante est lui même\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->tail, "Ajout en fin de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->nextForm == ancien, "Forme suivante est l'ancien jeton\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, couleur_debut_test, jeton.form);
	ancien = listejeton->tail;
	
	print_subtitle("TEST", "Ajout d'un autre jeton (couleur de debut du test) %d|%d (6 éléments)\n", jeton.color, jeton.form);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout du jeton %d|%d\n", jeton.color, jeton.form);
	subok &= print_test(listejeton->taille == 6, "Taille vaut 6\n");
	afficherConsole(listejeton->head);
	if(subok &= print_test(listejeton->head != NULL, "Tete non cassée\n"))
	{
		subok &= print_test(listejeton->tail != NULL, "tail non cassée\n");
		subok &= print_test(listejeton->head != listejeton->tail, "head != tail\n");
		subok &= print_test(listejeton->tail->jeton.color == jeton.color && listejeton->tail->jeton.form == jeton.form, "Vérification du jeton ajouté\n");
		subok &= print_test(listejeton->head->next != NULL, "Suivant non nul\n");
		subok &= print_test(listejeton->head->next != listejeton->tail, "Suivant n'est pas tail\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor == listejeton->tail, "Ajout en fin de la liste des couleurs\n");
		subok &= print_test(listejeton->head_color[jeton.color]->prevColor->nextColor != listejeton->head_color[jeton.color]->prevColor, "Couleur suivante différente de la précedente\n");
		afficherConsoleCouleur(listejeton->head_color[jeton.color]);
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm == listejeton->tail, "Ajout en fin de la liste des formes\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->prevForm == ancien, "Forme précente est l'ancien jeton\n");
		subok &= print_test(listejeton->head_shape[jeton.form]->prevForm->nextForm != ancien && listejeton->head_shape[jeton.form]->prevForm->nextForm != listejeton->tail, "Forme suivante n'est ni l'ancien jeton ni elle même\n");
		afficherConsoleCouleur(listejeton->head_shape[jeton.form]);
		afficherFull(listejeton);
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	while(TokenList_AjouterToken_EnFin(listejeton, jeton));
	ok &= print_test(listejeton->taille == LISTE_LIMITE, "Taille vaut %d\n", listejeton->taille);
	
	TokenList_Free(&listejeton);
	listejeton = NULL;
	
	print_test(ok, "Résultat final\n");
	print_title("TEST_AjoutEnFin", "Fin\n\n");
	return ok;
}

int TEST_Retire()
{
	print_title("TEST_Retire", "Début:\n");
	int ok = 1;
	int subok = 1;
	Token jeton;
	TokenList *listejeton = TokenList_Create();
	
	print_subtitle("TEST", "Début/Liste vide\n");
	afficherConsole(listejeton->head);
	subok &= print_test(listejeton->head == NULL, "Test liste vide\n");
	subok &= print_test(listejeton->taille == 0, "Taille vaut 0\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(!TokenList_Remove(NULL, listejeton->head), "Liste non créée\n");
	subok &= print_test(!TokenList_Remove(listejeton, NULL), "PlayedToken non créé\n");
	subok &= print_test(!TokenList_Remove(NULL, NULL), "Liste et PlayedToken non créés\n");
	if(subok &= print_test(listejeton->taille == 1 && listejeton->head != NULL && listejeton->tail != NULL, "Jeton existant\n"))
	{
		subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton\n");
		subok &= print_test(listejeton->head == NULL, "Test liste vide head\n");
		subok &= print_test(listejeton->tail == NULL, "Test liste vide tail\n");
		subok &= print_test(listejeton->taille == 0, "Taille vaut 0\n");
		subok &= print_test(listejeton->head_color[0] == NULL, "Head color est nul\n");
		subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton par la tete\n");
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton\n");
	subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	subok &= print_test(listejeton->head_color[0] == NULL, "Head color est nul\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton par la fin\n");
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton\n");
	subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	subok &= print_test(listejeton->head_color[0] == NULL, "Head color est nul\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un autre jeton similaire\n");
	PlayedToken *ancien = listejeton->head;
	subok &= print_test(listejeton->head->next != NULL, "Suivant de la tete est non nul\n");
	subok &= print_test(listejeton->head->next == listejeton->tail, "Suivant de la tete est tail\n");
	subok &= print_test(TokenList_Remove(listejeton, listejeton->tail), "Suppression du jeton en fin\n");
	subok &= print_test(listejeton->head_color[0]->prevColor == listejeton->head_color[0], "Head prevColor est lui même\n");
	subok &= print_test(listejeton->head_color[0]->nextColor == listejeton->head_color[0], "Head prevColor est lui même\n");
	subok &= print_test(listejeton->head->next == NULL, "Suivant de la tete est nul\n");
	subok &= print_test(listejeton->head == listejeton->tail, "La tete est tail\n");
	subok &= print_test(listejeton->head == ancien, "La tete correspond toujours au même jeton\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_Remove(listejeton, listejeton->tail), "Suppression du jeton en fin\n");
	subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	subok &= print_test(listejeton->head_color[0] == NULL, "Head color est nul\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un autre jeton similaire\n");
	ancien = listejeton->tail;
	subok &= print_test(listejeton->head->next != NULL, "Suivant de la tete est non nul\n");
	subok &= print_test(listejeton->head->next == listejeton->tail, "Suivant de la tete est tail\n");
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton en tete\n");
	subok &= print_test(listejeton->head_color[0]->prevColor == listejeton->head_color[0], "Head prevColor est lui même\n");
	subok &= print_test(listejeton->head_color[0]->nextColor == listejeton->head_color[0], "Head prevColor est lui même\n");
	subok &= print_test(listejeton->head->next == NULL, "Suivant de la tete est nul\n");
	subok &= print_test(listejeton->head == listejeton->tail, "La tete est tail\n");
	subok &= print_test(listejeton->tail == ancien, "tail correspond toujours au même jeton\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton en tete\n");
	subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	subok &= print_test(listejeton->head_color[0] == NULL, "Head color est nul\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un autre jeton différent\n");
	ancien = listejeton->head;
	subok &= print_test(listejeton->head->next != NULL, "Suivant de la tete est non nul\n");
	subok &= print_test(listejeton->head->next == listejeton->tail, "Suivant de la tete est tail\n");
	subok &= print_test(TokenList_Remove(listejeton, listejeton->tail), "Suppression du jeton en fin\n");
	subok &= print_test(listejeton->head_color[1] == NULL, "Head color 1 est nul\n");
	subok &= print_test(listejeton->head_color[0]->prevColor == listejeton->head_color[0], "Head prevColor 0 est lui même\n");
	subok &= print_test(listejeton->head_color[0]->nextColor == listejeton->head_color[0], "Head prevColor 0 est lui même\n");
	subok &= print_test(listejeton->head->next == NULL, "Suivant de la tete est nul\n");
	subok &= print_test(listejeton->head == listejeton->tail, "La tete est tail\n");
	subok &= print_test(listejeton->head == ancien, "La tete correspond toujours au même jeton\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_Remove(listejeton, listejeton->tail), "Suppression du jeton en fin\n");
	subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	subok &= print_test(listejeton->head_color[0] == NULL, "Head color 0 est nul\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un autre jeton différent\n");
	ancien = listejeton->tail;
	subok &= print_test(listejeton->head->next != NULL, "Suivant de la tete est non nul\n");
	subok &= print_test(listejeton->head->next == listejeton->tail, "Suivant de la tete est tail\n");
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton en tete\n");
	subok &= print_test(listejeton->head_color[0] == NULL, "Head color 0 est nul\n");
	subok &= print_test(listejeton->head_color[1]->prevColor == listejeton->head_color[1], "Head prevColor 1 est lui même\n");
	subok &= print_test(listejeton->head_color[1]->nextColor == listejeton->head_color[1], "Head prevColor 1 est lui même\n");
	subok &= print_test(listejeton->head->next == NULL, "Suivant de la tete est nul\n");
	subok &= print_test(listejeton->head == listejeton->tail, "La tete est tail\n");
	subok &= print_test(listejeton->tail == ancien, "tail correspond toujours au même jeton\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression du jeton en tete\n");
	subok &= print_test(listejeton->taille == 0 && listejeton->head == NULL && listejeton->tail == NULL, "liste vide\n");
	subok &= print_test(listejeton->head_color[1] == NULL, "Head color 1 est nul\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 2);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 3);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(listejeton->head_color[1]->nextColor != listejeton->head_color[1]->next, "Liens entre suivant et précédent\n");
	subok &= print_test(listejeton->head_color[0]->nextColor != listejeton->tail && listejeton->tail->nextColor == listejeton->head_color[0], "Suivants couleur\n");
	subok &= print_test(listejeton->head_color[0]->prevColor == listejeton->tail && listejeton->tail->prevColor != listejeton->head_color[0], "Précédents couleur\n");
	subok &= print_test(listejeton->head_shape[2] == listejeton->head_color[0]->nextColor, "Premier de head Forme 2\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head_color[0]->nextColor), "Suppression du jeton au centre\n");
	subok &= print_test(listejeton->head_color[0]->nextColor == listejeton->tail && listejeton->tail->nextColor == listejeton->head_color[0], "Suivants couleur\n");
	subok &= print_test(listejeton->head_color[0]->prevColor == listejeton->tail && listejeton->tail->prevColor == listejeton->head_color[0], "Précédents couleur\n");
	subok &= print_test(listejeton->head_color[1]->nextColor == listejeton->head_color[1]->next, "Liens entre suivant et précédent\n");
	subok &= print_test(listejeton->head_shape[2] == NULL, "Rétiré de head Forme 2\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 3, 1);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(listejeton->head_shape[1]->nextForm != listejeton->head_shape[1]->next, "Liens entre suivant et précédent\n");
	subok &= print_test(listejeton->head_shape[0]->nextForm != listejeton->tail && listejeton->tail->nextForm == listejeton->head_shape[0], "Suivants forme\n");
	subok &= print_test(listejeton->head_shape[0]->prevForm == listejeton->tail && listejeton->tail->prevForm != listejeton->head_shape[0], "Précédents forme\n");
	subok &= print_test(listejeton->head_color[2] == listejeton->head_shape[0]->nextForm, "Premier de head couleur 2\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head_shape[0]->nextForm), "Suppression du jeton au centre\n");
	subok &= print_test(listejeton->head_shape[0]->nextForm == listejeton->tail && listejeton->tail->nextForm == listejeton->head_shape[0], "Suivants forme\n");
	subok &= print_test(listejeton->head_shape[0]->prevForm == listejeton->tail && listejeton->tail->prevForm == listejeton->head_shape[0], "Précédents forme\n");
	subok &= print_test(listejeton->head_shape[1]->nextForm == listejeton->head_shape[1]->next, "Liens entre suivant et précédent\n");
	subok &= print_test(listejeton->head_color[2] == NULL, "Rétiré de head couleur 2\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_Remove(listejeton, listejeton->head), "Suppression en tete\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	while(TokenList_AjouterToken_EnTete(listejeton, jeton));
	subok &= print_test(listejeton->taille == LISTE_LIMITE, "Taille vaut %d\n", listejeton->taille);
	while(TokenList_Remove(listejeton, listejeton->head));
	subok &= print_test(listejeton->taille == 0, "Taille vaut %d\n", listejeton->taille);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	TokenList_Free(&listejeton);
	listejeton = NULL;
	
	print_test(ok, "Résultat final\n");
	print_title("TEST_Retire", "Fin\n\n");
	return ok;
}

int TEST_Rotation()
{
	print_title("TEST_Rotation", "Début:\n");
	int ok = 1;
	int subok = 1;
	Token jeton;
	TokenList *listejeton = TokenList_Create();
	
	print_subtitle("TEST", "Début/Liste vide\n");
	afficherConsole(listejeton->head);
	subok &= print_test(listejeton->head == NULL, "Test liste vide\n");
	subok &= print_test(listejeton->taille == 0, "Taille vaut 0\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	PlayedToken *ancien;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	if(subok &= print_test(listejeton->taille == 1 && listejeton->head != NULL && listejeton->tail != NULL, "Jeton existant\n"))
	{
		ancien = listejeton->head_color[0];
		subok &= print_test(!TokenList_RotateRightByColor(listejeton, listejeton->head_color[1]), "Rotation d'un jeton inexistant\n");
		subok &= print_test(!TokenList_RotateRightByColor(listejeton, listejeton->head_color[0]), "Rotation d'un jeton sur lui même\n");
		subok &= print_test(ancien == listejeton->head_color[0], "Jeton toujours le même\n");
		subok &= print_test(jeton.color == listejeton->head_color[0]->jeton.color && jeton.form == listejeton->head_color[0]->jeton.form, "Toujours les mêmes attributs de jeton\n");
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnTete(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RotateRightByColor(listejeton, listejeton->head_color[0]), "Echange de jetons\n");
	afficherFull(listejeton);
	subok &= print_test(0 == listejeton->head_color[0]->jeton.color && 0 == listejeton->head_color[0]->jeton.form, "Dernier placé en tête\n");
	subok &= print_test(0 == listejeton->head_color[0]->prevColor->jeton.color && 1 == listejeton->head_color[0]->prevColor->jeton.form, "Premier placé en fin\n");
	subok &= print_test(1 == listejeton->head_color[1]->jeton.color && 1 == listejeton->head_color[1]->jeton.form, "Autre non touché\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 3);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RotateRightByColor(listejeton, listejeton->head_color[0]), "Rotation droite de jetons\n");
	afficherFull(listejeton);
	subok &= print_test(listejeton->head_color[0]->jeton.form == 3, "Rotation\n");
	PlayedToken *cur = listejeton->head_color[0];
	int i = 3;
	do
	{
		subok &= print_test(cur->jeton.form == i, "Elément %d == %d\n", cur->jeton.form, i);
		i = (i+1)%4;
		cur = cur->nextColor;
	}while(cur->jeton.form != 3);
	subok &= print_test(TokenList_RotateLeftByColor(listejeton, listejeton->head_color[0]), "Rotation gauche de jetons\n");
	afficherFull(listejeton);
	cur = listejeton->head_color[0];
	i = 0;
	do
	{
		subok &= print_test(cur->jeton.form == i, "Elément %d == %d\n", cur->jeton.form, i);
		i = (i+1)%4;
		cur = cur->nextColor;
	}while(cur->jeton.form != 0);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 3, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RotateRightByForm(listejeton, listejeton->head_shape[0]), "Rotation droite de jetons\n");
	afficherFull(listejeton);
	subok &= print_test(listejeton->head_shape[0]->jeton.color == 3, "Rotation\n");
	cur = listejeton->head_shape[0];
	i = 3;
	do
	{
		subok &= print_test(cur->jeton.color == i, "Elément %d == %d\n", cur->jeton.color, i);
		i = (i+1)%4;
		cur = cur->nextForm;
	}while(cur->jeton.color != 3);
	subok &= print_test(TokenList_RotateLeftByForm(listejeton, listejeton->head_shape[0]), "Rotation gauche de jetons\n");
	afficherFull(listejeton);
	cur = listejeton->head_shape[0];
	i = 0;
	do
	{
		subok &= print_test(cur->jeton.color == i, "Elément %d == %d\n", cur->jeton.color, i);
		i = (i+1)%4;
		cur = cur->nextForm;
	}while(cur->jeton.color != 0);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	TokenList_Free(&listejeton);
	listejeton = NULL;
	
	print_test(ok, "Résultat final\n");
	print_title("TEST_Rotation", "Fin\n\n");
	return ok;
	
}

int TEST_Trio()
{
	print_title("TEST_Trio", "Début:\n");
	int ok = 1;
	int subok = 1;
	Token jeton;
	TokenList *listejeton = TokenList_Create();
	
	print_subtitle("TEST", "Début/Liste vide\n");
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 0, "Retire sur vide\n");
	subok &= print_test(TokenList_RemoveTrio(NULL, NULL) == 0, "Retire sur non créé\n");
	afficherConsole(listejeton->head);
	subok &= print_test(listejeton->head == NULL, "Test liste vide\n");
	subok &= print_test(listejeton->taille == 0, "Taille vaut 0\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 3, "3 mêmes\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 4, "4 mêmes\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 8, "8 mêmes\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 0, "3 différents\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 3, "3 même couleur, différentes formes\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 3, "3 même forme, différentes couleurs\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 0, "3 mêmes séparés\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	TokenList_Remove(listejeton, listejeton->head_color[1]);
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 0, "3 mêmes séparés par 1\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	TokenList_Remove(listejeton, listejeton->head_color[1]);
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 3, "3 mêmes séparés après suppresion du dernier séparateur\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	Token_Change(&jeton, 2, 3);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 3, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 4, "couleur et forme non disjoints\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	Token_Change(&jeton, 2, 3);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 3);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 3, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	subok &= print_test(TokenList_RemoveTrio(listejeton, NULL) == 6, "2 différents en même temps\n");
	afficherFull(listejeton);
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	while(TokenList_Remove(listejeton, listejeton->head));
	
	print_subtitle("ComboLand", "Tout doit disparaitre !\n");
	Token_Change(&jeton, 2, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 0, 0);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 1, 1);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	Token_Change(&jeton, 2, 2);
	subok &= print_test(TokenList_AjouterToken_EnFin(listejeton, jeton), "Ajout d'un jeton\n");
	afficherFull(listejeton);
	int i = 0;
	while(TokenList_RemoveTrio(listejeton, NULL) || i > 10)
	{
		afficherFull(listejeton);
		i ++;
	}
	subok &= print_test(i == 3, "3 tours combos\n");
	subok &= print_test(listejeton->taille == 0, "liste vidée\n");
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	TokenList_Free(&listejeton);
	listejeton = NULL;
	
	print_test(ok, "Résultat final\n");
	print_title("TEST_Trio", "Fin\n\n");
	return ok;
}

int TEST_Annexe()
{
	print_title("TEST_Annexe", "Début:\n");
	int ok = 1;
	int subok = 1;
	int i;
	for(i = 0; i < 40; i ++)
	{
		if(i <= 1)
			subok &= print_test(fibo(i) == i, "fibo(%d) = %d\n", i, fibo(i));
		else
			subok &= print_test(fibo(i) == (fibo(i-1)+fibo(i-2)), "fibo(%d) = %d\n", i, fibo(i));
	}
	ok &= print_test(subok, "Résultat du test\n\n");
	subok = 1;
	
	print_test(ok, "Résultat final\n");
	print_title("TEST_Annexe", "Fin\n\n");
	return ok;
}
